/* A Bison parser, made by GNU Bison 3.7.6.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30706

/* Bison version string.  */
#define YYBISON_VERSION "3.7.6"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 2

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 30 "parser.yy"


#define yyerror Lily_parser::parser_error

/* We use custom location type: Input objects */
#define YYLTYPE Input
#define YYSTYPE SCM
#define YYLLOC_DEFAULT(Current,Rhs,N) \
	((Current).set_location ((Rhs)[1], (Rhs)[N]))

#define YYPRINT(file, type, value)					\
	do {								\
		if (scm_is_eq (value, SCM_UNSPECIFIED))			\
			break;						\
		SCM s = Display::value_to_lily_string (value);		\
		char *p = scm_to_locale_string (s);			\
		fputs (p, file);					\
		free (p);						\
	} while (0)


#define lookup_identifier(x) lookup_identifier_symbol (ly_symbol2scm (x))

#line 101 "parser.yy"
 // -*-Fundamental-*-

/*
FIXME:

   * The rules for who is protecting what are very shady.  Uniformise
     this.

   * There are too many lexical modes?
*/

#include "config.hh"

#include <cctype>
#include <cstdlib>
#include <cstdio>

#include "book.hh"
#include "context.hh"
#include "context-def.hh"
#include "context-mod.hh"
#include "dimensions.hh"
#include "file-path.hh"
#include "input.hh"
#include "international.hh"
#include "lily-guile.hh"
#include "lily-lexer.hh"
#include "lily-parser.hh"
#include "ly-module.hh"
#include "ly-scm-list.hh"
#include "misc.hh"
#include "music.hh"
#include "output-def.hh"
#include "paper-book.hh"
#include "scm-hash.hh"
#include "score.hh"
#include "std-vector.hh"
#include "text-interface.hh"
#include "warn.hh"
#include "lily-imports.hh"

void
Lily_parser::parser_error (Input const *i, Lily_parser *parser, SCM *, const std::string &s)
{
	parser->parser_error (*i, s);
}

// The following are somewhat precarious constructs as they may change
// the value of the lookahead token.  That implies that the lookahead
// token must not yet have made an impact on the state stack other
// than causing the reduction of the current rule, or switching the
// lookahead token while Bison is mulling it over will cause trouble.

#define MYBACKUP(Token, Value, Location)				\
	do {								\
		if (yychar != YYEMPTY)					\
			parser->lexer_->push_extra_token		\
				(yylloc, yychar, yylval);		\
		parser->lexer_->push_extra_token			\
			(Location, Token, Value);			\
		parser->lexer_->push_extra_token (Location, BACKUP);	\
		yychar = YYEMPTY;					\
	} while (0)


#define MYREPARSE(Location, Pred, Token, Value)				\
	do {								\
		if (yychar != YYEMPTY)					\
			parser->lexer_->push_extra_token		\
				(yylloc, yychar, yylval);		\
		parser->lexer_->push_extra_token			\
			(Location, Token, Value);			\
		parser->lexer_->push_extra_token			\
			(Location, REPARSE, Pred);			\
		yychar = YYEMPTY;					\
	} while (0)

#line 181 "parser.yy"


#define MY_MAKE_MUSIC(x, spot) \
	make_music_with_input (ly_symbol2scm (x), \
			       parser->lexer_->override_input (spot))

/* ES TODO:
- delay application of the function
*/

#define LOWLEVEL_MAKE_SYNTAX(location, proc, ...)			\
	with_location							\
		(parser->lexer_->override_input (location).smobbed_copy (), \
		 proc,							\
		 ##__VA_ARGS__)

/* Syntactic Sugar. */
#define MAKE_SYNTAX(name, location, ...)				\
	LOWLEVEL_MAKE_SYNTAX (location, Syntax::name, ##__VA_ARGS__)

#define START_MAKE_SYNTAX(name, ...)					\
	scm_list_n (Syntax::name, ##__VA_ARGS__, SCM_UNDEFINED)

#define FINISH_MAKE_SYNTAX(start, location, ...)			\
	LOWLEVEL_MAKE_SYNTAX						\
		(location,						\
		 Guile_user::apply,					\
		 scm_car (start),					\
		 scm_append_x						\
		 (scm_list_2 (scm_cdr (start),				\
			      scm_list_n (__VA_ARGS__, SCM_UNDEFINED))))

#undef _
#if !HAVE_GETTEXT
#define _(x) x
#else
#include <libintl.h>
#define _(x) gettext (x)
#endif

using std::string;

static Music *make_music_with_input (SCM name, Input where);
bool add_post_events (Music *music, SCM events);
SCM reverse_music_list (Lily_parser *parser, Input loc, SCM lst, bool preserve, bool compress);
SCM check_scheme_arg (Lily_parser *parser, Input loc,
		      SCM arg, SCM args, SCM pred, SCM disp = SCM_UNDEFINED);
SCM make_music_from_simple (Lily_parser *parser, Input loc, SCM pitch);
SCM loc_on_copy (Lily_parser *parser, Input loc, SCM arg);
SCM make_chord_elements (Input loc, SCM pitch, SCM dur, SCM modification_list);
SCM make_chord_step (SCM step, Rational alter);
SCM make_simple_markup (SCM a);
SCM make_duration (SCM t, int dots = 0, SCM factor = SCM_UNDEFINED);
bool is_regular_identifier (SCM id, bool multiple=false);
SCM make_reverse_key_list (SCM keys);
SCM try_word_variants (SCM pred, SCM str);
SCM try_string_variants (SCM pred, SCM str);
SCM post_event_cons (SCM ev, SCM tail);
int yylex (YYSTYPE *s, YYLTYPE *loc, Lily_parser *parser);

// generated code may trigger conversion warnings
#pragma GCC diagnostic ignored "-Wconversion"

// generated code triggers a false positive in GCC 11
// https://gcc.gnu.org/bugzilla/show_bug.cgi?id=98753
#pragma GCC diagnostic ignored "-Wfree-nonheap-object"

// generated code contains some useless casts
#pragma GCC diagnostic ignored "-Wuseless-cast"


#line 245 "./out/parser.cc"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "parser.hh"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of input"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_PREC_BOT = 3,                   /* PREC_BOT  */
  YYSYMBOL_COMPOSITE = 4,                  /* COMPOSITE  */
  YYSYMBOL_5_ = 5,                         /* ':'  */
  YYSYMBOL_6_ = 6,                         /* '^'  */
  YYSYMBOL_7___ = 7,                       /* '_'  */
  YYSYMBOL_8_ = 8,                         /* '!'  */
  YYSYMBOL_9_ = 9,                         /* '\''  */
  YYSYMBOL_10_ = 10,                       /* ','  */
  YYSYMBOL_PREC_TOP = 11,                  /* PREC_TOP  */
  YYSYMBOL_ACCEPTS = 12,                   /* "\\accepts"  */
  YYSYMBOL_ADDLYRICS = 13,                 /* "\\addlyrics"  */
  YYSYMBOL_ALIAS = 14,                     /* "\\alias"  */
  YYSYMBOL_ALTERNATIVE = 15,               /* "\\alternative"  */
  YYSYMBOL_BOOK = 16,                      /* "\\book"  */
  YYSYMBOL_BOOKPART = 17,                  /* "\\bookpart"  */
  YYSYMBOL_CHANGE = 18,                    /* "\\change"  */
  YYSYMBOL_CHORDMODE = 19,                 /* "\\chordmode"  */
  YYSYMBOL_CHORDS = 20,                    /* "\\chords"  */
  YYSYMBOL_CONSISTS = 21,                  /* "\\consists"  */
  YYSYMBOL_CONTEXT = 22,                   /* "\\context"  */
  YYSYMBOL_DEFAULT = 23,                   /* "\\default"  */
  YYSYMBOL_DEFAULTCHILD = 24,              /* "\\defaultchild"  */
  YYSYMBOL_DENIES = 25,                    /* "\\denies"  */
  YYSYMBOL_DESCRIPTION = 26,               /* "\\description"  */
  YYSYMBOL_DRUMMODE = 27,                  /* "\\drummode"  */
  YYSYMBOL_DRUMS = 28,                     /* "\\drums"  */
  YYSYMBOL_ETC = 29,                       /* "\\etc"  */
  YYSYMBOL_FIGUREMODE = 30,                /* "\\figuremode"  */
  YYSYMBOL_FIGURES = 31,                   /* "\\figures"  */
  YYSYMBOL_HEADER = 32,                    /* "\\header"  */
  YYSYMBOL_INVALID = 33,                   /* "\\version-error"  */
  YYSYMBOL_LAYOUT = 34,                    /* "\\layout"  */
  YYSYMBOL_LYRICMODE = 35,                 /* "\\lyricmode"  */
  YYSYMBOL_LYRICS = 36,                    /* "\\lyrics"  */
  YYSYMBOL_LYRICSTO = 37,                  /* "\\lyricsto"  */
  YYSYMBOL_MARKUP = 38,                    /* "\\markup"  */
  YYSYMBOL_MARKUPLIST = 39,                /* "\\markuplist"  */
  YYSYMBOL_MIDI = 40,                      /* "\\midi"  */
  YYSYMBOL_NAME = 41,                      /* "\\name"  */
  YYSYMBOL_NOTEMODE = 42,                  /* "\\notemode"  */
  YYSYMBOL_OVERRIDE = 43,                  /* "\\override"  */
  YYSYMBOL_PAPER = 44,                     /* "\\paper"  */
  YYSYMBOL_REMOVE = 45,                    /* "\\remove"  */
  YYSYMBOL_REPEAT = 46,                    /* "\\repeat"  */
  YYSYMBOL_REST = 47,                      /* "\\rest"  */
  YYSYMBOL_REVERT = 48,                    /* "\\revert"  */
  YYSYMBOL_SCORE = 49,                     /* "\\score"  */
  YYSYMBOL_SCORELINES = 50,                /* "\\score-lines"  */
  YYSYMBOL_SEQUENTIAL = 51,                /* "\\sequential"  */
  YYSYMBOL_SET = 52,                       /* "\\set"  */
  YYSYMBOL_SIMULTANEOUS = 53,              /* "\\simultaneous"  */
  YYSYMBOL_TEMPO = 54,                     /* "\\tempo"  */
  YYSYMBOL_TYPE = 55,                      /* "\\type"  */
  YYSYMBOL_UNSET = 56,                     /* "\\unset"  */
  YYSYMBOL_WITH = 57,                      /* "\\with"  */
  YYSYMBOL_NEWCONTEXT = 58,                /* "\\new"  */
  YYSYMBOL_CHORD_BASS = 59,                /* "/+"  */
  YYSYMBOL_CHORD_CARET = 60,               /* "^"  */
  YYSYMBOL_CHORD_COLON = 61,               /* ":"  */
  YYSYMBOL_CHORD_MINUS = 62,               /* "-"  */
  YYSYMBOL_CHORD_SLASH = 63,               /* "/"  */
  YYSYMBOL_ANGLE_OPEN = 64,                /* "<"  */
  YYSYMBOL_ANGLE_CLOSE = 65,               /* ">"  */
  YYSYMBOL_DOUBLE_ANGLE_OPEN = 66,         /* "<<"  */
  YYSYMBOL_DOUBLE_ANGLE_CLOSE = 67,        /* ">>"  */
  YYSYMBOL_E_BACKSLASH = 68,               /* "\\\\"  */
  YYSYMBOL_E_EXCLAMATION = 69,             /* "\\!"  */
  YYSYMBOL_E_PLUS = 70,                    /* "\\+"  */
  YYSYMBOL_EXTENDER = 71,                  /* "__"  */
  YYSYMBOL_FIGURE_CLOSE = 72,              /* FIGURE_CLOSE  */
  YYSYMBOL_FIGURE_OPEN = 73,               /* FIGURE_OPEN  */
  YYSYMBOL_FIGURE_SPACE = 74,              /* "_"  */
  YYSYMBOL_HYPHEN = 75,                    /* "--"  */
  YYSYMBOL_MULTI_MEASURE_REST = 76,        /* MULTI_MEASURE_REST  */
  YYSYMBOL_E_UNSIGNED = 77,                /* E_UNSIGNED  */
  YYSYMBOL_UNSIGNED = 78,                  /* UNSIGNED  */
  YYSYMBOL_EXPECT_MARKUP = 79,             /* "markup?"  */
  YYSYMBOL_EXPECT_SCM = 80,                /* "scheme?"  */
  YYSYMBOL_BACKUP = 81,                    /* "(backed-up?)"  */
  YYSYMBOL_REPARSE = 82,                   /* "(reparsed?)"  */
  YYSYMBOL_EXPECT_MARKUP_LIST = 83,        /* "markup-list?"  */
  YYSYMBOL_EXPECT_OPTIONAL = 84,           /* "optional?"  */
  YYSYMBOL_EXPECT_NO_MORE_ARGS = 85,       /* EXPECT_NO_MORE_ARGS  */
  YYSYMBOL_EMBEDDED_LILY = 86,             /* "#{"  */
  YYSYMBOL_BOOK_IDENTIFIER = 87,           /* BOOK_IDENTIFIER  */
  YYSYMBOL_CHORD_MODIFIER = 88,            /* CHORD_MODIFIER  */
  YYSYMBOL_CHORD_REPETITION = 89,          /* CHORD_REPETITION  */
  YYSYMBOL_DRUM_PITCH = 90,                /* DRUM_PITCH  */
  YYSYMBOL_DURATION_ARG = 91,              /* DURATION_ARG  */
  YYSYMBOL_DURATION_IDENTIFIER = 92,       /* DURATION_IDENTIFIER  */
  YYSYMBOL_EVENT_IDENTIFIER = 93,          /* EVENT_IDENTIFIER  */
  YYSYMBOL_EVENT_FUNCTION = 94,            /* EVENT_FUNCTION  */
  YYSYMBOL_FRACTION = 95,                  /* FRACTION  */
  YYSYMBOL_LOOKUP_IDENTIFIER = 96,         /* LOOKUP_IDENTIFIER  */
  YYSYMBOL_LYRIC_ELEMENT = 97,             /* LYRIC_ELEMENT  */
  YYSYMBOL_MARKUP_FUNCTION = 98,           /* MARKUP_FUNCTION  */
  YYSYMBOL_MARKUP_LIST_FUNCTION = 99,      /* MARKUP_LIST_FUNCTION  */
  YYSYMBOL_MARKUP_IDENTIFIER = 100,        /* MARKUP_IDENTIFIER  */
  YYSYMBOL_MARKUPLIST_IDENTIFIER = 101,    /* MARKUPLIST_IDENTIFIER  */
  YYSYMBOL_MUSIC_FUNCTION = 102,           /* MUSIC_FUNCTION  */
  YYSYMBOL_MUSIC_IDENTIFIER = 103,         /* MUSIC_IDENTIFIER  */
  YYSYMBOL_NOTENAME_PITCH = 104,           /* NOTENAME_PITCH  */
  YYSYMBOL_NUMBER_IDENTIFIER = 105,        /* NUMBER_IDENTIFIER  */
  YYSYMBOL_PITCH_IDENTIFIER = 106,         /* PITCH_IDENTIFIER  */
  YYSYMBOL_REAL = 107,                     /* REAL  */
  YYSYMBOL_RESTNAME = 108,                 /* RESTNAME  */
  YYSYMBOL_SCM_ARG = 109,                  /* SCM_ARG  */
  YYSYMBOL_SCM_FUNCTION = 110,             /* SCM_FUNCTION  */
  YYSYMBOL_SCM_IDENTIFIER = 111,           /* SCM_IDENTIFIER  */
  YYSYMBOL_SCM_TOKEN = 112,                /* SCM_TOKEN  */
  YYSYMBOL_STRING = 113,                   /* STRING  */
  YYSYMBOL_SYMBOL_LIST = 114,              /* SYMBOL_LIST  */
  YYSYMBOL_TONICNAME_PITCH = 115,          /* TONICNAME_PITCH  */
  YYSYMBOL_SYMBOL = 116,                   /* SYMBOL  */
  YYSYMBOL_117_ = 117,                     /* '-'  */
  YYSYMBOL_118_ = 118,                     /* '+'  */
  YYSYMBOL_UNARY_MINUS = 119,              /* UNARY_MINUS  */
  YYSYMBOL_120_ = 120,                     /* '.'  */
  YYSYMBOL_121_ = 121,                     /* '{'  */
  YYSYMBOL_122_ = 122,                     /* '}'  */
  YYSYMBOL_123_ = 123,                     /* '='  */
  YYSYMBOL_124_ = 124,                     /* '*'  */
  YYSYMBOL_125_ = 125,                     /* ']'  */
  YYSYMBOL_126_ = 126,                     /* '/'  */
  YYSYMBOL_127_ = 127,                     /* '['  */
  YYSYMBOL_128_ = 128,                     /* '?'  */
  YYSYMBOL_YYACCEPT = 129,                 /* $accept  */
  YYSYMBOL_start_symbol = 130,             /* start_symbol  */
  YYSYMBOL_131_1 = 131,                    /* $@1  */
  YYSYMBOL_lilypond = 132,                 /* lilypond  */
  YYSYMBOL_toplevel_expression = 133,      /* toplevel_expression  */
  YYSYMBOL_lookup = 134,                   /* lookup  */
  YYSYMBOL_embedded_scm_bare = 135,        /* embedded_scm_bare  */
  YYSYMBOL_embedded_scm_active = 136,      /* embedded_scm_active  */
  YYSYMBOL_embedded_scm_bare_arg = 137,    /* embedded_scm_bare_arg  */
  YYSYMBOL_embedded_scm = 138,             /* embedded_scm  */
  YYSYMBOL_embedded_scm_arg = 139,         /* embedded_scm_arg  */
  YYSYMBOL_scm_function_call = 140,        /* scm_function_call  */
  YYSYMBOL_embedded_lilypond_number = 141, /* embedded_lilypond_number  */
  YYSYMBOL_embedded_lilypond = 142,        /* embedded_lilypond  */
  YYSYMBOL_lilypond_header_body = 143,     /* lilypond_header_body  */
  YYSYMBOL_lilypond_header = 144,          /* lilypond_header  */
  YYSYMBOL_header_block = 145,             /* header_block  */
  YYSYMBOL_146_2 = 146,                    /* $@2  */
  YYSYMBOL_assignment_id = 147,            /* assignment_id  */
  YYSYMBOL_assignment = 148,               /* assignment  */
  YYSYMBOL_identifier_init = 149,          /* identifier_init  */
  YYSYMBOL_identifier_init_nonumber = 150, /* identifier_init_nonumber  */
  YYSYMBOL_partial_function_scriptable = 151, /* partial_function_scriptable  */
  YYSYMBOL_partial_function = 152,         /* partial_function  */
  YYSYMBOL_context_def_spec_block = 153,   /* context_def_spec_block  */
  YYSYMBOL_context_mod_arg = 154,          /* context_mod_arg  */
  YYSYMBOL_155_3 = 155,                    /* $@3  */
  YYSYMBOL_context_def_spec_body = 156,    /* context_def_spec_body  */
  YYSYMBOL_book_block = 157,               /* book_block  */
  YYSYMBOL_book_body = 158,                /* book_body  */
  YYSYMBOL_159_4 = 159,                    /* $@4  */
  YYSYMBOL_bookpart_block = 160,           /* bookpart_block  */
  YYSYMBOL_bookpart_body = 161,            /* bookpart_body  */
  YYSYMBOL_162_5 = 162,                    /* $@5  */
  YYSYMBOL_score_block = 163,              /* score_block  */
  YYSYMBOL_score_body = 164,               /* score_body  */
  YYSYMBOL_score_item = 165,               /* score_item  */
  YYSYMBOL_score_items = 166,              /* score_items  */
  YYSYMBOL_167_6 = 167,                    /* $@6  */
  YYSYMBOL_paper_block = 168,              /* paper_block  */
  YYSYMBOL_output_def = 169,               /* output_def  */
  YYSYMBOL_output_def_head = 170,          /* output_def_head  */
  YYSYMBOL_output_def_head_with_mode_switch = 171, /* output_def_head_with_mode_switch  */
  YYSYMBOL_music_or_context_def = 172,     /* music_or_context_def  */
  YYSYMBOL_output_def_body = 173,          /* output_def_body  */
  YYSYMBOL_174_7 = 174,                    /* $@7  */
  YYSYMBOL_tempo_event = 175,              /* tempo_event  */
  YYSYMBOL_music_list = 176,               /* music_list  */
  YYSYMBOL_braced_music_list = 177,        /* braced_music_list  */
  YYSYMBOL_music = 178,                    /* music  */
  YYSYMBOL_pitch_as_music = 179,           /* pitch_as_music  */
  YYSYMBOL_music_embedded = 180,           /* music_embedded  */
  YYSYMBOL_music_embedded_backup = 181,    /* music_embedded_backup  */
  YYSYMBOL_music_assign = 182,             /* music_assign  */
  YYSYMBOL_repeated_music = 183,           /* repeated_music  */
  YYSYMBOL_sequential_alternative_music = 184, /* sequential_alternative_music  */
  YYSYMBOL_sequential_music = 185,         /* sequential_music  */
  YYSYMBOL_simultaneous_music = 186,       /* simultaneous_music  */
  YYSYMBOL_simple_music = 187,             /* simple_music  */
  YYSYMBOL_context_modification = 188,     /* context_modification  */
  YYSYMBOL_189_8 = 189,                    /* $@8  */
  YYSYMBOL_context_modification_arg = 190, /* context_modification_arg  */
  YYSYMBOL_optional_context_mods = 191,    /* optional_context_mods  */
  YYSYMBOL_context_modification_mods_list = 192, /* context_modification_mods_list  */
  YYSYMBOL_context_mod_list = 193,         /* context_mod_list  */
  YYSYMBOL_context_prefix = 194,           /* context_prefix  */
  YYSYMBOL_new_lyrics = 195,               /* new_lyrics  */
  YYSYMBOL_basic_music = 196,              /* basic_music  */
  YYSYMBOL_contextable_music = 197,        /* contextable_music  */
  YYSYMBOL_contexted_basic_music = 198,    /* contexted_basic_music  */
  YYSYMBOL_composite_music = 199,          /* composite_music  */
  YYSYMBOL_music_bare = 200,               /* music_bare  */
  YYSYMBOL_grouped_music_list = 201,       /* grouped_music_list  */
  YYSYMBOL_symbol_list_arg = 202,          /* symbol_list_arg  */
  YYSYMBOL_symbol_list_rev = 203,          /* symbol_list_rev  */
  YYSYMBOL_symbol_list_part = 204,         /* symbol_list_part  */
  YYSYMBOL_symbol_list_element = 205,      /* symbol_list_element  */
  YYSYMBOL_symbol_list_part_bare = 206,    /* symbol_list_part_bare  */
  YYSYMBOL_function_arglist_nonbackup = 207, /* function_arglist_nonbackup  */
  YYSYMBOL_reparsed_rhythm = 208,          /* reparsed_rhythm  */
  YYSYMBOL_function_arglist_nonbackup_reparse = 209, /* function_arglist_nonbackup_reparse  */
  YYSYMBOL_function_arglist_backup = 210,  /* function_arglist_backup  */
  YYSYMBOL_function_arglist = 211,         /* function_arglist  */
  YYSYMBOL_function_arglist_skip_nonbackup = 212, /* function_arglist_skip_nonbackup  */
  YYSYMBOL_function_arglist_partial = 213, /* function_arglist_partial  */
  YYSYMBOL_function_arglist_partial_optional = 214, /* function_arglist_partial_optional  */
  YYSYMBOL_function_arglist_common = 215,  /* function_arglist_common  */
  YYSYMBOL_function_arglist_common_reparse = 216, /* function_arglist_common_reparse  */
  YYSYMBOL_function_arglist_optional = 217, /* function_arglist_optional  */
  YYSYMBOL_function_arglist_skip_backup = 218, /* function_arglist_skip_backup  */
  YYSYMBOL_music_function_call = 219,      /* music_function_call  */
  YYSYMBOL_optional_id = 220,              /* optional_id  */
  YYSYMBOL_lyric_mode_music = 221,         /* lyric_mode_music  */
  YYSYMBOL_222_9 = 222,                    /* $@9  */
  YYSYMBOL_mode_changed_music = 223,       /* mode_changed_music  */
  YYSYMBOL_mode_changing_head = 224,       /* mode_changing_head  */
  YYSYMBOL_mode_changing_head_with_context = 225, /* mode_changing_head_with_context  */
  YYSYMBOL_context_change = 226,           /* context_change  */
  YYSYMBOL_property_path = 227,            /* property_path  */
  YYSYMBOL_property_operation = 228,       /* property_operation  */
  YYSYMBOL_revert_arg = 229,               /* revert_arg  */
  YYSYMBOL_revert_arg_backup = 230,        /* revert_arg_backup  */
  YYSYMBOL_revert_arg_part = 231,          /* revert_arg_part  */
  YYSYMBOL_context_def_mod = 232,          /* context_def_mod  */
  YYSYMBOL_context_mod = 233,              /* context_mod  */
  YYSYMBOL_grob_prop_spec = 234,           /* grob_prop_spec  */
  YYSYMBOL_grob_prop_path = 235,           /* grob_prop_path  */
  YYSYMBOL_context_prop_spec = 236,        /* context_prop_spec  */
  YYSYMBOL_simple_revert_context = 237,    /* simple_revert_context  */
  YYSYMBOL_music_property_def = 238,       /* music_property_def  */
  YYSYMBOL_string = 239,                   /* string  */
  YYSYMBOL_text = 240,                     /* text  */
  YYSYMBOL_simple_string = 241,            /* simple_string  */
  YYSYMBOL_symbol = 242,                   /* symbol  */
  YYSYMBOL_scalar = 243,                   /* scalar  */
  YYSYMBOL_event_chord = 244,              /* event_chord  */
  YYSYMBOL_note_chord_element = 245,       /* note_chord_element  */
  YYSYMBOL_chord_body = 246,               /* chord_body  */
  YYSYMBOL_chord_body_elements = 247,      /* chord_body_elements  */
  YYSYMBOL_chord_body_element = 248,       /* chord_body_element  */
  YYSYMBOL_music_function_chord_body = 249, /* music_function_chord_body  */
  YYSYMBOL_event_function_event = 250,     /* event_function_event  */
  YYSYMBOL_post_events = 251,              /* post_events  */
  YYSYMBOL_post_event_nofinger = 252,      /* post_event_nofinger  */
  YYSYMBOL_post_event = 253,               /* post_event  */
  YYSYMBOL_string_number_event = 254,      /* string_number_event  */
  YYSYMBOL_direction_less_event = 255,     /* direction_less_event  */
  YYSYMBOL_direction_reqd_event = 256,     /* direction_reqd_event  */
  YYSYMBOL_octave_check = 257,             /* octave_check  */
  YYSYMBOL_quotes = 258,                   /* quotes  */
  YYSYMBOL_erroneous_quotes = 259,         /* erroneous_quotes  */
  YYSYMBOL_sup_quotes = 260,               /* sup_quotes  */
  YYSYMBOL_sub_quotes = 261,               /* sub_quotes  */
  YYSYMBOL_steno_pitch = 262,              /* steno_pitch  */
  YYSYMBOL_steno_tonic_pitch = 263,        /* steno_tonic_pitch  */
  YYSYMBOL_pitch = 264,                    /* pitch  */
  YYSYMBOL_pitch_or_tonic_pitch = 265,     /* pitch_or_tonic_pitch  */
  YYSYMBOL_gen_text_def = 266,             /* gen_text_def  */
  YYSYMBOL_fingering = 267,                /* fingering  */
  YYSYMBOL_script_abbreviation = 268,      /* script_abbreviation  */
  YYSYMBOL_script_dir = 269,               /* script_dir  */
  YYSYMBOL_maybe_notemode_duration = 270,  /* maybe_notemode_duration  */
  YYSYMBOL_optional_notemode_duration = 271, /* optional_notemode_duration  */
  YYSYMBOL_steno_duration = 272,           /* steno_duration  */
  YYSYMBOL_duration = 273,                 /* duration  */
  YYSYMBOL_dots = 274,                     /* dots  */
  YYSYMBOL_multiplier_scm = 275,           /* multiplier_scm  */
  YYSYMBOL_multipliers = 276,              /* multipliers  */
  YYSYMBOL_tremolo_type = 277,             /* tremolo_type  */
  YYSYMBOL_bass_number = 278,              /* bass_number  */
  YYSYMBOL_figured_bass_alteration = 279,  /* figured_bass_alteration  */
  YYSYMBOL_bass_figure = 280,              /* bass_figure  */
  YYSYMBOL_figured_bass_modification = 281, /* figured_bass_modification  */
  YYSYMBOL_br_bass_figure = 282,           /* br_bass_figure  */
  YYSYMBOL_figure_list = 283,              /* figure_list  */
  YYSYMBOL_optional_rest = 284,            /* optional_rest  */
  YYSYMBOL_pitch_or_music = 285,           /* pitch_or_music  */
  YYSYMBOL_simple_element = 286,           /* simple_element  */
  YYSYMBOL_lyric_element = 287,            /* lyric_element  */
  YYSYMBOL_lyric_element_music = 288,      /* lyric_element_music  */
  YYSYMBOL_new_chord = 289,                /* new_chord  */
  YYSYMBOL_chord_items = 290,              /* chord_items  */
  YYSYMBOL_chord_separator = 291,          /* chord_separator  */
  YYSYMBOL_chord_item = 292,               /* chord_item  */
  YYSYMBOL_step_numbers = 293,             /* step_numbers  */
  YYSYMBOL_step_number = 294,              /* step_number  */
  YYSYMBOL_tempo_range = 295,              /* tempo_range  */
  YYSYMBOL_number_expression = 296,        /* number_expression  */
  YYSYMBOL_number_term = 297,              /* number_term  */
  YYSYMBOL_number_factor = 298,            /* number_factor  */
  YYSYMBOL_bare_number_common = 299,       /* bare_number_common  */
  YYSYMBOL_bare_number = 300,              /* bare_number  */
  YYSYMBOL_unsigned_number = 301,          /* unsigned_number  */
  YYSYMBOL_exclamations = 302,             /* exclamations  */
  YYSYMBOL_questions = 303,                /* questions  */
  YYSYMBOL_full_markup_list = 304,         /* full_markup_list  */
  YYSYMBOL_305_10 = 305,                   /* $@10  */
  YYSYMBOL_markup_mode = 306,              /* markup_mode  */
  YYSYMBOL_markup_mode_word = 307,         /* markup_mode_word  */
  YYSYMBOL_full_markup = 308,              /* full_markup  */
  YYSYMBOL_partial_markup = 309,           /* partial_markup  */
  YYSYMBOL_markup_top = 310,               /* markup_top  */
  YYSYMBOL_markup_scm = 311,               /* markup_scm  */
  YYSYMBOL_312_11 = 312,                   /* $@11  */
  YYSYMBOL_markup_list = 313,              /* markup_list  */
  YYSYMBOL_markup_uncomposed_list = 314,   /* markup_uncomposed_list  */
  YYSYMBOL_315_12 = 315,                   /* $@12  */
  YYSYMBOL_markup_composed_list = 316,     /* markup_composed_list  */
  YYSYMBOL_markup_braced_list = 317,       /* markup_braced_list  */
  YYSYMBOL_markup_braced_list_body = 318,  /* markup_braced_list_body  */
  YYSYMBOL_markup_command_list = 319,      /* markup_command_list  */
  YYSYMBOL_markup_command_embedded_lilypond = 320, /* markup_command_embedded_lilypond  */
  YYSYMBOL_321_13 = 321,                   /* $@13  */
  YYSYMBOL_markup_command_basic_arguments = 322, /* markup_command_basic_arguments  */
  YYSYMBOL_markup_command_list_arguments = 323, /* markup_command_list_arguments  */
  YYSYMBOL_markup_partial_function = 324,  /* markup_partial_function  */
  YYSYMBOL_markup_arglist_partial = 325,   /* markup_arglist_partial  */
  YYSYMBOL_markup_head_1_item = 326,       /* markup_head_1_item  */
  YYSYMBOL_markup_head_1_list = 327,       /* markup_head_1_list  */
  YYSYMBOL_markup_word = 328,              /* markup_word  */
  YYSYMBOL_simple_markup = 329,            /* simple_markup  */
  YYSYMBOL_simple_markup_noword = 330,     /* simple_markup_noword  */
  YYSYMBOL_331_14 = 331,                   /* $@14  */
  YYSYMBOL_markup = 332                    /* markup  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if 1

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* 1 */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE) \
             + YYSIZEOF (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  5
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   4678

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  129
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  204
/* YYNRULES -- Number of rules.  */
#define YYNRULES  609
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  897

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   366


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     8,     2,     2,     2,     2,     2,     9,
       2,     2,   124,   118,    10,   117,   120,   126,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     5,     2,
       2,   123,     2,   128,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   127,     2,   125,     6,     7,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   121,     2,   122,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   119
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   398,   398,   399,   399,   407,   408,   410,   412,   415,
     422,   425,   429,   433,   441,   445,   449,   453,   457,   461,
     496,   512,   513,   521,   525,   529,   530,   531,   535,   536,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   556,   557,   558,   571,   572,   573,   577,   584,   588,
     589,   597,   604,   605,   606,   611,   623,   641,   645,   653,
     654,   657,   661,   670,   676,   676,   687,   691,   698,   702,
     707,   722,   723,   724,   728,   732,   748,   749,   750,   751,
     752,   753,   754,   755,   756,   757,   758,   759,   760,   761,
     762,   772,   776,   780,   784,   788,   792,   796,   800,   804,
     811,   812,   822,   832,   842,   853,   863,   869,   878,   891,
     893,   893,   905,   908,   918,   929,   957,   969,   979,   982,
     986,   990,   994,   998,  1002,  1006,  1010,  1039,  1038,  1042,
    1051,  1059,  1064,  1067,  1070,  1074,  1078,  1082,  1086,  1090,
    1120,  1119,  1126,  1134,  1141,  1158,  1164,  1165,  1166,  1171,
    1174,  1234,  1233,  1256,  1269,  1279,  1285,  1290,  1299,  1311,
    1312,  1316,  1323,  1327,  1355,  1362,  1361,  1378,  1384,  1387,
    1390,  1399,  1402,  1406,  1416,  1422,  1423,  1424,  1428,  1440,
    1441,  1442,  1446,  1450,  1465,  1483,  1484,  1488,  1492,  1499,
    1503,  1507,  1510,  1513,  1519,  1522,  1530,  1531,  1532,  1537,
    1536,  1544,  1563,  1564,  1572,  1586,  1589,  1602,  1605,  1609,
    1623,  1626,  1632,  1635,  1657,  1658,  1659,  1660,  1663,  1670,
    1671,  1672,  1676,  1683,  1687,  1694,  1695,  1696,  1703,  1704,
    1705,  1709,  1710,  1767,  1768,  1772,  1779,  1780,  1784,  1793,
    1794,  1806,  1810,  1815,  1824,  1831,  1832,  1836,  1848,  1854,
    1860,  1870,  1874,  1884,  1888,  1892,  1896,  1900,  1904,  1912,
    1926,  1943,  1954,  1965,  1982,  1999,  2012,  2035,  2053,  2054,
    2069,  2079,  2095,  2111,  2120,  2147,  2158,  2168,  2187,  2198,
    2208,  2222,  2237,  2252,  2267,  2277,  2282,  2287,  2292,  2299,
    2300,  2307,  2308,  2327,  2331,  2335,  2339,  2346,  2350,  2354,
    2358,  2365,  2368,  2378,  2383,  2388,  2393,  2398,  2403,  2413,
    2418,  2423,  2428,  2435,  2453,  2464,  2475,  2493,  2511,  2525,
    2548,  2560,  2576,  2585,  2586,  2590,  2594,  2595,  2602,  2610,
    2611,  2623,  2623,  2630,  2634,  2645,  2656,  2661,  2666,  2671,
    2678,  2685,  2689,  2694,  2700,  2707,  2714,  2720,  2723,  2726,
    2737,  2766,  2773,  2785,  2786,  2790,  2794,  2801,  2802,  2804,
    2805,  2806,  2808,  2809,  2810,  2811,  2815,  2816,  2819,  2822,
    2840,  2858,  2866,  2881,  2913,  2931,  2940,  2943,  2952,  2963,
    2964,  2965,  2969,  2970,  2971,  2972,  2983,  2984,  2985,  2997,
    3000,  3006,  3022,  3023,  3024,  3025,  3033,  3037,  3038,  3042,
    3049,  3056,  3060,  3064,  3065,  3070,  3088,  3094,  3101,  3102,
    3109,  3135,  3145,  3161,  3165,  3166,  3167,  3171,  3178,  3181,
    3187,  3190,  3202,  3207,  3212,  3222,  3229,  3236,  3246,  3247,
    3254,  3262,  3263,  3266,  3271,  3275,  3278,  3300,  3301,  3306,
    3309,  3310,  3315,  3322,  3325,  3331,  3334,  3340,  3355,  3366,
    3367,  3378,  3379,  3383,  3388,  3394,  3401,  3409,  3417,  3420,
    3423,  3426,  3429,  3432,  3435,  3441,  3442,  3443,  3447,  3450,
    3458,  3466,  3474,  3480,  3486,  3489,  3495,  3496,  3501,  3504,
    3511,  3519,  3532,  3535,  3547,  3548,  3549,  3550,  3551,  3566,
    3567,  3568,  3572,  3576,  3587,  3591,  3602,  3610,  3613,  3616,
    3619,  3625,  3628,  3635,  3638,  3644,  3645,  3653,  3712,  3732,
    3739,  3755,  3760,  3765,  3770,  3774,  3784,  3790,  3797,  3800,
    3806,  3809,  3812,  3815,  3821,  3824,  3827,  3833,  3834,  3840,
    3843,  3846,  3852,  3855,  3867,  3870,  3873,  3877,  3880,  3883,
    3889,  3892,  3896,  3897,  3898,  3905,  3906,  3907,  3913,  3914,
    3923,  3935,  3936,  3952,  3953,  3964,  3963,  3972,  3988,  3997,
    4001,  4008,  4016,  4019,  4024,  4031,  4030,  4045,  4048,  4052,
    4055,  4058,  4062,  4062,  4078,  4085,  4091,  4092,  4095,  4101,
    4107,  4107,  4117,  4120,  4123,  4127,  4130,  4133,  4136,  4142,
    4143,  4149,  4153,  4161,  4165,  4169,  4173,  4180,  4186,  4189,
    4195,  4196,  4200,  4204,  4208,  4208,  4221,  4224,  4231,  4236
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if 1
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of input\"", "error", "\"invalid token\"", "PREC_BOT",
  "COMPOSITE", "':'", "'^'", "'_'", "'!'", "'\\''", "','", "PREC_TOP",
  "\"\\\\accepts\"", "\"\\\\addlyrics\"", "\"\\\\alias\"",
  "\"\\\\alternative\"", "\"\\\\book\"", "\"\\\\bookpart\"",
  "\"\\\\change\"", "\"\\\\chordmode\"", "\"\\\\chords\"",
  "\"\\\\consists\"", "\"\\\\context\"", "\"\\\\default\"",
  "\"\\\\defaultchild\"", "\"\\\\denies\"", "\"\\\\description\"",
  "\"\\\\drummode\"", "\"\\\\drums\"", "\"\\\\etc\"", "\"\\\\figuremode\"",
  "\"\\\\figures\"", "\"\\\\header\"", "\"\\\\version-error\"",
  "\"\\\\layout\"", "\"\\\\lyricmode\"", "\"\\\\lyrics\"",
  "\"\\\\lyricsto\"", "\"\\\\markup\"", "\"\\\\markuplist\"",
  "\"\\\\midi\"", "\"\\\\name\"", "\"\\\\notemode\"", "\"\\\\override\"",
  "\"\\\\paper\"", "\"\\\\remove\"", "\"\\\\repeat\"", "\"\\\\rest\"",
  "\"\\\\revert\"", "\"\\\\score\"", "\"\\\\score-lines\"",
  "\"\\\\sequential\"", "\"\\\\set\"", "\"\\\\simultaneous\"",
  "\"\\\\tempo\"", "\"\\\\type\"", "\"\\\\unset\"", "\"\\\\with\"",
  "\"\\\\new\"", "\"/+\"", "\"^\"", "\":\"", "\"-\"", "\"/\"", "\"<\"",
  "\">\"", "\"<<\"", "\">>\"", "\"\\\\\\\\\"", "\"\\\\!\"", "\"\\\\+\"",
  "\"__\"", "FIGURE_CLOSE", "FIGURE_OPEN", "\"_\"", "\"--\"",
  "MULTI_MEASURE_REST", "E_UNSIGNED", "UNSIGNED", "\"markup?\"",
  "\"scheme?\"", "\"(backed-up?)\"", "\"(reparsed?)\"", "\"markup-list?\"",
  "\"optional?\"", "EXPECT_NO_MORE_ARGS", "\"#{\"", "BOOK_IDENTIFIER",
  "CHORD_MODIFIER", "CHORD_REPETITION", "DRUM_PITCH", "DURATION_ARG",
  "DURATION_IDENTIFIER", "EVENT_IDENTIFIER", "EVENT_FUNCTION", "FRACTION",
  "LOOKUP_IDENTIFIER", "LYRIC_ELEMENT", "MARKUP_FUNCTION",
  "MARKUP_LIST_FUNCTION", "MARKUP_IDENTIFIER", "MARKUPLIST_IDENTIFIER",
  "MUSIC_FUNCTION", "MUSIC_IDENTIFIER", "NOTENAME_PITCH",
  "NUMBER_IDENTIFIER", "PITCH_IDENTIFIER", "REAL", "RESTNAME", "SCM_ARG",
  "SCM_FUNCTION", "SCM_IDENTIFIER", "SCM_TOKEN", "STRING", "SYMBOL_LIST",
  "TONICNAME_PITCH", "SYMBOL", "'-'", "'+'", "UNARY_MINUS", "'.'", "'{'",
  "'}'", "'='", "'*'", "']'", "'/'", "'['", "'?'", "$accept",
  "start_symbol", "$@1", "lilypond", "toplevel_expression", "lookup",
  "embedded_scm_bare", "embedded_scm_active", "embedded_scm_bare_arg",
  "embedded_scm", "embedded_scm_arg", "scm_function_call",
  "embedded_lilypond_number", "embedded_lilypond", "lilypond_header_body",
  "lilypond_header", "header_block", "$@2", "assignment_id", "assignment",
  "identifier_init", "identifier_init_nonumber",
  "partial_function_scriptable", "partial_function",
  "context_def_spec_block", "context_mod_arg", "$@3",
  "context_def_spec_body", "book_block", "book_body", "$@4",
  "bookpart_block", "bookpart_body", "$@5", "score_block", "score_body",
  "score_item", "score_items", "$@6", "paper_block", "output_def",
  "output_def_head", "output_def_head_with_mode_switch",
  "music_or_context_def", "output_def_body", "$@7", "tempo_event",
  "music_list", "braced_music_list", "music", "pitch_as_music",
  "music_embedded", "music_embedded_backup", "music_assign",
  "repeated_music", "sequential_alternative_music", "sequential_music",
  "simultaneous_music", "simple_music", "context_modification", "$@8",
  "context_modification_arg", "optional_context_mods",
  "context_modification_mods_list", "context_mod_list", "context_prefix",
  "new_lyrics", "basic_music", "contextable_music",
  "contexted_basic_music", "composite_music", "music_bare",
  "grouped_music_list", "symbol_list_arg", "symbol_list_rev",
  "symbol_list_part", "symbol_list_element", "symbol_list_part_bare",
  "function_arglist_nonbackup", "reparsed_rhythm",
  "function_arglist_nonbackup_reparse", "function_arglist_backup",
  "function_arglist", "function_arglist_skip_nonbackup",
  "function_arglist_partial", "function_arglist_partial_optional",
  "function_arglist_common", "function_arglist_common_reparse",
  "function_arglist_optional", "function_arglist_skip_backup",
  "music_function_call", "optional_id", "lyric_mode_music", "$@9",
  "mode_changed_music", "mode_changing_head",
  "mode_changing_head_with_context", "context_change", "property_path",
  "property_operation", "revert_arg", "revert_arg_backup",
  "revert_arg_part", "context_def_mod", "context_mod", "grob_prop_spec",
  "grob_prop_path", "context_prop_spec", "simple_revert_context",
  "music_property_def", "string", "text", "simple_string", "symbol",
  "scalar", "event_chord", "note_chord_element", "chord_body",
  "chord_body_elements", "chord_body_element", "music_function_chord_body",
  "event_function_event", "post_events", "post_event_nofinger",
  "post_event", "string_number_event", "direction_less_event",
  "direction_reqd_event", "octave_check", "quotes", "erroneous_quotes",
  "sup_quotes", "sub_quotes", "steno_pitch", "steno_tonic_pitch", "pitch",
  "pitch_or_tonic_pitch", "gen_text_def", "fingering",
  "script_abbreviation", "script_dir", "maybe_notemode_duration",
  "optional_notemode_duration", "steno_duration", "duration", "dots",
  "multiplier_scm", "multipliers", "tremolo_type", "bass_number",
  "figured_bass_alteration", "bass_figure", "figured_bass_modification",
  "br_bass_figure", "figure_list", "optional_rest", "pitch_or_music",
  "simple_element", "lyric_element", "lyric_element_music", "new_chord",
  "chord_items", "chord_separator", "chord_item", "step_numbers",
  "step_number", "tempo_range", "number_expression", "number_term",
  "number_factor", "bare_number_common", "bare_number", "unsigned_number",
  "exclamations", "questions", "full_markup_list", "$@10", "markup_mode",
  "markup_mode_word", "full_markup", "partial_markup", "markup_top",
  "markup_scm", "$@11", "markup_list", "markup_uncomposed_list", "$@12",
  "markup_composed_list", "markup_braced_list", "markup_braced_list_body",
  "markup_command_list", "markup_command_embedded_lilypond", "$@13",
  "markup_command_basic_arguments", "markup_command_list_arguments",
  "markup_partial_function", "markup_arglist_partial",
  "markup_head_1_item", "markup_head_1_list", "markup_word",
  "simple_markup", "simple_markup_noword", "$@14", "markup", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,   258,   259,    58,    94,    95,    33,    39,
      44,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,    45,    43,   366,
      46,   123,   125,    61,    42,    93,    47,    91,    63
};
#endif

#define YYPACT_NINF (-604)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-596)

#define yytable_value_is_error(Yyn) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
      84,  -604,   181,  1930,  1586,  -604,  -604,    55,   -14,    67,
    -604,  -604,   637,  -604,  -604,  -604,  -604,  -604,  -604,  -604,
    -604,   757,  -604,  -604,  -604,  -604,  -604,   933,    74,    80,
      80,   637,  -604,  -604,    88,   242,  -604,   242,  -604,  -604,
    -604,  -604,  -604,  -604,  -604,  -604,  -604,  -604,   143,   196,
    -604,  -604,  -604,  -604,  -604,  -604,   173,  1104,  -604,  -604,
    -604,  -604,  -604,  4465,   260,  -604,  -604,  -604,  -604,  -604,
    -604,   331,  -604,  -604,  1381,   154,  -604,  -604,   224,   229,
     229,   637,   530,  1350,   337,   337,   337,   512,   337,   789,
    -604,  -604,  -604,  -604,    45,  -604,   220,    45,    45,  -604,
    -604,   263,  -604,  -604,   377,   385,  -604,   385,   226,    45,
     393,  -604,  -604,    91,   385,    99,    93,  -604,  -604,   120,
    -604,  -604,  -604,  -604,  -604,  -604,   307,  -604,  -604,  -604,
    -604,  -604,  -604,  -604,  -604,  3532,   270,   125,  -604,  -604,
    -604,  -604,  -604,  -604,  -604,  -604,    45,  -604,  -604,   133,
    -604,  -604,  -604,    45,  -604,  1196,  -604,  -604,  -604,   156,
    -604,    45,  -604,  -604,  -604,  -604,  3786,  -604,   165,  -604,
    -604,  -604,   267,   272,  -604,  -604,  -604,   243,   246,   258,
     264,   310,   293,   983,  -604,  -604,  -604,   702,  -604,  -604,
    -604,   243,  2176,   337,   460,   340,  -604,  -604,   341,  -604,
    -604,   345,  -604,  1812,   314,  -604,   337,  3419,  -604,  -604,
    -604,  -604,  -604,  -604,  4401,   198,   154,  -604,  -604,   260,
    -604,  -604,  -604,  -604,   418,  -604,   331,   389,  -604,  -604,
     747,   939,  -604,  -604,  -604,  -604,  -604,   343,  -604,  -604,
    -604,  -604,  -604,  -604,  1381,  -604,  -604,  3419,  -604,  -604,
    -604,  -604,   349,  -604,  -604,  -604,  -604,  -604,  -604,   150,
    -604,  -604,  -604,   337,   366,  -604,   337,   150,   382,  -604,
    -604,  -604,  -604,    45,   408,  -604,  -604,  -604,  -604,   342,
    -604,  3873,  1175,  -604,  -604,  -604,  -604,   388,  -604,  -604,
     388,   504,   420,  -604,  -604,   504,   436,  -604,  -604,  -604,
    -604,   528,   529,  -604,  -604,  -604,   504,   467,  -604,  -604,
     220,  -604,  -604,  -604,   337,   337,   242,  -604,  -604,   229,
    -604,  -604,  -604,  -604,  3810,  -604,  -604,    64,  -604,  1009,
    1185,   541,  -604,  -604,  -604,  -604,  -604,  -604,  -604,  -604,
    -604,  -604,  -604,  -604,  -604,  -604,  -604,  -604,  3786,  -604,
     427,  1003,   560,  -604,   560,   958,   524,  3841,  -604,  1970,
    -604,  2068,   933,  -604,  -604,  -604,   331,   933,   482,   462,
    -604,   983,  -604,  -604,  -604,  4309,    61,  4205,  -604,  -604,
    -604,  -604,   150,   489,   405,  -604,  3306,   494,   554,  1233,
    2033,  -604,  -604,   150,   456,   107,   152,   175,   286,  -604,
    -604,  -604,  -604,   180,  -604,  -604,   380,  -604,   216,  -604,
    -604,  -604,  -604,  -604,  -604,   418,   310,  -604,  -604,  -604,
     475,   480,   939,   939,   939,  -604,  -604,   939,  -604,  -604,
     990,   518,  -604,  -604,  -604,  -604,  -604,  -604,  -604,  -604,
     933,  3968,   337,   337,  -604,  3644,  -604,  -604,   525,  -604,
    3756,   497,   702,  -604,  -604,  -604,  -604,  -604,  -604,  -604,
    -604,  -604,  -604,  -604,  -604,  -604,  -604,  -604,  -604,  -604,
     865,  -604,  -604,   959,  -604,  -604,   560,  -604,   560,   504,
     537,  -604,  2741,   672,  2741,   672,  -604,  -604,  2741,   672,
     499,   509,  1468,   560,  -604,   560,   521,  -604,  -604,   521,
    -604,  -604,    -4,  -604,   879,  -604,   560,  1152,  1152,  -604,
    -604,   958,  -604,  -604,  -604,  -604,   143,  -604,  -604,  -604,
    -604,  -604,  -604,  -604,  -604,  -604,  -604,  -604,   143,  -604,
    -604,  -604,  -604,  -604,  -604,  -604,  -604,   310,   625,  -604,
    -604,  -604,  -604,   143,  -604,  -604,  -604,   678,  1953,  -604,
    -604,  -604,  -604,  -604,  -604,  -604,  -604,   363,  -604,  -604,
    -604,  -604,  -604,  -604,  -604,  -604,  -604,  -604,  -604,  -604,
    -604,  -604,  -604,  -604,  -604,  -604,  -604,  -604,   565,  2854,
     624,  -604,  -604,   184,  -604,  -604,  -604,  -604,  -604,  -604,
    -604,  -604,  -604,  -604,  -604,  -604,  -604,   399,  3419,  -604,
     551,   415,  -604,   337,   337,   560,   415,   415,   415,   415,
    -604,   310,  -604,  -604,  -604,  1156,   983,  1184,  -604,  -604,
    1381,  -604,  -604,  -604,  -604,  -604,  -604,  -604,  -604,  -604,
    -604,  -604,   337,  -604,   337,  -604,   637,  -604,   264,  -604,
    -604,  4557,  -604,  -604,   571,  -604,   535,  -604,  -604,  -604,
    -604,    48,  -604,   286,  -604,  -604,   195,  -604,  -604,   108,
    -604,  -604,   187,  -604,  -604,   702,  -604,   543,  3993,   560,
     541,   959,  -604,  -604,  -604,  -604,  -604,  -604,  -604,  -604,
    -604,  -604,  -604,  2967,   758,  -604,   504,   582,  2402,  -604,
    -604,  2402,  -604,  2402,  4101,  4101,  -604,  -604,   713,   385,
    -604,    45,  -604,  -604,  -604,  -604,  -604,  1152,   635,  -604,
    1156,  -604,  -604,  -604,  -604,  -604,  -604,  -604,   594,  2515,
     655,  -604,  -604,  -604,  -604,  -604,  -604,  -604,  -604,   554,
    -604,  -604,  -604,  -604,  -604,   428,  -604,  -604,  -604,  -604,
    -604,  -604,  -604,   388,   337,   337,  -604,  -604,  -604,  -604,
    -604,  -604,  -604,  -604,  -604,  -604,  -604,  -604,   130,   166,
    -604,  -604,  -604,  -604,  -604,  -604,  -604,   593,  1184,  -604,
    -604,   572,  -604,  -604,  -604,  -604,  -604,  -604,  4101,   504,
     616,  -604,   337,   337,    56,    63,   605,   197,  -604,  -604,
     702,  -604,  -604,  -604,    -4,   628,  2289,  -604,  3080,   672,
    -604,  -604,  -604,   286,    41,  -604,  -604,  -604,   591,  -604,
    -604,   385,  1184,   678,  -604,  -604,  -604,  -604,  -604,  -604,
    -604,   463,  -604,  -604,  -604,  -604,  -604,  -604,  -604,  -604,
    -604,  -604,   427,   150,   150,  -604,  -604,  1699,  4101,  -604,
     973,   832,  -604,  -604,   504,   651,   504,   652,   477,   617,
     337,   337,  -604,  -604,  -604,   758,  2628,  -604,  -604,   662,
    -604,   686,  -604,  -604,  -604,  -604,   560,   621,  -604,   337,
     337,  -604,   664,   973,   973,   832,   973,   832,  1152,   477,
    -604,  -604,   560,  -604,  -604,  -604,  -604,   623,   642,   832,
     973,   973,  -604,   560,   973,   973,  3193
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       5,     3,     0,     0,     0,     1,     8,     0,     0,     0,
     339,   343,     0,   337,   341,   338,   342,     9,   157,   340,
     344,     0,   557,   555,   156,   336,   155,     0,     0,     0,
       0,     0,   171,    13,    21,     0,   229,     0,    25,    18,
      66,    67,   171,     6,    27,    19,    26,    10,     0,     0,
       7,    11,    12,    14,    20,   158,     0,     0,   193,   215,
     191,   232,   231,     0,   225,   226,    15,   216,   230,   214,
     228,     0,   205,    17,     0,   560,    16,    57,   482,   466,
     465,     0,     0,     0,     0,     0,     0,     0,     0,   199,
     408,   423,   503,   422,   468,   430,   474,   468,   468,   474,
     432,     0,    84,   514,     0,   439,   543,   439,   542,   468,
       0,    24,    23,   513,   439,   512,   467,    43,    41,   184,
      42,    53,     4,    76,    52,   100,     0,    81,    78,    79,
      77,    80,   403,   179,   177,     0,   181,   175,   185,    89,
     186,   198,   197,    85,   196,   404,   468,   434,   428,   180,
     431,   420,   449,   468,   551,   107,   478,   418,   433,   178,
     418,   468,   176,   418,    49,    88,     0,   560,   511,    87,
     190,   189,   117,   131,   389,   390,   391,   329,   386,   387,
     388,   331,     0,     0,   386,   387,   388,     0,   149,   192,
     194,   329,     0,     0,     0,     0,   301,   289,     0,   328,
     245,     0,    47,     0,     0,    65,     0,    64,   161,   167,
     164,   154,   163,   162,     0,     0,     0,   220,   219,   223,
     224,   221,   178,   205,   227,   334,     0,   204,   604,   572,
       0,     0,   600,   601,   576,   565,   559,     0,   562,   568,
     567,   569,   570,   598,     0,   558,   564,    64,   483,   457,
     426,   427,     0,   112,    58,   242,   241,   243,   240,   370,
     236,   244,   239,   371,     0,   374,     0,   373,     0,   474,
     382,   383,   385,   170,     0,   384,   378,   203,   202,     0,
     201,     0,     0,   470,   418,   469,    50,   471,   418,   509,
     472,     0,     0,   417,    92,     0,     0,    91,   443,   445,
     447,   441,   440,   450,   544,   510,     0,     0,    93,   448,
     457,    48,   429,    90,     0,     0,     0,   513,   512,   467,
     184,   171,   175,   180,     0,   418,   511,     0,   418,   516,
       0,   553,   458,   464,   461,   462,   454,   455,   460,   459,
     463,   456,   106,   421,   425,   424,   435,   436,     0,   453,
     473,   183,   400,   418,   508,     0,     0,     0,   118,     0,
     132,     0,     0,   205,   333,   217,     0,     0,     0,     0,
     556,     0,   548,   549,   550,     0,     0,   144,   205,   173,
     195,   172,    22,     0,   323,   268,    64,     0,     0,     0,
       0,   174,    59,   346,     0,   546,   379,   380,   467,    86,
      68,    71,    82,     0,   418,    83,    72,   536,   537,   545,
     541,   381,   160,   166,   159,   222,   331,   205,   335,   206,
       0,     0,     0,     0,     0,   588,   606,     0,   589,   579,
       0,     0,   607,   571,   574,   599,   602,   563,   603,    70,
       0,   110,     0,     0,   372,    64,   353,   376,     0,   352,
      64,     0,     0,   207,   406,   418,   415,   416,   414,   409,
     412,   413,   452,   451,   551,   407,   492,   484,   485,   486,
       0,   488,   493,   501,   504,   487,   402,   475,   401,     0,
       0,   294,    64,     0,    64,     0,   444,   446,    64,     0,
       0,     0,     0,   183,   182,   405,     0,   521,   520,     0,
     518,   552,   437,   105,     0,   419,   515,     0,     0,   591,
     561,     0,   129,   125,   116,   126,     0,   120,   121,   119,
     153,   122,   124,   123,   142,   138,   130,   139,     0,   134,
     133,   135,   137,   136,   330,   210,   332,   331,   187,   145,
     143,   146,   150,     0,   148,   147,   211,     0,     0,   319,
     320,    30,    28,   313,    29,   316,   317,   467,    40,    44,
     302,    45,    34,    36,    37,    38,    35,    39,    46,    33,
     304,   315,   314,   303,    32,   318,    31,   325,     0,    64,
       0,   474,   256,   233,   258,   254,   253,   252,   257,   255,
     306,   312,   311,   310,   308,   307,   309,     0,    64,   547,
     546,     0,   540,     0,     0,    75,     0,     0,     0,     0,
     212,   331,   149,   149,   597,     0,     0,     0,   575,   578,
       0,   609,   577,   566,   345,   359,   362,   357,   360,   361,
     364,   365,     0,   358,     0,   363,     0,   108,    41,   109,
     115,     0,   114,   366,     0,   113,     0,   238,   237,   466,
     465,     0,   394,   467,   392,   103,     0,   397,   375,   107,
     393,   395,     0,   104,   377,     0,   168,   532,   110,   411,
     553,   502,   491,   500,   498,   497,   489,   490,   494,   499,
     495,   496,   298,    64,     0,    95,     0,     0,    64,   296,
      94,    64,    96,    64,    64,    64,   523,   522,   517,   439,
     554,   468,   479,   480,   476,   477,   481,     0,   597,   593,
     596,   594,   592,   128,   141,   218,   188,   152,     0,   326,
     327,   288,   287,   286,   284,   285,   321,   305,   322,     0,
     266,   267,   260,   263,   264,   467,   250,   246,   262,   261,
     251,   265,   290,   478,     0,     0,    61,    63,    62,    60,
      69,    74,    73,   535,   534,   538,   539,   213,     0,     0,
     586,   587,   580,   583,   585,   584,   582,     0,     0,   590,
     608,     0,   350,   348,   111,   367,   368,   369,    64,     0,
       0,   396,     0,     0,     0,     0,     0,     0,   351,   169,
       0,   200,   209,   208,   437,     0,   326,   300,    64,     0,
      98,    97,    99,     0,   529,   526,   524,   519,   525,   527,
     438,   439,   595,     0,   274,   280,   276,   275,   281,   282,
     283,   467,   269,   270,   272,   271,   273,   324,   292,   247,
     249,   248,   418,   235,   234,   605,   573,     0,    64,   347,
     293,     0,   399,   398,     0,     0,     0,     0,     0,     0,
       0,     0,   356,   533,   418,     0,    64,   531,   530,     0,
     442,   505,   327,   277,   279,   278,   259,     0,   349,     0,
       0,   467,     0,   295,   293,     0,   293,     0,     0,     0,
     355,   354,   410,   528,   506,   418,   581,     0,     0,     0,
     295,   295,   596,   507,   101,   102,    64
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -604,  -604,  -604,  -604,  -604,     6,   151,   -24,  -604,   574,
     277,    19,   653,   -73,  -604,  -401,    -1,  -604,  -604,   -23,
    -202,  -159,  -113,    54,    17,    83,  -604,  -604,     4,  -604,
    -604,    15,  -604,  -604,     9,   -31,  -604,  -604,  -604,   407,
       2,  -604,  -604,  -604,  -604,  -604,  -604,     7,   115,    31,
     708,   -82,  -604,    51,  -604,   241,  -604,  -604,  -604,    13,
    -604,  -604,  -137,  -604,  -604,  -604,   563,   723,  -604,   727,
      27,  -604,    37,  -333,    -9,    16,  -604,  -169,   176,  -300,
    -604,  -495,    29,  -603,   -64,  -415,   139,  -604,  -127,  -493,
     -58,   601,  -344,  -604,  -544,  -604,  -604,  -604,  -228,  -604,
    -223,  -604,  -604,  -604,   126,  -604,  -283,   -65,  -604,  -604,
    -356,  -604,    40,    30,  -406,   733,  -604,  -604,  -604,  -604,
    -604,  -604,   -54,   191,    22,  -604,   -41,  -604,     5,   -87,
    -604,  -604,  -604,  -604,   425,   478,  -604,  -604,   550,  -604,
      46,  -121,   188,   -28,     0,   -52,  -604,    66,  -604,  -604,
    -604,   336,  -604,  -604,  -604,  -604,    10,  -604,  -604,   -66,
    -604,  -604,   112,  -604,  -604,   -43,   153,  -604,    65,  -317,
      35,  -276,  -163,   356,   159,    12,  -604,   673,     8,    -3,
      21,  -604,  -142,  -604,  -140,  -184,  -604,  -604,  -604,  -604,
    -604,  -604,  -604,  -156,  -354,   656,  -395,  -216,   -45,   -18,
    -208,   -16,  -604,   394
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,     2,     4,     3,    43,   117,   118,    45,   559,   235,
     560,   120,   121,   122,   597,   205,   562,    48,    49,    50,
     400,   124,   125,   126,   563,   640,   641,   441,   564,   359,
     516,   565,   361,   528,   566,   376,   542,   377,   543,   519,
     567,    55,    56,   413,    57,   214,   132,   192,    58,   133,
     134,   135,   136,   568,    59,    60,    61,    62,   138,   569,
     279,   280,   226,   227,   668,    63,   224,    64,   219,    65,
     140,    67,    68,   584,   393,   260,   261,   262,   197,   585,
     198,   384,   199,   580,   689,   481,   200,   201,   386,   387,
      69,   363,   365,   366,    70,    71,    72,   141,   394,   643,
     447,   448,   449,   644,   645,   263,   264,   268,   266,   142,
     143,   273,   181,   177,   658,   144,   145,   146,   281,   459,
     460,   147,   351,   148,   505,   150,   151,   345,   701,   300,
     861,   301,   302,   152,   153,   154,   464,   346,   312,   347,
     324,   283,   284,   156,   285,   287,   706,   350,   158,   472,
     680,   473,   681,   474,   282,   885,   222,   160,   161,   162,
     163,   698,   500,   807,   808,   809,   666,   406,   407,   408,
     409,   410,   667,   331,   502,   574,   183,   166,   167,   326,
     576,   236,   237,   431,   238,   239,   421,   240,   241,   430,
     242,   765,   837,   428,   429,   503,   509,   243,   357,   436,
     621,   438,   420,   769
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      76,   168,    47,   123,   157,    54,   131,    51,   128,    44,
     254,    75,    53,   130,   159,    73,   165,   139,    52,   129,
     303,   127,    46,   276,   375,   169,   149,   309,   435,   244,
      66,   490,   329,   212,   213,   444,   437,   294,   403,   164,
     297,   369,   342,   370,   664,   439,   308,   290,   401,   203,
     155,   182,   719,   321,   720,   137,   245,   591,   246,   274,
     434,   191,   539,    44,   682,   216,   202,   187,   614,   615,
     616,   764,   610,   617,   426,   259,    46,   267,   403,   267,
     168,   602,   123,   157,   275,   131,   416,   128,   401,   657,
     592,  -379,   130,   159,   657,   165,   139,   343,   129,  -380,
     127,   265,    22,   857,   169,   149,   352,   172,   225,   354,
     381,   252,   709,   711,   344,   713,   712,  -242,   164,   699,
     -86,   381,   171,   269,   700,   -82,   828,   714,   779,   155,
     293,   539,   780,   -54,   137,   325,   844,    99,   371,   202,
     845,   435,   717,   846,   189,   190,    22,   847,   245,   437,
     246,   164,   349,   708,   710,   435,   -83,   323,   170,   858,
     442,   103,  -241,   176,   482,  -381,   764,   539,   484,   661,
       1,   310,   180,   434,   661,   204,    42,   317,   186,   488,
     318,     5,   176,   540,   382,  -243,   322,   434,   173,   796,
     603,   720,   325,   715,   744,   188,   828,   245,   106,   426,
     108,    42,   651,   325,   411,   782,   123,   850,   193,   131,
     784,   128,   599,  -379,   323,   721,   130,   405,   785,   165,
     139,  -380,   129,   458,   127,   323,   535,  -242,   169,   369,
     476,   412,   176,   176,   478,   258,   258,   258,   272,   258,
     419,   546,   -86,   322,   411,   451,   123,   -82,   722,   131,
     491,   128,   835,   155,   322,   -54,   130,   405,   402,   165,
     139,   494,   129,   418,   127,   414,   343,   757,   169,   797,
     443,   493,  -241,   223,   495,   255,   656,   247,   -83,   475,
     611,   656,   446,   344,   602,   288,   289,  -381,   836,   664,
     619,   755,   756,   155,   208,  -243,   787,   305,   402,   506,
     604,   583,   248,   461,   745,   259,   267,   249,   111,   112,
     256,   232,   709,   257,   233,   783,   206,   851,   719,   207,
     862,   349,   194,   588,   595,   286,   195,   196,   492,   788,
     245,   304,   246,   385,   328,   515,   313,   527,   657,   657,
     608,   330,   609,   291,   258,   293,     7,   292,   196,   353,
     605,   327,   683,   812,   358,   426,   523,   258,   533,   360,
     796,   520,   862,   520,   600,    44,   362,    44,   518,  -389,
     529,   522,   839,   532,   517,   751,   752,   781,    46,   544,
      46,  -390,    29,   575,    30,   620,   521,  -391,   531,   586,
     593,   106,   558,   108,   298,   299,   750,    32,   404,   587,
     594,   669,   534,   536,   435,   561,   538,   537,   545,   771,
     381,   772,   770,   364,   258,   255,   367,   258,   661,   661,
     388,   573,   657,   389,   589,   596,   322,   390,   322,   403,
     385,   417,   868,   471,   385,   392,   434,    22,   404,   401,
     797,   726,   411,   432,   433,   385,    89,   411,   111,   112,
     256,   558,    42,   257,   642,   660,   558,   295,   647,   648,
     660,   296,   196,   453,   561,   258,   258,   475,   727,   561,
     728,   646,   440,   306,   369,   767,   766,   307,   196,   575,
     624,   575,   657,   711,   712,   575,  -326,   548,   558,   445,
     558,   659,   325,   600,   558,    34,   659,   606,   607,   655,
     483,   561,   661,   561,   663,   450,   829,   561,   477,    37,
      38,   746,    40,   186,   323,    41,   485,   573,   186,   573,
     106,   747,   108,   573,   892,   656,   656,   781,   155,   743,
     155,   452,   601,   830,   155,   831,   685,   486,   690,   487,
     194,   863,   692,   322,   383,   196,   342,   489,   723,   501,
      22,   504,   435,   510,   842,   843,   507,   878,   724,   798,
     770,   422,   661,   433,   579,    78,    79,    80,   864,   547,
     865,   371,   768,   748,   749,   577,   741,   570,   119,   598,
     811,   758,   759,   725,   479,   558,   887,   294,   480,   196,
     269,   186,   638,   258,   258,   411,   612,   123,   561,   623,
     131,   613,   128,    44,    99,   216,   662,   130,   405,   656,
     165,   139,   810,   129,   740,   127,    46,   684,   385,   169,
     665,   471,   694,   111,   112,   270,   767,   853,   271,   250,
     251,    91,   695,   435,   194,    93,   114,    95,   578,   196,
       7,   111,   112,   174,   155,   729,   175,   742,   446,   402,
     446,   253,   840,   100,   316,   705,   599,   119,   778,   688,
     790,   691,   799,   278,  -595,   693,   773,    34,   774,   656,
     767,   753,   754,   570,   813,   570,    74,   319,   827,   570,
     575,    37,   111,   112,   775,   741,   385,   776,   741,   558,
     741,   411,   411,   432,   558,   838,   841,   558,   646,   558,
     558,   558,   561,   848,   660,   660,   462,   561,   855,   320,
     561,   859,   561,   561,   561,   879,   826,   874,   573,   876,
     297,   308,   654,   740,   860,   558,   740,   654,   740,   341,
     215,   875,   877,   884,   155,   833,   834,   155,   561,   155,
     804,   849,   800,   886,   889,   801,   894,   802,   111,   112,
     174,   792,   686,   175,   258,   258,   687,   196,   194,   463,
      74,   374,   718,   196,   867,   895,   320,   768,   530,   311,
     737,   217,   496,   497,   498,   411,   499,   320,   866,   716,
     372,   399,   415,   258,   558,   258,   218,   176,   660,   404,
     220,   804,   378,   826,   793,   575,   221,   561,    34,   854,
     882,   805,   558,   852,   558,   888,   671,   373,    74,   832,
     806,   571,    37,   111,   112,   561,   883,   561,   789,   638,
     670,   399,   356,   385,   622,   385,   422,   423,   348,   794,
     424,   893,   425,   573,   168,   411,   123,   157,   479,   131,
       0,   128,   795,   196,   558,     0,   130,   159,   660,   165,
     139,     0,   129,   741,   127,   457,   736,   561,   169,   149,
     259,   267,   558,     0,   572,    74,   880,   881,   111,   112,
     178,     0,   164,   179,   570,   561,    74,     0,     0,   737,
       0,     0,   737,   155,   737,    34,   659,     0,   137,     0,
       0,   740,   277,   741,   685,   258,   258,     0,   341,    37,
     111,   112,   558,    22,     0,   579,     0,   571,     0,   571,
     823,     0,   686,   571,     0,   561,   872,   196,   385,   659,
     659,   696,   659,     0,   697,     0,     0,   800,   690,     0,
     692,   740,     0,   258,   258,     0,   659,   659,   258,   466,
     659,   659,     0,   467,   801,   802,     0,     0,   655,   663,
       0,   541,   385,     0,     0,    74,     0,   702,     0,     0,
     572,     0,   572,     0,     0,   736,   572,   672,   736,     0,
     736,   654,   654,     0,   703,   856,   111,   112,   468,   649,
     650,   469,     0,   385,   704,   385,     0,   823,     0,   570,
     111,   112,     0,     0,   385,     0,   822,    74,     0,     0,
      74,   258,   258,   -55,   738,     0,     0,     0,    78,    79,
      80,     0,     0,     0,     0,   639,   869,   873,   427,   423,
     258,   258,   424,     0,   425,   870,   374,   673,   674,   675,
       0,     0,    74,   229,    74,     0,     0,   507,   508,   228,
     229,   424,     0,   425,   111,   112,   184,   737,    74,   185,
      74,   890,     0,   891,     0,   654,     0,   739,     0,     0,
       0,     0,    74,    74,     0,   896,   320,   651,  -470,  -470,
    -470,     0,  -470,   822,    91,   784,   676,   677,    93,    34,
      95,   368,   231,   785,   678,   679,    34,   737,   230,   231,
     871,     0,     0,    37,   111,   112,   100,   316,     0,     0,
      37,   111,   112,   232,   234,   209,   233,     0,   571,     0,
       0,   234,   618,   738,     0,   654,   738,     0,   738,  -165,
     319,     0,  -165,  -165,  -165,   -55,  -165,     0,     0,     0,
       0,  -165,  -165,   736,  -165,  -165,     0,     0,     0,  -165,
    -165,  -165,    22,    74,   824,     0,  -165,  -165,     0,     0,
    -165,     0,  -165,     0,     0,  -165,  -165,  -165,  -165,     0,
    -165,   572,  -165,     0,     0,    74,   739,     0,  -165,   739,
    -165,   739,   399,   736,     0,    10,    11,  -165,     0,     0,
    -165,     0,     0,    13,    14,     0,    15,    16,     0,   763,
       0,    19,    20,  -165,  -165,     0,     0,   825,    25,     0,
      34,    78,   332,   333,   334,     0,  -165,  -165,     0,     0,
       0,     0,  -165,    22,    37,    38,   210,    40,   777,     0,
      41,   824,     0,   571,     0,  -165,   211,     0,     0,     0,
       0,   707,   508,   228,    22,   424,     0,   425,     0,   374,
       0,     0,   639,     0,   496,   497,   498,   465,   499,   466,
       0,     0,    34,   467,     0,     0,     0,     0,     0,   760,
       0,   335,     0,     0,     0,     0,    37,   111,   112,   761,
     215,    22,     0,    95,   825,     0,   572,   762,     0,     0,
      34,   738,   230,     0,   763,     0,   111,   112,   468,   100,
     101,   469,    34,     0,    37,   111,   112,   232,   104,     0,
     233,     0,   470,     0,     0,     0,   110,   111,   112,   336,
       0,   269,   337,   338,   339,     0,   340,     0,     0,     0,
       0,   738,     0,     0,   581,    99,     0,     0,     0,     0,
     103,     0,   786,     0,   739,     0,     0,   105,   106,   107,
     108,     0,   582,     0,     0,     0,   317,   583,   114,   318,
     -51,    77,     0,     0,     0,    78,    79,    80,     0,     0,
       0,     0,     0,     0,   374,     7,     8,     9,    81,    10,
      11,     0,    82,     0,   739,     0,     0,    13,    14,     0,
      15,    16,   -64,    83,    18,    19,    20,    21,    22,    23,
      24,     0,    25,    84,    26,     0,    27,     0,    85,    28,
       0,    29,    86,    30,    87,     0,    88,    89,    31,     0,
       0,   119,     0,     0,    90,     0,    32,     0,     0,     0,
       0,    91,     0,    92,     0,    93,    94,    95,    96,     0,
     228,   229,     0,     0,     0,     0,     0,     0,     0,    97,
      98,     0,    99,   100,   101,   102,    34,   103,     0,     0,
       0,     0,   104,    36,   105,   106,   107,   108,   109,     0,
     110,   111,   112,   113,     0,   114,   115,   116,   -56,   379,
       0,    42,   -51,    78,    79,    80,     0,    34,     0,   230,
     231,     0,     0,     7,     0,     0,    81,    10,    11,     0,
      12,    37,   111,   112,   232,    13,    14,   233,    15,    16,
       0,     0,   234,    19,    20,    21,    22,     0,     0,     0,
      25,   314,     0,     0,    27,     0,    85,     0,     0,    29,
     315,    30,    87,     0,    88,     0,    31,     0,     0,     0,
       0,     0,    90,     0,    32,     0,     0,     0,     0,    91,
       0,    92,     0,    93,    94,    95,   269,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    97,    98,     0,
      99,   100,   316,     0,    34,   103,     0,     0,     0,     0,
      35,    36,   105,     0,   107,     0,   109,     0,    37,   111,
     112,   317,     0,   114,   318,   319,   -51,    77,     0,    42,
     -56,    78,    79,    80,     0,     0,     0,     0,     0,     0,
       0,     7,     8,     9,    81,    10,    11,     0,    82,     0,
       0,     0,     0,    13,    14,     0,    15,    16,   -64,    83,
      18,    19,    20,    21,    22,    23,    24,     0,    25,    84,
      26,     0,    27,     0,    85,    28,     0,    29,    86,    30,
      87,     0,    88,    89,    31,     0,     0,     0,     0,     0,
      90,     0,    32,     0,     0,     0,     0,    91,     0,    92,
       0,    93,    94,    95,    96,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    97,    98,     0,    99,   100,
     101,   102,    34,   103,     0,     0,     0,     0,   104,    36,
     105,   106,   107,   108,   109,     0,   110,   111,   112,   113,
      77,   114,   115,   116,    78,    79,    80,    42,     0,     0,
       0,     0,     0,     0,     7,     8,     9,    81,    10,    11,
       0,    82,     0,     0,     0,     0,    13,    14,     0,    15,
      16,   -64,    83,    18,    19,    20,    21,    22,    23,    24,
       0,    25,    84,    26,     0,    27,     0,    85,    28,     0,
      29,    86,    30,    87,     0,    88,    89,    31,     0,     0,
       0,     0,     0,    90,     0,    32,     0,     0,     0,     0,
      91,     0,    92,     0,    93,    94,    95,    96,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    97,    98,
       0,    99,   100,   101,   102,    34,   103,     0,     0,     0,
       0,   104,    36,   105,   106,   107,   108,   109,     0,   110,
     111,   112,   113,   379,   114,   115,   116,    78,    79,    80,
      42,   -51,     0,     0,     0,     0,     0,     7,     0,     0,
      81,    10,    11,     0,    12,     0,     0,     0,     0,    13,
      14,     0,    15,    16,     0,     0,     0,    19,    20,    21,
      22,     0,     0,     0,    25,   314,     0,     0,    27,     0,
      85,     0,     0,    29,   315,    30,    87,     0,    88,     0,
      31,     0,     0,     0,     0,     0,    90,     0,    32,     0,
       0,     0,     0,    91,     0,    92,     0,    93,    94,    95,
     269,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    97,    98,     0,    99,   100,   316,     0,    34,   103,
       0,     0,     0,     0,    35,    36,   105,     0,   107,     0,
     109,     0,    37,   111,   112,   317,     0,   114,   318,   319,
      -2,     6,     0,    42,   391,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     7,     8,     9,     0,    10,
      11,     0,    12,     0,     0,     0,     0,    13,    14,     0,
      15,    16,   -64,    17,    18,    19,    20,    21,    22,    23,
      24,   512,    25,     0,    26,     0,    27,     0,     0,    28,
       0,    29,     0,    30,     0,     7,     0,     9,    31,    10,
      11,     0,    12,     0,     0,     0,    32,    13,    14,     0,
      15,    16,  -127,     0,    18,    19,    20,    21,    22,    23,
      24,     0,    25,     0,    26,     0,    27,    33,     0,    28,
       0,    29,     0,    30,     0,     0,    34,     0,    31,     0,
       0,   269,    35,    36,     0,     0,    32,     0,     0,     0,
      37,    38,    39,    40,   581,    99,    41,     0,     0,     0,
       0,    42,     0,     0,     0,     0,     0,   105,   106,   107,
     108,     0,     0,     0,     0,     0,    34,   583,   114,   524,
       0,    22,    35,    36,     0,     0,     0,     0,     0,     0,
      37,    38,   513,     7,     0,     0,     0,    10,    11,     0,
      12,    42,   514,     0,     0,    13,    14,     0,    15,    16,
    -140,     0,    18,    19,    20,    21,    22,    23,    24,     0,
      25,   269,    26,     0,    27,     0,     0,    28,     0,    29,
       0,    30,     0,     0,   581,    99,    31,     0,     0,     0,
     103,     0,     0,     0,    32,     0,     0,   105,   106,   107,
     108,     0,   590,     0,     0,     0,   317,   583,   114,   318,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    34,     0,     0,     0,     0,     0,
      35,    36,     0,     0,     0,     0,     0,   379,    37,    38,
     525,    78,    79,    80,     0,     0,     0,     0,     0,    42,
     526,     7,     0,     0,    81,    10,    11,     0,    12,     0,
       0,     0,     0,    13,    14,     0,    15,    16,     0,     0,
       0,    19,    20,    21,    22,     0,     0,     0,    25,   314,
       0,     0,    27,     0,    85,     0,     0,    29,   315,    30,
      87,     0,    88,     0,    31,     0,     0,     0,     0,     0,
      90,     0,    32,   380,     0,     0,     0,    91,     0,    92,
       0,    93,    94,    95,   269,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    97,    98,     0,    99,   100,
     316,     0,    34,   103,     0,     0,     0,     0,    35,    36,
     105,     0,   107,     0,   109,     0,    37,   111,   112,   317,
       0,   114,   318,   319,    78,    79,    80,    42,     0,     0,
       0,     0,     0,     0,     7,     8,     9,    81,    10,    11,
       0,    82,     0,     0,     0,     0,    13,    14,  -299,    15,
      16,   -64,     0,    18,    19,    20,    21,    22,    23,    24,
       0,    25,   314,    26,     0,    27,     0,    85,    28,     0,
      29,   315,    30,    87,     0,    88,    89,    31,     0,     0,
       0,     0,     0,    90,     0,    32,     0,     0,     0,     0,
      91,     0,    92,     0,    93,    94,    95,   814,     0,     0,
       0,   548,     0,     0,     0,     0,     0,     0,    97,    98,
       0,   815,   100,   316,   551,    34,     0,     0,     0,     0,
       0,    35,    36,   105,   816,   107,   817,   109,   552,    37,
     818,   554,   819,     0,   114,   820,   821,    78,    79,    80,
      42,     0,     0,     0,     0,     0,     0,     7,     8,     9,
      81,    10,    11,     0,    82,  -291,     0,     0,     0,    13,
      14,  -295,    15,    16,     0,     0,    18,    19,    20,    21,
      22,    23,    24,     0,    25,    84,    26,     0,    27,     0,
      85,    28,     0,    29,    86,    30,    87,     0,    88,    89,
      31,     0,     0,     0,     0,     0,    90,     0,    32,     0,
       0,     0,     0,    91,     0,    92,     0,    93,    94,    95,
     730,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    97,    98,     0,   731,   100,   101,   551,    34,     0,
       0,     0,     0,     0,   104,    36,   105,   106,   107,   108,
     109,   552,   110,   732,   554,   733,     0,   114,   734,   735,
      78,    79,    80,    42,     0,     0,     0,     0,     0,     0,
       7,     8,     9,    81,    10,    11,     0,    82,     0,     0,
       0,     0,    13,    14,     0,    15,    16,   -64,     0,    18,
      19,    20,    21,    22,    23,    24,     0,    25,   314,    26,
       0,    27,     0,    85,    28,     0,    29,   315,    30,    87,
       0,    88,    89,    31,     0,     0,     0,     0,     0,    90,
       0,    32,     0,     0,     0,     0,    91,     0,    92,     0,
      93,    94,    95,   814,     0,     0,     0,   548,     0,     0,
       0,     0,     0,     0,    97,    98,     0,   815,   100,   316,
     551,    34,     0,     0,     0,     0,     0,    35,    36,   105,
     816,   107,   817,   109,   552,    37,   818,   554,   819,     0,
     114,   820,   821,    78,    79,    80,    42,     0,     0,     0,
       0,     0,     0,     7,     8,     9,    81,    10,    11,     0,
      82,  -291,     0,     0,     0,    13,    14,  -295,    15,    16,
       0,     0,    18,    19,    20,    21,    22,    23,    24,     0,
      25,   314,    26,     0,    27,     0,    85,    28,     0,    29,
     315,    30,    87,     0,    88,    89,    31,     0,     0,     0,
       0,     0,    90,     0,    32,     0,     0,     0,     0,    91,
       0,    92,     0,    93,    94,    95,   730,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    97,    98,     0,
     731,   100,   316,   551,    34,     0,     0,     0,     0,     0,
      35,    36,   105,   106,   107,   108,   109,   552,    37,   732,
     554,   733,     0,   114,   734,   735,    78,    79,    80,    42,
       0,     0,     0,     0,     0,     0,     7,     8,     9,    81,
      10,    11,     0,    82,     0,     0,     0,     0,    13,    14,
    -293,    15,    16,     0,     0,    18,    19,    20,    21,    22,
      23,    24,     0,    25,    84,    26,     0,    27,     0,    85,
      28,     0,    29,    86,    30,    87,     0,    88,    89,    31,
       0,     0,     0,     0,     0,    90,     0,    32,     0,     0,
       0,     0,    91,     0,    92,     0,    93,    94,    95,   549,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      97,    98,     0,   550,   100,   101,   551,    34,     0,     0,
       0,     0,     0,   104,    36,   105,   106,   107,   108,   109,
     552,   110,   553,   554,   555,     0,   114,   556,   557,    78,
      79,    80,    42,     0,     0,     0,     0,     0,     0,     7,
       8,     9,    81,    10,    11,     0,    82,  -291,     0,     0,
       0,    13,    14,     0,    15,    16,     0,     0,    18,    19,
      20,    21,    22,    23,    24,     0,    25,   314,    26,     0,
      27,     0,    85,    28,     0,    29,   315,    30,    87,     0,
      88,    89,    31,     0,     0,     0,     0,     0,    90,     0,
      32,     0,     0,     0,     0,    91,     0,    92,     0,    93,
      94,    95,   730,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    97,    98,     0,   731,   100,   316,   551,
      34,     0,     0,     0,     0,     0,    35,    36,   105,   106,
     107,   108,   109,   552,    37,   732,   554,   733,     0,   114,
     734,   735,    78,    79,    80,    42,     0,     0,     0,     0,
       0,     0,     7,     8,     9,    81,    10,    11,     0,    82,
       0,     0,     0,     0,    13,    14,  -297,    15,    16,     0,
       0,    18,    19,    20,    21,    22,    23,    24,     0,    25,
     314,    26,     0,    27,     0,    85,    28,     0,    29,   315,
      30,    87,     0,    88,    89,    31,     0,     0,     0,     0,
       0,    90,     0,    32,     0,     0,     0,     0,    91,     0,
      92,     0,    93,    94,    95,   549,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    97,    98,     0,   550,
     100,   316,   551,    34,     0,     0,     0,     0,     0,    35,
      36,   105,   106,   107,   108,   109,   552,    37,   553,   554,
     555,     0,   114,   556,   557,    78,    79,    80,    42,     0,
       0,     0,     0,     0,     0,     7,     8,     9,    81,    10,
      11,     0,    82,     0,     0,     0,     0,    13,    14,  -293,
      15,    16,     0,     0,    18,    19,    20,    21,    22,    23,
      24,     0,    25,   314,    26,     0,    27,     0,    85,    28,
       0,    29,   315,    30,    87,     0,    88,    89,    31,     0,
       0,     0,     0,     0,    90,     0,    32,     0,     0,     0,
       0,    91,     0,    92,     0,    93,    94,    95,   549,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    97,
      98,     0,   550,   100,   316,   551,    34,     0,     0,     0,
       0,     0,    35,    36,   105,   106,   107,   108,   109,   552,
      37,   553,   554,   555,     0,   114,   556,   557,    78,    79,
      80,    42,     0,     0,     0,     0,     0,     0,     7,     8,
       9,    81,    10,    11,     0,    82,     0,     0,     0,     0,
      13,    14,  -295,    15,    16,     0,     0,    18,    19,    20,
      21,    22,    23,    24,     0,    25,   314,    26,     0,    27,
       0,    85,    28,     0,    29,   315,    30,    87,     0,    88,
      89,    31,     0,     0,     0,     0,     0,    90,     0,    32,
       0,     0,     0,     0,    91,     0,    92,     0,    93,    94,
      95,   730,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    97,    98,     0,   731,   100,   316,   551,    34,
       0,     0,     0,     0,     0,    35,    36,   105,   106,   107,
     108,   109,   552,    37,   732,   554,   733,     0,   114,   734,
     735,    78,    79,    80,    42,     0,     0,     0,     0,     0,
       0,     7,     8,     9,    81,    10,    11,     0,    82,     0,
       0,     0,     0,    13,    14,     0,    15,    16,     0,     0,
      18,    19,    20,    21,    22,    23,    24,     0,    25,   314,
      26,     0,    27,     0,    85,    28,     0,    29,   315,    30,
      87,     0,    88,    89,    31,     0,     0,     0,     0,     0,
      90,     0,    32,     0,     0,     0,     0,    91,     0,    92,
       0,    93,    94,    95,   549,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    97,    98,     0,   550,   100,
     316,   551,    34,     0,     0,     0,     0,     0,    35,    36,
     105,   106,   107,   108,   109,   552,    37,   553,   554,   555,
       0,   114,   556,   557,    78,    79,    80,    42,     0,     0,
       0,     0,     0,     0,     7,     8,     9,    81,    10,    11,
       0,    82,     0,     0,     0,     0,    13,    14,     0,    15,
      16,     0,     0,    18,    19,    20,    21,    22,    23,    24,
       0,    25,    84,    26,     0,    27,     0,    85,    28,     0,
      29,    86,    30,    87,     0,    88,    89,    31,     0,     0,
       0,     0,     0,    90,     0,    32,     0,     0,     0,     0,
      91,     0,    92,     0,    93,    94,    95,   395,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    97,    98,
       0,     0,   100,   101,   102,    34,     0,     0,     0,     0,
       0,   104,    36,   105,   106,   107,   108,   109,     0,   110,
     111,   112,   396,     0,   114,   397,   398,    78,    79,    80,
      42,     0,     0,     0,     0,     0,     0,     7,     0,     0,
      81,    10,    11,     0,    12,     0,     0,     0,     0,    13,
      14,     0,    15,    16,     0,     0,     0,    19,    20,    21,
      22,     0,     0,     0,    25,   314,     0,     0,    27,     0,
      85,     0,     0,    29,   315,    30,    87,     0,    88,     0,
      31,     0,     0,     0,     0,     0,    90,     0,    32,     0,
       0,     0,     0,    91,     0,    92,     0,    93,    94,    95,
     269,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    97,    98,     0,    99,   100,   316,     0,    34,   103,
       0,     0,     0,     0,    35,    36,   105,     0,   107,     0,
     109,     0,    37,   111,   112,   317,     0,   114,   318,   319,
     649,   650,     0,    42,     0,     0,     0,     0,     0,     7,
       8,     9,    81,    10,    11,     0,    82,     0,     0,     0,
       0,    13,    14,  -101,    15,    16,     0,     0,    18,    19,
      20,    21,    22,    23,    24,     0,    25,    84,    26,     0,
      27,     0,    85,    28,     0,    29,    86,    30,    87,     0,
      88,    89,    31,     0,     0,     0,     0,     0,    90,     0,
      32,     0,     0,     0,     0,     0,     0,    92,     0,     0,
      94,     0,   395,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    97,    98,     0,     0,     0,   651,   551,
      34,     0,     0,     0,     0,     0,   104,    36,   105,   106,
     107,   108,   109,   552,   110,   652,   554,   396,     0,   114,
     397,   653,   649,   650,     0,    42,     0,     0,     0,     0,
       0,     7,     8,     9,    81,    10,    11,     0,    82,     0,
       0,     0,     0,    13,    14,  -102,    15,    16,     0,     0,
      18,    19,    20,    21,    22,    23,    24,     0,    25,    84,
      26,     0,    27,     0,    85,    28,     0,    29,    86,    30,
      87,     0,    88,    89,    31,    78,   332,   333,   334,     0,
      90,     0,    32,     0,     0,     0,     0,     0,     0,    92,
       0,     0,    94,     0,   395,   228,   229,     0,     0,     0,
       0,     0,     0,     0,     0,    97,    98,     0,    22,     0,
     651,   551,    34,     0,     0,     0,     0,     0,   104,    36,
     105,   106,   107,   108,   109,   552,   110,   652,   554,   396,
       0,   114,   397,   653,     0,   335,     0,    42,    78,    79,
      80,     0,    34,     0,   355,   231,     0,    95,     0,     0,
     228,   229,     0,     0,     0,     0,    37,   111,   112,   232,
       0,     0,   233,   100,   316,     0,    34,   234,     0,     0,
       0,     0,    35,     0,     0,     0,     0,     0,     0,     0,
      37,   111,   112,   336,     0,     0,   337,   338,   339,     0,
     340,     0,     0,     0,     0,     0,     0,    34,   454,   511,
     231,     0,     0,     0,    91,     0,     0,     0,    93,     0,
      95,    37,   111,   112,   232,     0,     0,   233,     0,     0,
       0,     0,   234,   455,     0,     0,   100,   316,     0,    34,
       0,     0,     0,     0,     0,    35,   456,   105,     0,   107,
     625,     0,   626,    37,   111,   112,     0,     0,   114,   627,
     319,     0,   628,   629,   630,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   625,     0,   626,     0,   631,
       0,   632,     0,   633,   627,     0,   634,   628,   629,   630,
       0,     0,     0,   635,   636,    89,     0,     0,     0,     0,
       0,     0,     0,     0,   631,     0,   632,     0,   633,     0,
       0,   634,     0,     0,     0,     0,     0,     0,   635,   636,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    34,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    37,   111,
     112,   174,     0,     0,   175,     0,     0,     0,     0,    34,
     637,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    37,   111,   112,   174,     0,     0,   175,
       0,     0,     0,     0,     0,   791,     7,     8,     9,    81,
      10,    11,     0,    82,     0,     0,     0,     0,    13,    14,
       0,    15,    16,     0,     0,    18,    19,    20,    21,    22,
      23,    24,     0,    25,   314,    26,     0,    27,     0,    85,
      28,     0,    29,   315,    30,    87,     0,    88,    89,    31,
       0,     0,     0,     0,     0,    90,     0,    32,     0,     0,
       0,     0,     0,     0,    92,     0,     0,    94,     0,   395,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      97,    98,     0,     0,     0,     0,   551,    34,     0,     0,
       0,     0,     0,    35,    36,   105,   106,   107,   108,   109,
     552,    37,   652,   554,   396,     0,   114,   397,   803,     0,
       7,     0,    42,    81,    10,    11,     0,    12,     0,     0,
       0,     0,    13,    14,     0,    15,    16,  -151,     0,    18,
      19,    20,    21,    22,     0,    24,     0,    25,   314,    26,
       0,    27,     0,    85,     0,     0,    29,   315,    30,    87,
       0,    88,     0,    31,     0,     0,     0,     0,     0,    90,
       0,    32,     0,     0,     0,     0,     0,     0,    92,     0,
       0,    94,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    97,    98,     0,     0,     0,     0,
       0,    34,   103,     0,     0,     0,     0,    35,    36,   105,
       0,   107,     0,   109,     0,    37,   111,   112,   317,     0,
     114,   318,     0,     0,     7,     0,    42,    81,    10,    11,
       0,    12,     0,     0,     0,     0,    13,    14,     0,    15,
      16,     0,     0,     0,    19,    20,    21,    22,     0,     0,
       0,    25,   314,     0,     0,    27,     0,    85,     0,     0,
      29,   315,    30,    87,     0,    88,     0,    31,     0,     0,
       0,     0,     0,    90,     0,    32,     0,     0,     0,     0,
       0,     0,    92,     0,     0,    94,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    97,    98,
       0,     0,     0,     0,     0,     0,   103,     0,     0,     0,
       0,    35,    36,   105,     0,   107,     7,   109,     0,    81,
      10,    11,   317,    82,   114,   318,     0,     0,    13,    14,
      42,    15,    16,     0,     0,     0,    19,    20,    21,     0,
       0,     0,     0,    25,   314,     0,     0,    27,     0,    85,
       0,     0,    29,   315,    30,    87,     0,    88,     0,    31,
       0,     0,     0,     0,     0,    90,     0,    32,     0,     0,
       0,     0,     0,     0,    92,     0,     0,    94,     0,     0,
       7,     0,     0,     0,    10,    11,     0,    12,     0,     0,
      97,    98,    13,    14,     0,    15,    16,     0,     0,     0,
      19,    20,    21,    35,    36,     0,     0,    25,     0,   109,
       0,    27,     0,     0,     0,     0,    29,     0,    30,    87,
       0,     0,    42,    31,     0,     0,     0,     0,     0,    90,
       0,    32,     0,     0,     0,     0,     0,     0,    92,     0,
       0,    94,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    97,    98,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    35,    36,   105,
       0,   107,     7,   109,     0,     0,    10,    11,     0,    12,
     114,     0,     0,     0,    13,    14,    42,    15,    16,     0,
       0,     0,    19,    20,    21,     0,     0,     0,     0,    25,
       0,     0,     0,    27,     0,     0,     0,     0,    29,     0,
      30,     0,     0,     0,     0,    31,     0,     0,     0,     0,
       0,     0,     0,    32,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    35,
      36,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    42
};

static const yytype_int16 yycheck[] =
{
       3,     4,     3,     4,     4,     3,     4,     3,     4,     3,
      83,     3,     3,     4,     4,     3,     4,     4,     3,     4,
     107,     4,     3,    88,   187,     4,     4,   114,   244,    74,
       3,   314,   153,    57,    57,   263,   244,   101,   207,     4,
     104,   183,   155,   183,   450,   247,   110,    99,   207,    42,
       4,    21,   547,   135,   547,     4,    74,   390,    74,    87,
     244,    31,     1,    57,   479,    57,    37,    27,   422,   423,
     424,   615,   416,   427,   230,    84,    57,    86,   247,    88,
      83,   398,    83,    83,    87,    83,   223,    83,   247,   445,
     390,     0,    83,    83,   450,    83,    83,   155,    83,     0,
      83,    85,    38,    62,    83,    83,   160,   121,    71,   163,
     192,    81,   507,   508,   155,   516,   511,    10,    83,   123,
       0,   203,     7,    78,   128,     0,   729,   528,    80,    83,
     101,     1,    84,     0,    83,   135,    80,    92,   183,   110,
      84,   357,   543,    80,    29,    30,    38,    84,   166,   357,
     166,   116,   155,   507,   508,   371,     0,   135,   103,   118,
      10,    97,    10,    12,   291,     0,   710,     1,   295,   445,
      86,    78,    21,   357,   450,    32,   121,   113,    27,   306,
     116,     0,    31,   122,   193,    10,   135,   371,   121,   684,
      10,   684,   192,   537,    10,   121,   799,   215,   105,   355,
     107,   121,    94,   203,   207,    10,   207,    10,   120,   207,
     102,   207,   105,   122,   192,   548,   207,   207,   110,   207,
     207,   122,   207,   281,   207,   203,   363,   120,   207,   371,
     284,   214,    81,    82,   288,    84,    85,    86,    87,    88,
     227,   378,   122,   192,   247,   273,   247,   122,   548,   247,
     315,   247,   122,   207,   203,   122,   247,   247,   207,   247,
     247,   327,   247,   226,   247,   214,   324,   611,   247,   684,
     120,   325,   120,    13,   328,    78,   445,   123,   122,   282,
     417,   450,   266,   324,   601,    97,    98,   122,   122,   695,
     430,   608,   609,   247,   121,   120,   109,   109,   247,   353,
     120,   114,    78,   281,   120,   314,   315,    78,   111,   112,
     113,   113,   707,   116,   116,   120,   120,   120,   813,   123,
     813,   324,    80,   389,   390,   105,    84,    85,   321,   662,
     348,   105,   348,   194,   146,   359,    29,   361,   694,   695,
     124,   153,   126,    80,   193,   316,    15,    84,    85,   161,
     404,    81,   479,   707,    87,   511,   359,   206,   361,    87,
     855,   359,   855,   361,    78,   359,   123,   361,   359,   123,
     361,   359,   778,   361,   359,   603,   604,   653,   359,   377,
     361,   123,    51,   386,    53,   430,   359,   123,   361,   389,
     390,   105,   386,   107,     9,    10,   598,    66,   207,   389,
     390,   455,   362,   366,   620,   386,   375,   367,   377,   632,
     492,   634,   620,   103,   263,    78,   123,   266,   694,   695,
      80,   386,   778,    82,   389,   390,   375,    82,   377,   598,
     291,    13,   838,   282,   295,   121,   620,    38,   247,   598,
     855,    78,   445,   100,   101,   306,    57,   450,   111,   112,
     113,   445,   121,   116,   441,   445,   450,    80,   442,   443,
     450,    84,    85,   121,   445,   314,   315,   470,   105,   450,
     107,   441,   123,    80,   616,   617,   616,    84,    85,   482,
     440,   484,   838,   878,   879,   488,    81,    82,   482,   123,
     484,   445,   492,    78,   488,    96,   450,   117,   118,   445,
      80,   482,   778,   484,   450,   123,    78,   488,   120,   110,
     111,   112,   113,   362,   492,   116,    80,   482,   367,   484,
     105,   122,   107,   488,   878,   694,   695,   803,   482,   581,
     484,   123,   117,   105,   488,   107,   482,     9,   484,    10,
      80,    78,   488,   492,    84,    85,   659,    80,   548,     8,
      38,   124,   768,    29,   782,   783,    79,    80,   548,   686,
     768,    79,   838,   101,   388,     5,     6,     7,   105,    80,
     107,   616,   617,   597,   597,    81,   579,   386,     4,   123,
     701,   612,   613,   548,    80,   579,   869,   651,    84,    85,
      78,   440,   441,   442,   443,   598,   121,   598,   579,    81,
     598,   121,   598,   597,    92,   597,    81,   598,   598,   778,
     598,   598,   699,   598,   579,   598,   597,    80,   479,   598,
     123,   470,   123,   111,   112,   113,   768,   790,   116,    79,
      80,    71,   123,   849,    80,    75,   115,    77,    84,    85,
      15,   111,   112,   113,   598,    80,   116,    23,   632,   598,
     634,   121,   779,    93,    94,   504,   105,    83,   123,   483,
     117,   485,    80,    89,    29,   489,   636,    96,   641,   838,
     812,   606,   607,   482,    80,   484,     3,   117,    23,   488,
     683,   110,   111,   112,   113,   688,   547,   116,   691,   683,
     693,   694,   695,   100,   688,   123,    80,   691,   668,   693,
     694,   695,   683,    98,   694,   695,   281,   688,    80,   135,
     691,   120,   693,   694,   695,    98,   719,   844,   683,   846,
     784,   785,   445,   688,   811,   719,   691,   450,   693,   155,
      57,    80,    80,    47,   688,   744,   745,   691,   719,   693,
      78,   786,   688,   122,    80,   691,   123,   693,   111,   112,
     113,   668,    80,   116,   603,   604,    84,    85,    80,   281,
      87,   187,    84,    85,   837,   123,   192,   812,   361,   116,
     579,    63,    59,    60,    61,   778,    63,   203,   832,   538,
      78,   207,   219,   632,   778,   634,    63,   636,   778,   598,
      63,    78,   191,   796,   668,   798,    63,   778,    96,   794,
     854,    88,   796,   787,   798,   870,   470,   105,   135,   743,
     698,   386,   110,   111,   112,   796,   859,   798,   665,   668,
     464,   247,   166,   684,   430,   686,    79,    80,   155,   670,
      83,   885,    85,   798,   837,   838,   837,   837,    80,   837,
      -1,   837,    84,    85,   838,    -1,   837,   837,   838,   837,
     837,    -1,   837,   856,   837,   281,   579,   838,   837,   837,
     869,   870,   856,    -1,   386,   192,   850,   851,   111,   112,
     113,    -1,   837,   116,   683,   856,   203,    -1,    -1,   688,
      -1,    -1,   691,   837,   693,    96,   840,    -1,   837,    -1,
      -1,   856,   103,   896,   840,   744,   745,    -1,   324,   110,
     111,   112,   896,    38,    -1,   729,    -1,   482,    -1,   484,
     719,    -1,    80,   488,    -1,   896,    84,    85,   779,   873,
     874,   496,   876,    -1,   499,    -1,    -1,   873,   874,    -1,
     876,   896,    -1,   782,   783,    -1,   890,   891,   787,    74,
     894,   895,    -1,    78,   890,   891,    -1,    -1,   894,   895,
      -1,   377,   813,    -1,    -1,   282,    -1,    78,    -1,    -1,
     482,    -1,   484,    -1,    -1,   688,   488,     8,   691,    -1,
     693,   694,   695,    -1,    95,   799,   111,   112,   113,     6,
       7,   116,    -1,   844,   105,   846,    -1,   796,    -1,   798,
     111,   112,    -1,    -1,   855,    -1,   719,   324,    -1,    -1,
     327,   850,   851,     0,   579,    -1,    -1,    -1,     5,     6,
       7,    -1,    -1,    -1,    -1,   441,    43,   841,    79,    80,
     869,   870,    83,    -1,    85,    52,   452,    68,    69,    70,
      -1,    -1,   359,    50,   361,    -1,    -1,    79,    80,    49,
      50,    83,    -1,    85,   111,   112,   113,   856,   375,   116,
     377,   875,    -1,   877,    -1,   778,    -1,   579,    -1,    -1,
      -1,    -1,   389,   390,    -1,   889,   492,    94,    59,    60,
      61,    -1,    63,   796,    71,   102,   117,   118,    75,    96,
      77,    98,    99,   110,   125,   126,    96,   896,    98,    99,
     117,    -1,    -1,   110,   111,   112,    93,    94,    -1,    -1,
     110,   111,   112,   113,   121,     1,   116,    -1,   683,    -1,
      -1,   121,   122,   688,    -1,   838,   691,    -1,   693,    15,
     117,    -1,    18,    19,    20,   122,    22,    -1,    -1,    -1,
      -1,    27,    28,   856,    30,    31,    -1,    -1,    -1,    35,
      36,    37,    38,   470,   719,    -1,    42,    43,    -1,    -1,
      46,    -1,    48,    -1,    -1,    51,    52,    53,    54,    -1,
      56,   683,    58,    -1,    -1,   492,   688,    -1,    64,   691,
      66,   693,   598,   896,    -1,    19,    20,    73,    -1,    -1,
      76,    -1,    -1,    27,    28,    -1,    30,    31,    -1,   615,
      -1,    35,    36,    89,    90,    -1,    -1,   719,    42,    -1,
      96,     5,     6,     7,     8,    -1,   102,   103,    -1,    -1,
      -1,    -1,   108,    38,   110,   111,   112,   113,   644,    -1,
     116,   796,    -1,   798,    -1,   121,   122,    -1,    -1,    -1,
      -1,    79,    80,    49,    38,    83,    -1,    85,    -1,   665,
      -1,    -1,   668,    -1,    59,    60,    61,    72,    63,    74,
      -1,    -1,    96,    78,    -1,    -1,    -1,    -1,    -1,   103,
      -1,    65,    -1,    -1,    -1,    -1,   110,   111,   112,   113,
     597,    38,    -1,    77,   796,    -1,   798,   121,    -1,    -1,
      96,   856,    98,    -1,   710,    -1,   111,   112,   113,    93,
      94,   116,    96,    -1,   110,   111,   112,   113,   102,    -1,
     116,    -1,   127,    -1,    -1,    -1,   110,   111,   112,   113,
      -1,    78,   116,   117,   118,    -1,   120,    -1,    -1,    -1,
      -1,   896,    -1,    -1,    91,    92,    -1,    -1,    -1,    -1,
      97,    -1,   659,    -1,   856,    -1,    -1,   104,   105,   106,
     107,    -1,   109,    -1,    -1,    -1,   113,   114,   115,   116,
       0,     1,    -1,    -1,    -1,     5,     6,     7,    -1,    -1,
      -1,    -1,    -1,    -1,   790,    15,    16,    17,    18,    19,
      20,    -1,    22,    -1,   896,    -1,    -1,    27,    28,    -1,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    43,    44,    -1,    46,    -1,    48,    49,
      -1,    51,    52,    53,    54,    -1,    56,    57,    58,    -1,
      -1,   837,    -1,    -1,    64,    -1,    66,    -1,    -1,    -1,
      -1,    71,    -1,    73,    -1,    75,    76,    77,    78,    -1,
      49,    50,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
      -1,    -1,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,   111,   112,   113,    -1,   115,   116,   117,     0,     1,
      -1,   121,   122,     5,     6,     7,    -1,    96,    -1,    98,
      99,    -1,    -1,    15,    -1,    -1,    18,    19,    20,    -1,
      22,   110,   111,   112,   113,    27,    28,   116,    30,    31,
      -1,    -1,   121,    35,    36,    37,    38,    -1,    -1,    -1,
      42,    43,    -1,    -1,    46,    -1,    48,    -1,    -1,    51,
      52,    53,    54,    -1,    56,    -1,    58,    -1,    -1,    -1,
      -1,    -1,    64,    -1,    66,    -1,    -1,    -1,    -1,    71,
      -1,    73,    -1,    75,    76,    77,    78,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    89,    90,    -1,
      92,    93,    94,    -1,    96,    97,    -1,    -1,    -1,    -1,
     102,   103,   104,    -1,   106,    -1,   108,    -1,   110,   111,
     112,   113,    -1,   115,   116,   117,     0,     1,    -1,   121,
     122,     5,     6,     7,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    15,    16,    17,    18,    19,    20,    -1,    22,    -1,
      -1,    -1,    -1,    27,    28,    -1,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    43,
      44,    -1,    46,    -1,    48,    49,    -1,    51,    52,    53,
      54,    -1,    56,    57,    58,    -1,    -1,    -1,    -1,    -1,
      64,    -1,    66,    -1,    -1,    -1,    -1,    71,    -1,    73,
      -1,    75,    76,    77,    78,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    89,    90,    -1,    92,    93,
      94,    95,    96,    97,    -1,    -1,    -1,    -1,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,   111,   112,   113,
       1,   115,   116,   117,     5,     6,     7,   121,    -1,    -1,
      -1,    -1,    -1,    -1,    15,    16,    17,    18,    19,    20,
      -1,    22,    -1,    -1,    -1,    -1,    27,    28,    -1,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    43,    44,    -1,    46,    -1,    48,    49,    -1,
      51,    52,    53,    54,    -1,    56,    57,    58,    -1,    -1,
      -1,    -1,    -1,    64,    -1,    66,    -1,    -1,    -1,    -1,
      71,    -1,    73,    -1,    75,    76,    77,    78,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    89,    90,
      -1,    92,    93,    94,    95,    96,    97,    -1,    -1,    -1,
      -1,   102,   103,   104,   105,   106,   107,   108,    -1,   110,
     111,   112,   113,     1,   115,   116,   117,     5,     6,     7,
     121,   122,    -1,    -1,    -1,    -1,    -1,    15,    -1,    -1,
      18,    19,    20,    -1,    22,    -1,    -1,    -1,    -1,    27,
      28,    -1,    30,    31,    -1,    -1,    -1,    35,    36,    37,
      38,    -1,    -1,    -1,    42,    43,    -1,    -1,    46,    -1,
      48,    -1,    -1,    51,    52,    53,    54,    -1,    56,    -1,
      58,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,
      -1,    -1,    -1,    71,    -1,    73,    -1,    75,    76,    77,
      78,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    89,    90,    -1,    92,    93,    94,    -1,    96,    97,
      -1,    -1,    -1,    -1,   102,   103,   104,    -1,   106,    -1,
     108,    -1,   110,   111,   112,   113,    -1,   115,   116,   117,
       0,     1,    -1,   121,   122,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    15,    16,    17,    -1,    19,
      20,    -1,    22,    -1,    -1,    -1,    -1,    27,    28,    -1,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,     1,    42,    -1,    44,    -1,    46,    -1,    -1,    49,
      -1,    51,    -1,    53,    -1,    15,    -1,    17,    58,    19,
      20,    -1,    22,    -1,    -1,    -1,    66,    27,    28,    -1,
      30,    31,    32,    -1,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    -1,    44,    -1,    46,    87,    -1,    49,
      -1,    51,    -1,    53,    -1,    -1,    96,    -1,    58,    -1,
      -1,    78,   102,   103,    -1,    -1,    66,    -1,    -1,    -1,
     110,   111,   112,   113,    91,    92,   116,    -1,    -1,    -1,
      -1,   121,    -1,    -1,    -1,    -1,    -1,   104,   105,   106,
     107,    -1,    -1,    -1,    -1,    -1,    96,   114,   115,     1,
      -1,    38,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,    15,    -1,    -1,    -1,    19,    20,    -1,
      22,   121,   122,    -1,    -1,    27,    28,    -1,    30,    31,
      32,    -1,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    78,    44,    -1,    46,    -1,    -1,    49,    -1,    51,
      -1,    53,    -1,    -1,    91,    92,    58,    -1,    -1,    -1,
      97,    -1,    -1,    -1,    66,    -1,    -1,   104,   105,   106,
     107,    -1,   109,    -1,    -1,    -1,   113,   114,   115,   116,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    96,    -1,    -1,    -1,    -1,    -1,
     102,   103,    -1,    -1,    -1,    -1,    -1,     1,   110,   111,
     112,     5,     6,     7,    -1,    -1,    -1,    -1,    -1,   121,
     122,    15,    -1,    -1,    18,    19,    20,    -1,    22,    -1,
      -1,    -1,    -1,    27,    28,    -1,    30,    31,    -1,    -1,
      -1,    35,    36,    37,    38,    -1,    -1,    -1,    42,    43,
      -1,    -1,    46,    -1,    48,    -1,    -1,    51,    52,    53,
      54,    -1,    56,    -1,    58,    -1,    -1,    -1,    -1,    -1,
      64,    -1,    66,    67,    -1,    -1,    -1,    71,    -1,    73,
      -1,    75,    76,    77,    78,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    89,    90,    -1,    92,    93,
      94,    -1,    96,    97,    -1,    -1,    -1,    -1,   102,   103,
     104,    -1,   106,    -1,   108,    -1,   110,   111,   112,   113,
      -1,   115,   116,   117,     5,     6,     7,   121,    -1,    -1,
      -1,    -1,    -1,    -1,    15,    16,    17,    18,    19,    20,
      -1,    22,    -1,    -1,    -1,    -1,    27,    28,    29,    30,
      31,    32,    -1,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    43,    44,    -1,    46,    -1,    48,    49,    -1,
      51,    52,    53,    54,    -1,    56,    57,    58,    -1,    -1,
      -1,    -1,    -1,    64,    -1,    66,    -1,    -1,    -1,    -1,
      71,    -1,    73,    -1,    75,    76,    77,    78,    -1,    -1,
      -1,    82,    -1,    -1,    -1,    -1,    -1,    -1,    89,    90,
      -1,    92,    93,    94,    95,    96,    -1,    -1,    -1,    -1,
      -1,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,    -1,   115,   116,   117,     5,     6,     7,
     121,    -1,    -1,    -1,    -1,    -1,    -1,    15,    16,    17,
      18,    19,    20,    -1,    22,    23,    -1,    -1,    -1,    27,
      28,    29,    30,    31,    -1,    -1,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    43,    44,    -1,    46,    -1,
      48,    49,    -1,    51,    52,    53,    54,    -1,    56,    57,
      58,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,
      -1,    -1,    -1,    71,    -1,    73,    -1,    75,    76,    77,
      78,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    89,    90,    -1,    92,    93,    94,    95,    96,    -1,
      -1,    -1,    -1,    -1,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,    -1,   115,   116,   117,
       5,     6,     7,   121,    -1,    -1,    -1,    -1,    -1,    -1,
      15,    16,    17,    18,    19,    20,    -1,    22,    -1,    -1,
      -1,    -1,    27,    28,    -1,    30,    31,    32,    -1,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    43,    44,
      -1,    46,    -1,    48,    49,    -1,    51,    52,    53,    54,
      -1,    56,    57,    58,    -1,    -1,    -1,    -1,    -1,    64,
      -1,    66,    -1,    -1,    -1,    -1,    71,    -1,    73,    -1,
      75,    76,    77,    78,    -1,    -1,    -1,    82,    -1,    -1,
      -1,    -1,    -1,    -1,    89,    90,    -1,    92,    93,    94,
      95,    96,    -1,    -1,    -1,    -1,    -1,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,    -1,
     115,   116,   117,     5,     6,     7,   121,    -1,    -1,    -1,
      -1,    -1,    -1,    15,    16,    17,    18,    19,    20,    -1,
      22,    23,    -1,    -1,    -1,    27,    28,    29,    30,    31,
      -1,    -1,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    43,    44,    -1,    46,    -1,    48,    49,    -1,    51,
      52,    53,    54,    -1,    56,    57,    58,    -1,    -1,    -1,
      -1,    -1,    64,    -1,    66,    -1,    -1,    -1,    -1,    71,
      -1,    73,    -1,    75,    76,    77,    78,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    89,    90,    -1,
      92,    93,    94,    95,    96,    -1,    -1,    -1,    -1,    -1,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,    -1,   115,   116,   117,     5,     6,     7,   121,
      -1,    -1,    -1,    -1,    -1,    -1,    15,    16,    17,    18,
      19,    20,    -1,    22,    -1,    -1,    -1,    -1,    27,    28,
      29,    30,    31,    -1,    -1,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    43,    44,    -1,    46,    -1,    48,
      49,    -1,    51,    52,    53,    54,    -1,    56,    57,    58,
      -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    -1,
      -1,    -1,    71,    -1,    73,    -1,    75,    76,    77,    78,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      89,    90,    -1,    92,    93,    94,    95,    96,    -1,    -1,
      -1,    -1,    -1,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,    -1,   115,   116,   117,     5,
       6,     7,   121,    -1,    -1,    -1,    -1,    -1,    -1,    15,
      16,    17,    18,    19,    20,    -1,    22,    23,    -1,    -1,
      -1,    27,    28,    -1,    30,    31,    -1,    -1,    34,    35,
      36,    37,    38,    39,    40,    -1,    42,    43,    44,    -1,
      46,    -1,    48,    49,    -1,    51,    52,    53,    54,    -1,
      56,    57,    58,    -1,    -1,    -1,    -1,    -1,    64,    -1,
      66,    -1,    -1,    -1,    -1,    71,    -1,    73,    -1,    75,
      76,    77,    78,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    89,    90,    -1,    92,    93,    94,    95,
      96,    -1,    -1,    -1,    -1,    -1,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,    -1,   115,
     116,   117,     5,     6,     7,   121,    -1,    -1,    -1,    -1,
      -1,    -1,    15,    16,    17,    18,    19,    20,    -1,    22,
      -1,    -1,    -1,    -1,    27,    28,    29,    30,    31,    -1,
      -1,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      43,    44,    -1,    46,    -1,    48,    49,    -1,    51,    52,
      53,    54,    -1,    56,    57,    58,    -1,    -1,    -1,    -1,
      -1,    64,    -1,    66,    -1,    -1,    -1,    -1,    71,    -1,
      73,    -1,    75,    76,    77,    78,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    89,    90,    -1,    92,
      93,    94,    95,    96,    -1,    -1,    -1,    -1,    -1,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,    -1,   115,   116,   117,     5,     6,     7,   121,    -1,
      -1,    -1,    -1,    -1,    -1,    15,    16,    17,    18,    19,
      20,    -1,    22,    -1,    -1,    -1,    -1,    27,    28,    29,
      30,    31,    -1,    -1,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    43,    44,    -1,    46,    -1,    48,    49,
      -1,    51,    52,    53,    54,    -1,    56,    57,    58,    -1,
      -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    -1,    -1,
      -1,    71,    -1,    73,    -1,    75,    76,    77,    78,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    89,
      90,    -1,    92,    93,    94,    95,    96,    -1,    -1,    -1,
      -1,    -1,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,    -1,   115,   116,   117,     5,     6,
       7,   121,    -1,    -1,    -1,    -1,    -1,    -1,    15,    16,
      17,    18,    19,    20,    -1,    22,    -1,    -1,    -1,    -1,
      27,    28,    29,    30,    31,    -1,    -1,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    43,    44,    -1,    46,
      -1,    48,    49,    -1,    51,    52,    53,    54,    -1,    56,
      57,    58,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,
      -1,    -1,    -1,    -1,    71,    -1,    73,    -1,    75,    76,
      77,    78,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    89,    90,    -1,    92,    93,    94,    95,    96,
      -1,    -1,    -1,    -1,    -1,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,    -1,   115,   116,
     117,     5,     6,     7,   121,    -1,    -1,    -1,    -1,    -1,
      -1,    15,    16,    17,    18,    19,    20,    -1,    22,    -1,
      -1,    -1,    -1,    27,    28,    -1,    30,    31,    -1,    -1,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    43,
      44,    -1,    46,    -1,    48,    49,    -1,    51,    52,    53,
      54,    -1,    56,    57,    58,    -1,    -1,    -1,    -1,    -1,
      64,    -1,    66,    -1,    -1,    -1,    -1,    71,    -1,    73,
      -1,    75,    76,    77,    78,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    89,    90,    -1,    92,    93,
      94,    95,    96,    -1,    -1,    -1,    -1,    -1,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
      -1,   115,   116,   117,     5,     6,     7,   121,    -1,    -1,
      -1,    -1,    -1,    -1,    15,    16,    17,    18,    19,    20,
      -1,    22,    -1,    -1,    -1,    -1,    27,    28,    -1,    30,
      31,    -1,    -1,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    43,    44,    -1,    46,    -1,    48,    49,    -1,
      51,    52,    53,    54,    -1,    56,    57,    58,    -1,    -1,
      -1,    -1,    -1,    64,    -1,    66,    -1,    -1,    -1,    -1,
      71,    -1,    73,    -1,    75,    76,    77,    78,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    89,    90,
      -1,    -1,    93,    94,    95,    96,    -1,    -1,    -1,    -1,
      -1,   102,   103,   104,   105,   106,   107,   108,    -1,   110,
     111,   112,   113,    -1,   115,   116,   117,     5,     6,     7,
     121,    -1,    -1,    -1,    -1,    -1,    -1,    15,    -1,    -1,
      18,    19,    20,    -1,    22,    -1,    -1,    -1,    -1,    27,
      28,    -1,    30,    31,    -1,    -1,    -1,    35,    36,    37,
      38,    -1,    -1,    -1,    42,    43,    -1,    -1,    46,    -1,
      48,    -1,    -1,    51,    52,    53,    54,    -1,    56,    -1,
      58,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,
      -1,    -1,    -1,    71,    -1,    73,    -1,    75,    76,    77,
      78,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    89,    90,    -1,    92,    93,    94,    -1,    96,    97,
      -1,    -1,    -1,    -1,   102,   103,   104,    -1,   106,    -1,
     108,    -1,   110,   111,   112,   113,    -1,   115,   116,   117,
       6,     7,    -1,   121,    -1,    -1,    -1,    -1,    -1,    15,
      16,    17,    18,    19,    20,    -1,    22,    -1,    -1,    -1,
      -1,    27,    28,    29,    30,    31,    -1,    -1,    34,    35,
      36,    37,    38,    39,    40,    -1,    42,    43,    44,    -1,
      46,    -1,    48,    49,    -1,    51,    52,    53,    54,    -1,
      56,    57,    58,    -1,    -1,    -1,    -1,    -1,    64,    -1,
      66,    -1,    -1,    -1,    -1,    -1,    -1,    73,    -1,    -1,
      76,    -1,    78,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    89,    90,    -1,    -1,    -1,    94,    95,
      96,    -1,    -1,    -1,    -1,    -1,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,    -1,   115,
     116,   117,     6,     7,    -1,   121,    -1,    -1,    -1,    -1,
      -1,    15,    16,    17,    18,    19,    20,    -1,    22,    -1,
      -1,    -1,    -1,    27,    28,    29,    30,    31,    -1,    -1,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    43,
      44,    -1,    46,    -1,    48,    49,    -1,    51,    52,    53,
      54,    -1,    56,    57,    58,     5,     6,     7,     8,    -1,
      64,    -1,    66,    -1,    -1,    -1,    -1,    -1,    -1,    73,
      -1,    -1,    76,    -1,    78,    49,    50,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    89,    90,    -1,    38,    -1,
      94,    95,    96,    -1,    -1,    -1,    -1,    -1,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
      -1,   115,   116,   117,    -1,    65,    -1,   121,     5,     6,
       7,    -1,    96,    -1,    98,    99,    -1,    77,    -1,    -1,
      49,    50,    -1,    -1,    -1,    -1,   110,   111,   112,   113,
      -1,    -1,   116,    93,    94,    -1,    96,   121,    -1,    -1,
      -1,    -1,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,    -1,    -1,   116,   117,   118,    -1,
     120,    -1,    -1,    -1,    -1,    -1,    -1,    96,    65,    98,
      99,    -1,    -1,    -1,    71,    -1,    -1,    -1,    75,    -1,
      77,   110,   111,   112,   113,    -1,    -1,   116,    -1,    -1,
      -1,    -1,   121,    90,    -1,    -1,    93,    94,    -1,    96,
      -1,    -1,    -1,    -1,    -1,   102,   103,   104,    -1,   106,
      12,    -1,    14,   110,   111,   112,    -1,    -1,   115,    21,
     117,    -1,    24,    25,    26,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    12,    -1,    14,    -1,    41,
      -1,    43,    -1,    45,    21,    -1,    48,    24,    25,    26,
      -1,    -1,    -1,    55,    56,    57,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    41,    -1,    43,    -1,    45,    -1,
      -1,    48,    -1,    -1,    -1,    -1,    -1,    -1,    55,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    96,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
     112,   113,    -1,    -1,   116,    -1,    -1,    -1,    -1,    96,
     122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,   112,   113,    -1,    -1,   116,
      -1,    -1,    -1,    -1,    -1,   122,    15,    16,    17,    18,
      19,    20,    -1,    22,    -1,    -1,    -1,    -1,    27,    28,
      -1,    30,    31,    -1,    -1,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    43,    44,    -1,    46,    -1,    48,
      49,    -1,    51,    52,    53,    54,    -1,    56,    57,    58,
      -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    -1,
      -1,    -1,    -1,    -1,    73,    -1,    -1,    76,    -1,    78,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      89,    90,    -1,    -1,    -1,    -1,    95,    96,    -1,    -1,
      -1,    -1,    -1,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,    -1,   115,   116,   117,    -1,
      15,    -1,   121,    18,    19,    20,    -1,    22,    -1,    -1,
      -1,    -1,    27,    28,    -1,    30,    31,    32,    -1,    34,
      35,    36,    37,    38,    -1,    40,    -1,    42,    43,    44,
      -1,    46,    -1,    48,    -1,    -1,    51,    52,    53,    54,
      -1,    56,    -1,    58,    -1,    -1,    -1,    -1,    -1,    64,
      -1,    66,    -1,    -1,    -1,    -1,    -1,    -1,    73,    -1,
      -1,    76,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    89,    90,    -1,    -1,    -1,    -1,
      -1,    96,    97,    -1,    -1,    -1,    -1,   102,   103,   104,
      -1,   106,    -1,   108,    -1,   110,   111,   112,   113,    -1,
     115,   116,    -1,    -1,    15,    -1,   121,    18,    19,    20,
      -1,    22,    -1,    -1,    -1,    -1,    27,    28,    -1,    30,
      31,    -1,    -1,    -1,    35,    36,    37,    38,    -1,    -1,
      -1,    42,    43,    -1,    -1,    46,    -1,    48,    -1,    -1,
      51,    52,    53,    54,    -1,    56,    -1,    58,    -1,    -1,
      -1,    -1,    -1,    64,    -1,    66,    -1,    -1,    -1,    -1,
      -1,    -1,    73,    -1,    -1,    76,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    89,    90,
      -1,    -1,    -1,    -1,    -1,    -1,    97,    -1,    -1,    -1,
      -1,   102,   103,   104,    -1,   106,    15,   108,    -1,    18,
      19,    20,   113,    22,   115,   116,    -1,    -1,    27,    28,
     121,    30,    31,    -1,    -1,    -1,    35,    36,    37,    -1,
      -1,    -1,    -1,    42,    43,    -1,    -1,    46,    -1,    48,
      -1,    -1,    51,    52,    53,    54,    -1,    56,    -1,    58,
      -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    -1,
      -1,    -1,    -1,    -1,    73,    -1,    -1,    76,    -1,    -1,
      15,    -1,    -1,    -1,    19,    20,    -1,    22,    -1,    -1,
      89,    90,    27,    28,    -1,    30,    31,    -1,    -1,    -1,
      35,    36,    37,   102,   103,    -1,    -1,    42,    -1,   108,
      -1,    46,    -1,    -1,    -1,    -1,    51,    -1,    53,    54,
      -1,    -1,   121,    58,    -1,    -1,    -1,    -1,    -1,    64,
      -1,    66,    -1,    -1,    -1,    -1,    -1,    -1,    73,    -1,
      -1,    76,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    89,    90,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   102,   103,   104,
      -1,   106,    15,   108,    -1,    -1,    19,    20,    -1,    22,
     115,    -1,    -1,    -1,    27,    28,   121,    30,    31,    -1,
      -1,    -1,    35,    36,    37,    -1,    -1,    -1,    -1,    42,
      -1,    -1,    -1,    46,    -1,    -1,    -1,    -1,    51,    -1,
      53,    -1,    -1,    -1,    -1,    58,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    66,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   102,
     103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   121
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,    86,   130,   132,   131,     0,     1,    15,    16,    17,
      19,    20,    22,    27,    28,    30,    31,    33,    34,    35,
      36,    37,    38,    39,    40,    42,    44,    46,    49,    51,
      53,    58,    66,    87,    96,   102,   103,   110,   111,   112,
     113,   116,   121,   133,   134,   136,   140,   145,   146,   147,
     148,   157,   160,   163,   169,   170,   171,   173,   177,   183,
     184,   185,   186,   194,   196,   198,   199,   200,   201,   219,
     223,   224,   225,   304,   306,   307,   308,     1,     5,     6,
       7,    18,    22,    33,    43,    48,    52,    54,    56,    57,
      64,    71,    73,    75,    76,    77,    78,    89,    90,    92,
      93,    94,    95,    97,   102,   104,   105,   106,   107,   108,
     110,   111,   112,   113,   115,   116,   117,   134,   135,   138,
     140,   141,   142,   145,   150,   151,   152,   153,   157,   160,
     163,   169,   175,   178,   179,   180,   181,   182,   187,   188,
     199,   226,   238,   239,   244,   245,   246,   250,   252,   253,
     254,   255,   262,   263,   264,   269,   272,   273,   277,   285,
     286,   287,   288,   289,   299,   304,   306,   307,   308,   309,
     103,   177,   121,   121,   113,   116,   135,   242,   113,   116,
     135,   241,   242,   305,   113,   116,   135,   241,   121,   177,
     177,   242,   176,   120,    80,    84,    85,   207,   209,   211,
     215,   216,   211,   176,    32,   144,   120,   123,   121,     1,
     112,   122,   136,   148,   174,   306,   307,   179,   196,   197,
     198,   244,   285,    13,   195,   201,   191,   192,    49,    50,
      98,    99,   113,   116,   121,   138,   310,   311,   313,   314,
     316,   317,   319,   326,   327,   328,   330,   123,    78,    78,
     267,   267,   242,   121,   142,    78,   113,   116,   135,   203,
     204,   205,   206,   234,   235,   204,   237,   203,   236,    78,
     113,   116,   135,   240,   272,   308,   236,   103,   138,   189,
     190,   247,   283,   270,   271,   273,   105,   274,   271,   271,
     274,    80,    84,   211,   213,    80,    84,   213,     9,    10,
     258,   260,   261,   258,   105,   271,    80,    84,   213,   258,
      78,   141,   267,    29,    43,    52,    94,   113,   116,   117,
     138,   180,   182,   253,   269,   273,   308,    81,   271,   270,
     271,   302,     6,     7,     8,    65,   113,   116,   117,   118,
     120,   138,   151,   219,   255,   256,   266,   268,   306,   308,
     276,   251,   251,   271,   251,    98,   324,   327,    87,   158,
      87,   161,   123,   220,   103,   221,   222,   123,    98,   311,
     313,   327,    78,   105,   138,   301,   164,   166,   220,     1,
      67,   180,   203,    84,   210,   215,   217,   218,    80,    82,
      82,   122,   121,   203,   227,    78,   113,   116,   117,   138,
     149,   150,   182,   206,   252,   285,   296,   297,   298,   299,
     300,   308,   153,   172,   182,   195,   191,    13,   201,   188,
     331,   315,    79,    80,    83,    85,   322,    79,   322,   323,
     318,   312,   100,   101,   314,   326,   328,   329,   330,   149,
     123,   156,    10,   120,   227,   123,   204,   229,   230,   231,
     123,   272,   123,   121,    65,    90,   103,   138,   219,   248,
     249,   253,   263,   264,   265,    72,    74,    78,   113,   116,
     127,   135,   278,   280,   282,   308,   251,   120,   251,    80,
      84,   214,   217,    80,   217,    80,     9,    10,   217,    80,
     235,   236,   176,   251,   288,   251,    59,    60,    61,    63,
     291,     8,   303,   324,   124,   253,   251,    79,    80,   325,
      29,    98,     1,   112,   122,   136,   159,   160,   163,   168,
     169,   199,   304,   308,     1,   112,   122,   136,   162,   163,
     168,   199,   304,   308,   241,   191,   201,   241,   178,     1,
     122,   138,   165,   167,   169,   178,   191,    80,    82,    78,
      92,    95,   109,   111,   112,   113,   116,   117,   134,   137,
     139,   140,   145,   153,   157,   160,   163,   169,   182,   188,
     252,   263,   264,   299,   304,   308,   309,    81,    84,   207,
     212,    91,   109,   114,   202,   208,   273,   285,   288,   299,
     109,   202,   208,   273,   285,   288,   299,   143,   123,   105,
      78,   117,   298,    10,   120,   251,   117,   118,   124,   126,
     221,   191,   121,   121,   323,   323,   323,   323,   122,   313,
     327,   329,   332,    81,   241,    12,    14,    21,    24,    25,
      26,    41,    43,    45,    48,    55,    56,   122,   135,   138,
     154,   155,   188,   228,   232,   233,   242,   204,   204,     6,
       7,    94,   111,   117,   139,   152,   206,   239,   243,   269,
     285,   300,    81,   152,   243,   123,   295,   301,   193,   251,
     302,   280,     8,    68,    69,    70,   117,   118,   125,   126,
     279,   281,   214,   217,    80,   152,    80,    84,   207,   213,
     152,   207,   152,   207,   123,   123,   263,   263,   290,   123,
     128,   257,    78,    95,   105,   135,   275,    79,   323,   325,
     323,   325,   325,   144,   144,   221,   184,   144,    84,   210,
     218,   202,   208,   273,   285,   299,    78,   105,   107,    80,
      78,    92,   111,   113,   116,   117,   139,   252,   263,   264,
     299,   308,    23,   274,    10,   120,   112,   122,   136,   148,
     149,   227,   227,   297,   297,   298,   298,   221,   164,   164,
     103,   113,   121,   138,   223,   320,   313,   311,   327,   332,
     329,   229,   229,   242,   199,   113,   116,   138,   123,    80,
      84,   300,    10,   120,   102,   110,   306,   109,   202,   295,
     117,   122,   154,   233,   303,    84,   210,   214,   217,    80,
     152,   152,   152,   117,    78,    88,   291,   292,   293,   294,
     258,   270,   323,    80,    78,    92,   105,   107,   111,   113,
     116,   117,   139,   252,   263,   264,   308,    23,   212,    78,
     105,   107,   276,   203,   203,   122,   122,   321,   123,   243,
     217,    80,   227,   227,    80,    84,    80,    84,    98,   327,
      10,   120,   204,   301,   257,    80,   207,    62,   118,   120,
     258,   259,   218,    78,   105,   107,   251,   142,   243,    43,
      52,   117,    84,   207,   217,    80,   217,    80,    80,    98,
     204,   204,   251,   294,    47,   284,   122,   235,   236,    80,
     207,   207,   323,   251,   123,   123,   207
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_int16 yyr1[] =
{
       0,   129,   130,   131,   130,   132,   132,   132,   132,   132,
     133,   133,   133,   133,   133,   133,   133,   133,   133,   133,
     133,   134,   134,   135,   135,   136,   136,   136,   137,   137,
     137,   137,   137,   137,   137,   137,   137,   137,   137,   137,
     137,   138,   138,   138,   139,   139,   139,   140,   141,   141,
     141,   142,   142,   142,   142,   142,   142,   142,   142,   143,
     143,   143,   143,   144,   146,   145,   147,   147,   148,   148,
     148,   149,   149,   149,   149,   149,   150,   150,   150,   150,
     150,   150,   150,   150,   150,   150,   150,   150,   150,   150,
     150,   151,   151,   151,   151,   151,   151,   151,   151,   151,
     152,   152,   152,   152,   152,   152,   152,   152,   153,   154,
     155,   154,   156,   156,   156,   156,   157,   158,   158,   158,
     158,   158,   158,   158,   158,   158,   158,   159,   158,   158,
     160,   161,   161,   161,   161,   161,   161,   161,   161,   161,
     162,   161,   161,   163,   164,   164,   165,   165,   165,   166,
     166,   167,   166,   168,   169,   170,   170,   170,   171,   172,
     172,   173,   173,   173,   173,   174,   173,   173,   175,   175,
     175,   176,   176,   176,   177,   178,   178,   178,   179,   180,
     180,   180,   180,   180,   181,   182,   182,   183,   183,   184,
     184,   185,   185,   185,   186,   186,   187,   187,   187,   189,
     188,   188,   190,   190,   191,   192,   192,   193,   193,   193,
     194,   194,   195,   195,   196,   196,   196,   196,   196,   197,
     197,   197,   198,   198,   198,   199,   199,   199,   200,   200,
     200,   201,   201,   202,   202,   202,   203,   203,   203,   204,
     204,   205,   205,   206,   206,   207,   207,   207,   207,   207,
     207,   207,   207,   207,   207,   207,   207,   207,   207,   208,
     209,   209,   209,   209,   209,   209,   209,   209,   210,   210,
     210,   210,   210,   210,   210,   210,   210,   210,   210,   210,
     210,   210,   210,   210,   210,   210,   210,   210,   210,   211,
     211,   212,   212,   213,   213,   213,   213,   214,   214,   214,
     214,   215,   215,   215,   215,   215,   215,   215,   215,   215,
     215,   215,   215,   216,   216,   216,   216,   216,   216,   216,
     216,   216,   216,   217,   217,   217,   218,   218,   219,   220,
     220,   222,   221,   221,   223,   223,   224,   224,   224,   224,
     224,   225,   225,   225,   225,   226,   227,   228,   228,   228,
     228,   229,   230,   231,   231,   231,   231,   232,   232,   232,
     232,   232,   232,   232,   232,   232,   233,   233,   233,   233,
     234,   235,   235,   236,   237,   238,   238,   238,   238,   239,
     239,   239,   240,   240,   240,   240,   241,   241,   241,   242,
     242,   242,   243,   243,   243,   243,   243,   243,   243,   243,
     244,   244,   244,   244,   244,   245,   246,   246,   247,   247,
     248,   248,   248,   248,   249,   249,   249,   250,   251,   251,
     252,   252,   252,   252,   252,   252,   252,   252,   253,   253,
     254,   255,   255,   255,   255,   256,   256,   257,   257,   258,
     258,   258,   259,   260,   260,   261,   261,   262,   263,   264,
     264,   265,   265,   266,   266,   266,   266,   267,   268,   268,
     268,   268,   268,   268,   268,   269,   269,   269,   270,   270,
     271,   272,   272,   273,   274,   274,   275,   275,   276,   276,
     276,   276,   277,   277,   278,   278,   278,   278,   278,   279,
     279,   279,   280,   280,   280,   280,   280,   281,   281,   281,
     281,   282,   282,   283,   283,   284,   284,   285,   285,   286,
     286,   287,   287,   287,   287,   288,   289,   289,   290,   290,
     291,   291,   291,   291,   292,   292,   292,   293,   293,   294,
     294,   294,   295,   295,   296,   296,   296,   297,   297,   297,
     298,   298,   299,   299,   299,   300,   300,   300,   301,   301,
     301,   302,   302,   303,   303,   305,   304,   306,   307,   308,
     308,   309,   310,   310,   310,   312,   311,   313,   313,   314,
     314,   314,   315,   314,   316,   317,   318,   318,   318,   319,
     321,   320,   322,   322,   322,   322,   322,   322,   322,   323,
     323,   324,   324,   325,   325,   325,   325,   326,   327,   327,
     328,   328,   329,   329,   331,   330,   330,   330,   332,   332
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     0,     3,     0,     2,     2,     2,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     2,     2,     1,
       2,     0,     1,     1,     1,     2,     3,     1,     2,     0,
       2,     2,     2,     4,     0,     2,     1,     1,     3,     5,
       3,     1,     1,     3,     3,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     2,     2,     2,     4,     4,     4,     5,     5,     5,
       1,     3,     3,     4,     4,     3,     2,     1,     4,     1,
       0,     2,     0,     2,     2,     2,     4,     0,     1,     2,
       2,     2,     2,     2,     2,     2,     2,     0,     3,     2,
       4,     0,     1,     2,     2,     2,     2,     2,     2,     2,
       0,     3,     2,     4,     1,     2,     1,     1,     1,     0,
       2,     0,     3,     1,     2,     1,     1,     1,     1,     1,
       1,     2,     2,     2,     2,     0,     3,     2,     4,     5,
       2,     0,     2,     2,     3,     1,     1,     1,     1,     1,
       1,     1,     3,     2,     1,     1,     1,     4,     5,     2,
       2,     1,     2,     1,     2,     3,     1,     1,     1,     0,
       5,     2,     1,     1,     1,     0,     2,     0,     2,     2,
       4,     4,     3,     4,     1,     1,     1,     3,     5,     1,
       1,     1,     3,     2,     2,     1,     1,     2,     1,     1,
       1,     1,     1,     1,     3,     3,     1,     3,     3,     1,
       1,     1,     1,     1,     1,     1,     4,     5,     5,     5,
       4,     4,     3,     3,     3,     3,     3,     3,     3,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     1,     4,
       4,     4,     4,     4,     4,     4,     4,     5,     5,     5,
       4,     4,     4,     4,     3,     3,     3,     3,     3,     1,
       4,     1,     3,     2,     2,     3,     3,     2,     2,     3,
       3,     1,     3,     3,     3,     4,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     4,     4,     1,     4,     2,     1,     3,     2,     0,
       2,     0,     2,     1,     2,     3,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     4,     1,     3,     2,     4,
       2,     3,     1,     1,     5,     5,     4,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     2,     2,     2,
       1,     1,     2,     1,     1,     4,     3,     4,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     2,     1,     3,     3,
       2,     3,     3,     1,     1,     3,     3,     3,     0,     2,
       5,     2,     1,     1,     1,     1,     1,     2,     0,     2,
       1,     2,     1,     1,     2,     2,     2,     2,     1,     2,
       1,     1,     1,     1,     1,     1,     1,     0,     2,     0,
       1,     1,     1,     1,     2,     1,     2,     2,     2,     1,
       2,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     0,     1,
       1,     2,     2,     2,     0,     2,     1,     1,     0,     3,
       3,     3,     1,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     2,     2,     1,     1,     1,
       1,     1,     2,     0,     2,     0,     1,     8,     2,     2,
       2,     1,     1,     1,     1,     3,     2,     4,     0,     2,
       1,     1,     2,     2,     1,     1,     1,     1,     3,     1,
       2,     2,     1,     3,     3,     3,     1,     1,     3,     3,
       2,     1,     1,     1,     2,     1,     1,     2,     1,     1,
       1,     0,     2,     0,     2,     0,     3,     1,     2,     2,
       1,     3,     1,     2,     1,     0,     3,     1,     1,     1,
       1,     2,     0,     5,     2,     3,     0,     2,     2,     2,
       0,     4,     3,     3,     3,     3,     3,     3,     1,     1,
       3,     2,     3,     2,     2,     2,     2,     3,     1,     2,
       1,     1,     1,     1,     0,     5,     2,     2,     2,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (&yylloc, parser, retval, YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF

/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

# ifndef YY_LOCATION_PRINT
#  if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static int
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  int res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#   define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

#  else
#   define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#  endif
# endif /* !defined YY_LOCATION_PRINT */


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, Location, parser, retval); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, Lily_parser *parser, SCM *retval)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  YY_USE (yylocationp);
  YY_USE (parser);
  YY_USE (retval);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yykind < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yykind], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, Lily_parser *parser, SCM *retval)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  YY_LOCATION_PRINT (yyo, *yylocationp);
  YYFPRINTF (yyo, ": ");
  yy_symbol_value_print (yyo, yykind, yyvaluep, yylocationp, parser, retval);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp,
                 int yyrule, Lily_parser *parser, SCM *retval)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)],
                       &(yylsp[(yyi + 1) - (yynrhs)]), parser, retval);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule, parser, retval); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


/* Context of a parse error.  */
typedef struct
{
  yy_state_t *yyssp;
  yysymbol_kind_t yytoken;
  YYLTYPE *yylloc;
} yypcontext_t;

/* Put in YYARG at most YYARGN of the expected tokens given the
   current YYCTX, and return the number of tokens stored in YYARG.  If
   YYARG is null, return the number of expected tokens (guaranteed to
   be less than YYNTOKENS).  Return YYENOMEM on memory exhaustion.
   Return 0 if there are more than YYARGN expected tokens, yet fill
   YYARG up to YYARGN. */
static int
yypcontext_expected_tokens (const yypcontext_t *yyctx,
                            yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  int yyn = yypact[+*yyctx->yyssp];
  if (!yypact_value_is_default (yyn))
    {
      /* Start YYX at -YYN if negative to avoid negative indexes in
         YYCHECK.  In other words, skip the first -YYN actions for
         this state because they are default actions.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;
      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yyx;
      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
        if (yycheck[yyx + yyn] == yyx && yyx != YYSYMBOL_YYerror
            && !yytable_value_is_error (yytable[yyx + yyn]))
          {
            if (!yyarg)
              ++yycount;
            else if (yycount == yyargn)
              return 0;
            else
              yyarg[yycount++] = YY_CAST (yysymbol_kind_t, yyx);
          }
    }
  if (yyarg && yycount == 0 && 0 < yyargn)
    yyarg[0] = YYSYMBOL_YYEMPTY;
  return yycount;
}




#ifndef yystrlen
# if defined __GLIBC__ && defined _STRING_H
#  define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
# else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
# endif
#endif

#ifndef yystpcpy
# if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#  define yystpcpy stpcpy
# else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
# endif
#endif

#ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYPTRDIFF_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYPTRDIFF_T yyn = 0;
      char const *yyp = yystr;
      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (yyres)
    return yystpcpy (yyres, yystr) - yyres;
  else
    return yystrlen (yystr);
}
#endif


static int
yy_syntax_error_arguments (const yypcontext_t *yyctx,
                           yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yyctx->yytoken != YYSYMBOL_YYEMPTY)
    {
      int yyn;
      if (yyarg)
        yyarg[yycount] = yyctx->yytoken;
      ++yycount;
      yyn = yypcontext_expected_tokens (yyctx,
                                        yyarg ? yyarg + 1 : yyarg, yyargn - 1);
      if (yyn == YYENOMEM)
        return YYENOMEM;
      else
        yycount += yyn;
    }
  return yycount;
}

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return -1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return YYENOMEM if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                const yypcontext_t *yyctx)
{
  enum { YYARGS_MAX = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  yysymbol_kind_t yyarg[YYARGS_MAX];
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* Actual size of YYARG. */
  int yycount = yy_syntax_error_arguments (yyctx, yyarg, YYARGS_MAX);
  if (yycount == YYENOMEM)
    return YYENOMEM;

  switch (yycount)
    {
#define YYCASE_(N, S)                       \
      case N:                               \
        yyformat = S;                       \
        break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
    }

  /* Compute error message size.  Don't count the "%s"s, but reserve
     room for the terminator.  */
  yysize = yystrlen (yyformat) - 2 * yycount + 1;
  {
    int yyi;
    for (yyi = 0; yyi < yycount; ++yyi)
      {
        YYPTRDIFF_T yysize1
          = yysize + yytnamerr (YY_NULLPTR, yytname[yyarg[yyi]]);
        if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
          yysize = yysize1;
        else
          return YYENOMEM;
      }
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return -1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yytname[yyarg[yyi++]]);
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, YYLTYPE *yylocationp, Lily_parser *parser, SCM *retval)
{
  YY_USE (yyvaluep);
  YY_USE (yylocationp);
  YY_USE (parser);
  YY_USE (retval);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}






/*----------.
| yyparse.  |
`----------*/

int
yyparse (Lily_parser *parser, SCM *retval)
{
/* Lookahead token kind.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

/* Location data for the lookahead symbol.  */
static YYLTYPE yyloc_default
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
YYLTYPE yylloc = yyloc_default;

    /* Number of syntax errors so far.  */
    int yynerrs = 0;

    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

    /* The location stack: array, bottom, top.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls = yylsa;
    YYLTYPE *yylsp = yyls;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

  /* The locations where the error started and ended.  */
  YYLTYPE yyerror_range[3];

  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yyls1, yysize * YYSIZEOF (*yylsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
        yyls = yyls1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex (&yylval, &yylloc, parser);
    }

  if (yychar <= END_OF_FILE)
    {
      yychar = END_OF_FILE;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      yyerror_range[1] = yylloc;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location. */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  yyerror_range[1] = yyloc;
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 3: /* $@1: %empty  */
#line 399 "parser.yy"
                        {
		parser->lexer_->push_note_state ();
	}
#line 3474 "./out/parser.cc"
    break;

  case 4: /* start_symbol: "#{" $@1 embedded_lilypond  */
#line 401 "parser.yy"
                            {
		parser->lexer_->pop_state ();
                *retval = yyvsp[0];
 	}
#line 3483 "./out/parser.cc"
    break;

  case 5: /* lilypond: %empty  */
#line 407 "parser.yy"
                            { yyval = SCM_UNSPECIFIED; }
#line 3489 "./out/parser.cc"
    break;

  case 6: /* lilypond: lilypond toplevel_expression  */
#line 408 "parser.yy"
                                       {
	}
#line 3496 "./out/parser.cc"
    break;

  case 7: /* lilypond: lilypond assignment  */
#line 410 "parser.yy"
                              {
	}
#line 3503 "./out/parser.cc"
    break;

  case 8: /* lilypond: lilypond error  */
#line 412 "parser.yy"
                         {
		parser->error_level_ = 1;
	}
#line 3511 "./out/parser.cc"
    break;

  case 9: /* lilypond: lilypond "\\version-error"  */
#line 415 "parser.yy"
                                {
		parser->error_level_ = 1;
	}
#line 3519 "./out/parser.cc"
    break;

  case 10: /* toplevel_expression: header_block  */
#line 422 "parser.yy"
                     {
		parser->lexer_->set_identifier (ly_symbol2scm ("$defaultheader"), yyvsp[0]);
	}
#line 3527 "./out/parser.cc"
    break;

  case 11: /* toplevel_expression: book_block  */
#line 425 "parser.yy"
                     {
		SCM proc = parser->lexer_->lookup_identifier ("toplevel-book-handler");
		scm_call_1 (proc, yyvsp[0]);
	}
#line 3536 "./out/parser.cc"
    break;

  case 12: /* toplevel_expression: bookpart_block  */
#line 429 "parser.yy"
                         {
		SCM proc = parser->lexer_->lookup_identifier ("toplevel-bookpart-handler");
		scm_call_1 (proc, yyvsp[0]);
	}
#line 3545 "./out/parser.cc"
    break;

  case 13: /* toplevel_expression: BOOK_IDENTIFIER  */
#line 433 "parser.yy"
                          {
		SCM sym = unsmob<Book>(yyvsp[0])->paper_
			? ly_symbol2scm ("toplevel-book-handler")
			: ly_symbol2scm ("toplevel-bookpart-handler");

		SCM proc = parser->lexer_->lookup_identifier_symbol (sym);
		scm_call_1 (proc, yyvsp[0]);
	}
#line 3558 "./out/parser.cc"
    break;

  case 14: /* toplevel_expression: score_block  */
#line 441 "parser.yy"
                      {
		SCM proc = parser->lexer_->lookup_identifier ("toplevel-score-handler");
		scm_call_1 (proc, yyvsp[0]);
	}
#line 3567 "./out/parser.cc"
    break;

  case 15: /* toplevel_expression: composite_music  */
#line 445 "parser.yy"
                          {
		SCM proc = parser->lexer_->lookup_identifier ("toplevel-music-handler");
		scm_call_1 (proc, yyvsp[0]);
	}
#line 3576 "./out/parser.cc"
    break;

  case 16: /* toplevel_expression: full_markup  */
#line 449 "parser.yy"
                      {
		SCM proc = parser->lexer_->lookup_identifier ("toplevel-text-handler");
		scm_call_1 (proc, scm_list_1 (yyvsp[0]));
	}
#line 3585 "./out/parser.cc"
    break;

  case 17: /* toplevel_expression: full_markup_list  */
#line 453 "parser.yy"
                           {
		SCM proc = parser->lexer_->lookup_identifier ("toplevel-text-handler");
		scm_call_1 (proc, yyvsp[0]);
	}
#line 3594 "./out/parser.cc"
    break;

  case 18: /* toplevel_expression: SCM_TOKEN  */
#line 457 "parser.yy"
                    {
		// Evaluate and ignore #xxx, as opposed to \xxx
		parser->lexer_->eval_scm_token (yyvsp[0], (yylsp[0]));
	}
#line 3603 "./out/parser.cc"
    break;

  case 19: /* toplevel_expression: embedded_scm_active  */
#line 462 "parser.yy"
        {
		SCM out = SCM_UNDEFINED;
		if (Text_interface::is_markup (yyvsp[0]))
			out = scm_list_1 (yyvsp[0]);
		else if (Text_interface::is_markup_list (yyvsp[0]))
			out = yyvsp[0];
		if (scm_is_pair (out))
		{
			SCM proc = parser->lexer_->lookup_identifier ("toplevel-text-handler");
			scm_call_1 (proc, out);
		} else if (unsmob<Score> (yyvsp[0]))
		{
			SCM proc = parser->lexer_->lookup_identifier ("toplevel-score-handler");
			scm_call_1 (proc, yyvsp[0]);
		} else if (Output_def * od = unsmob<Output_def> (yyvsp[0])) {
			SCM id = SCM_EOL;

			if (from_scm<bool> (od->c_variable ("is-paper")))
				id = ly_symbol2scm ("$defaultpaper");
			else if (from_scm<bool> (od->c_variable ("is-midi")))
				id = ly_symbol2scm ("$defaultmidi");
			else if (from_scm<bool> (od->c_variable ("is-layout")))
				id = ly_symbol2scm ("$defaultlayout");

			parser->lexer_->set_identifier (id, yyvsp[0]);
		} else if (ly_is_module (yyvsp[0]))
		{
			SCM module = get_header (parser);
			ly_module_copy (module, yyvsp[0]);
			parser->lexer_->set_identifier
				(ly_symbol2scm ("$defaultheader"), module);
		} else if (!scm_is_eq (yyvsp[0], SCM_UNSPECIFIED))
			parser->parser_error ((yylsp[0]), _("bad expression type"));
	}
#line 3642 "./out/parser.cc"
    break;

  case 20: /* toplevel_expression: output_def  */
#line 496 "parser.yy"
                     {
		SCM id = SCM_EOL;
		Output_def * od = unsmob<Output_def> (yyvsp[0]);

		if (from_scm<bool> (od->c_variable ("is-paper")))
			id = ly_symbol2scm ("$defaultpaper");
		else if (from_scm<bool> (od->c_variable ("is-midi")))
			id = ly_symbol2scm ("$defaultmidi");
		else if (from_scm<bool> (od->c_variable ("is-layout")))
			id = ly_symbol2scm ("$defaultlayout");

		parser->lexer_->set_identifier (id, yyvsp[0]);
	}
#line 3660 "./out/parser.cc"
    break;

  case 22: /* lookup: LOOKUP_IDENTIFIER '.' symbol_list_rev  */
#line 514 "parser.yy"
        {
		yyval = loc_on_copy (parser, (yyloc),
				  nested_property (yyvsp[-2], scm_reverse_x (yyvsp[0], SCM_EOL)));
	}
#line 3669 "./out/parser.cc"
    break;

  case 23: /* embedded_scm_bare: SCM_TOKEN  */
#line 522 "parser.yy"
        {
		yyval = parser->lexer_->eval_scm_token (yyvsp[0], (yylsp[0]));
	}
#line 3677 "./out/parser.cc"
    break;

  case 29: /* embedded_scm_bare_arg: SCM_TOKEN  */
#line 537 "parser.yy"
        {
		yyval = parser->lexer_->eval_scm_token (yyvsp[0], (yylsp[0]));
	}
#line 3685 "./out/parser.cc"
    break;

  case 47: /* scm_function_call: SCM_FUNCTION function_arglist  */
#line 577 "parser.yy"
                                      {
		yyval = MAKE_SYNTAX (music_function, (yyloc),
				  yyvsp[-1], yyvsp[0]);
	}
#line 3694 "./out/parser.cc"
    break;

  case 48: /* embedded_lilypond_number: '-' embedded_lilypond_number  */
#line 585 "parser.yy"
        {
		yyval = scm_difference (yyvsp[0], SCM_UNDEFINED);
	}
#line 3702 "./out/parser.cc"
    break;

  case 50: /* embedded_lilypond_number: UNSIGNED NUMBER_IDENTIFIER  */
#line 590 "parser.yy"
        {
		yyval = scm_product (yyvsp[-1], yyvsp[0]);
	}
#line 3710 "./out/parser.cc"
    break;

  case 51: /* embedded_lilypond: %empty  */
#line 597 "parser.yy"
        {
		// FIXME: @$ does not contain a useful source location
		// for empty rules, and the only token in the whole
		// production, EMBEDDED_LILY, is synthetic and also
		// contains no source location.
		yyval = MAKE_SYNTAX (void_music, (yyloc));
	}
#line 3722 "./out/parser.cc"
    break;

  case 54: /* embedded_lilypond: post_event  */
#line 607 "parser.yy"
        {
		if (!unsmob<Music> (yyvsp[0]))
			yyval = MY_MAKE_MUSIC ("PostEvents", (yyloc))->unprotect ();
	}
#line 3731 "./out/parser.cc"
    break;

  case 55: /* embedded_lilypond: duration post_events  */
#line 612 "parser.yy"
        {
		if (scm_is_pair (yyvsp[0])) {
			Music *n = MY_MAKE_MUSIC ("NoteEvent", (yyloc));

			parser->default_duration_ = *unsmob<Duration> (yyvsp[-1]);
			set_property (n, "duration", yyvsp[-1]);
			set_property (n, "articulations",
					 scm_reverse_x (yyvsp[0], SCM_EOL));
			yyval = n->unprotect ();
		}
	}
#line 3747 "./out/parser.cc"
    break;

  case 56: /* embedded_lilypond: music_embedded music_embedded music_list  */
#line 623 "parser.yy"
                                                   {
		SCM tail = SCM_EOL;
		if (unsmob<Music> (yyvsp[-2]))
			tail = scm_cons (yyvsp[-2], tail);
		if (unsmob<Music> (yyvsp[-1]))
			tail = scm_cons (yyvsp[-1], tail);
		yyval = reverse_music_list (parser, (yyloc),
					 scm_append_x (scm_list_2 (yyvsp[0], tail)),
					 true, true);
		if (scm_is_pair (yyval)) // unpackaged list
			if (scm_is_null (scm_cdr (yyval)))
				yyval = scm_car (yyval); // single expression
			else
				yyval = MAKE_SYNTAX (sequential_music, (yyloc), yyval);
		else if (scm_is_null (yyval))
			yyval = MAKE_SYNTAX (void_music, (yyloc));
		// else already packaged post-event
	}
#line 3770 "./out/parser.cc"
    break;

  case 57: /* embedded_lilypond: error  */
#line 641 "parser.yy"
                {
		parser->error_level_ = 1;
                yyval = SCM_UNSPECIFIED;
	}
#line 3779 "./out/parser.cc"
    break;

  case 58: /* embedded_lilypond: "\\version-error" embedded_lilypond  */
#line 645 "parser.yy"
                                    {
		parser->error_level_ = 1;
                yyval = yyvsp[0];
	}
#line 3788 "./out/parser.cc"
    break;

  case 59: /* lilypond_header_body: %empty  */
#line 653 "parser.yy"
                    { yyval = SCM_UNSPECIFIED; }
#line 3794 "./out/parser.cc"
    break;

  case 60: /* lilypond_header_body: lilypond_header_body assignment  */
#line 654 "parser.yy"
                                           {

	}
#line 3802 "./out/parser.cc"
    break;

  case 61: /* lilypond_header_body: lilypond_header_body SCM_TOKEN  */
#line 657 "parser.yy"
                                         {
		// Evaluate and ignore #xxx, as opposed to \xxx
		parser->lexer_->eval_scm_token (yyvsp[0], (yylsp[0]));
	}
#line 3811 "./out/parser.cc"
    break;

  case 62: /* lilypond_header_body: lilypond_header_body embedded_scm_active  */
#line 661 "parser.yy"
                                                   {
		if (ly_is_module (yyvsp[0]))
			ly_module_copy (scm_current_module (), yyvsp[0]);
		else if (!scm_is_eq (yyvsp[0], SCM_UNSPECIFIED))
			parser->parser_error ((yylsp[0]), _("bad expression type"));
	}
#line 3822 "./out/parser.cc"
    break;

  case 63: /* lilypond_header: "\\header" '{' lilypond_header_body '}'  */
#line 670 "parser.yy"
                                                {
		yyval = parser->lexer_->remove_scope ();
	}
#line 3830 "./out/parser.cc"
    break;

  case 64: /* $@2: %empty  */
#line 676 "parser.yy"
        {
		parser->lexer_->add_scope (get_header (parser));
	}
#line 3838 "./out/parser.cc"
    break;

  case 65: /* header_block: $@2 lilypond_header  */
#line 678 "parser.yy"
                          {
		yyval = yyvsp[0];
	}
#line 3846 "./out/parser.cc"
    break;

  case 66: /* assignment_id: STRING  */
#line 688 "parser.yy"
        {
		yyval = scm_string_to_symbol (yyvsp[0]);
	}
#line 3854 "./out/parser.cc"
    break;

  case 67: /* assignment_id: SYMBOL  */
#line 692 "parser.yy"
        {
		yyval = scm_string_to_symbol (yyvsp[0]);
	}
#line 3862 "./out/parser.cc"
    break;

  case 68: /* assignment: assignment_id '=' identifier_init  */
#line 698 "parser.yy"
                                           {
	        parser->lexer_->set_identifier (yyvsp[-2], yyvsp[0]);
                yyval = SCM_UNSPECIFIED;
	}
#line 3871 "./out/parser.cc"
    break;

  case 69: /* assignment: assignment_id '.' property_path '=' identifier_init  */
#line 702 "parser.yy"
                                                              {
		SCM path = scm_cons (yyvsp[-4], yyvsp[-2]);
		parser->lexer_->set_identifier (path, yyvsp[0]);
                yyval = SCM_UNSPECIFIED;
	}
#line 3881 "./out/parser.cc"
    break;

  case 70: /* assignment: markup_mode_word '=' identifier_init  */
#line 708 "parser.yy"
        {
		if (scm_is_false (Lily::markup_function_p (yyvsp[0])))
		{
			parser->parser_error ((yylsp[0]), _ ("Not a markup function"));
		} else {
			Lily::define_markup_command_internal
 				(scm_string_to_symbol (yyvsp[-2]), yyvsp[0], SCM_BOOL_F);
		}
		yyval = SCM_UNSPECIFIED;
	}
#line 3896 "./out/parser.cc"
    break;

  case 73: /* identifier_init: symbol_list_part_bare '.' property_path  */
#line 725 "parser.yy"
        {
		yyval = scm_reverse_x (yyvsp[-2], yyvsp[0]);
	}
#line 3904 "./out/parser.cc"
    break;

  case 74: /* identifier_init: symbol_list_part_bare ',' property_path  */
#line 729 "parser.yy"
        {
		yyval = scm_reverse_x (yyvsp[-2], yyvsp[0]);
	}
#line 3912 "./out/parser.cc"
    break;

  case 75: /* identifier_init: post_event_nofinger post_events  */
#line 733 "parser.yy"
        {
		yyval = post_event_cons (yyvsp[-1], scm_reverse_x (yyvsp[0], SCM_EOL));
		if (scm_is_pair (yyval)
		    && scm_is_null (scm_cdr (yyval)))
			yyval = scm_car (yyval);
		else
		{
			Music * m = MY_MAKE_MUSIC ("PostEvents", (yyloc));
			set_property (m, "elements", yyval);
			yyval = m->unprotect ();
		}
	}
#line 3929 "./out/parser.cc"
    break;

  case 90: /* identifier_init_nonumber: partial_function "\\etc"  */
#line 763 "parser.yy"
        {
		yyval = MAKE_SYNTAX (partial_music_function, (yyloc),
				  scm_reverse_x (yyvsp[-1], SCM_EOL));
	}
#line 3938 "./out/parser.cc"
    break;

  case 91: /* partial_function_scriptable: MUSIC_FUNCTION function_arglist_partial  */
#line 773 "parser.yy"
        {
		yyval = scm_acons (yyvsp[-1], yyvsp[0], SCM_EOL);
	}
#line 3946 "./out/parser.cc"
    break;

  case 92: /* partial_function_scriptable: EVENT_FUNCTION function_arglist_partial  */
#line 777 "parser.yy"
        {
		yyval = scm_acons (yyvsp[-1], yyvsp[0], SCM_EOL);
	}
#line 3954 "./out/parser.cc"
    break;

  case 93: /* partial_function_scriptable: SCM_FUNCTION function_arglist_partial  */
#line 781 "parser.yy"
        {
		yyval = scm_acons (yyvsp[-1], yyvsp[0], SCM_EOL);
	}
#line 3962 "./out/parser.cc"
    break;

  case 94: /* partial_function_scriptable: MUSIC_FUNCTION "scheme?" function_arglist_optional partial_function  */
#line 785 "parser.yy"
        {
		yyval = scm_acons (yyvsp[-3], yyvsp[-1], yyvsp[0]);
	}
#line 3970 "./out/parser.cc"
    break;

  case 95: /* partial_function_scriptable: EVENT_FUNCTION "scheme?" function_arglist_optional partial_function  */
#line 789 "parser.yy"
        {
		yyval = scm_acons (yyvsp[-3], yyvsp[-1], yyvsp[0]);
	}
#line 3978 "./out/parser.cc"
    break;

  case 96: /* partial_function_scriptable: SCM_FUNCTION "scheme?" function_arglist_optional partial_function  */
#line 793 "parser.yy"
        {
		yyval = scm_acons (yyvsp[-3], yyvsp[-1], yyvsp[0]);
	}
#line 3986 "./out/parser.cc"
    break;

  case 97: /* partial_function_scriptable: MUSIC_FUNCTION "optional?" "scheme?" function_arglist_nonbackup partial_function  */
#line 797 "parser.yy"
        {
		yyval = scm_acons (yyvsp[-4], yyvsp[-1], yyvsp[0]);
	}
#line 3994 "./out/parser.cc"
    break;

  case 98: /* partial_function_scriptable: EVENT_FUNCTION "optional?" "scheme?" function_arglist_nonbackup partial_function  */
#line 801 "parser.yy"
        {
		yyval = scm_acons (yyvsp[-4], yyvsp[-1], yyvsp[0]);
	}
#line 4002 "./out/parser.cc"
    break;

  case 99: /* partial_function_scriptable: SCM_FUNCTION "optional?" "scheme?" function_arglist_nonbackup partial_function  */
#line 805 "parser.yy"
        {
		yyval = scm_acons (yyvsp[-4], yyvsp[-1], yyvsp[0]);
	}
#line 4010 "./out/parser.cc"
    break;

  case 101: /* partial_function: "\\override" grob_prop_path '='  */
#line 813 "parser.yy"
        {
		if (SCM_UNBNDP (yyvsp[-1]))
			yyval = scm_list_1 (SCM_BOOL_F);
		else
			yyval = scm_cons
				(scm_list_3 (Syntax::property_override,
					     scm_cdr (yyvsp[-1]), scm_car (yyvsp[-1])),
				 SCM_EOL);
	}
#line 4024 "./out/parser.cc"
    break;

  case 102: /* partial_function: "\\set" context_prop_spec '='  */
#line 823 "parser.yy"
        {
		if (SCM_UNBNDP (yyvsp[-1]))
			yyval = scm_list_1 (SCM_BOOL_F);
		else
			yyval = scm_cons
				(scm_list_3 (Syntax::property_set,
					     scm_cadr (yyvsp[-1]), scm_car (yyvsp[-1])),
				 SCM_EOL);
	}
#line 4038 "./out/parser.cc"
    break;

  case 103: /* partial_function: "\\override" grob_prop_path '=' partial_function  */
#line 833 "parser.yy"
        {
		if (SCM_UNBNDP (yyvsp[-2]))
			yyval = scm_list_1 (SCM_BOOL_F);
		else
			yyval = scm_cons
				(scm_list_3 (Syntax::property_override,
					     scm_cdr (yyvsp[-2]), scm_car (yyvsp[-2])),
				 yyvsp[0]);
	}
#line 4052 "./out/parser.cc"
    break;

  case 104: /* partial_function: "\\set" context_prop_spec '=' partial_function  */
#line 843 "parser.yy"
        {
		if (SCM_UNBNDP (yyvsp[-2]))
			yyval = scm_list_1 (SCM_BOOL_F);
		else
			yyval = scm_cons
				(scm_list_3 (Syntax::property_set,
					     scm_cadr (yyvsp[-2]), scm_car (yyvsp[-2])),
				 yyvsp[0]);
	}
#line 4066 "./out/parser.cc"
    break;

  case 105: /* partial_function: script_dir markup_mode markup_partial_function  */
#line 854 "parser.yy"
        {
		if (SCM_UNBNDP (yyvsp[-2]))
			yyvsp[-2] = SCM_INUM0;
		yyvsp[0] = MAKE_SYNTAX (partial_markup, (yylsp[0]), yyvsp[0]);
		parser->lexer_->pop_state ();
// This relies on partial_function always being followed by ETC
		yyval = scm_list_1 (scm_list_3 (MAKE_SYNTAX (partial_text_script, (yyloc), yyvsp[0]),
					     yyvsp[0], yyvsp[-2]));
	}
#line 4080 "./out/parser.cc"
    break;

  case 106: /* partial_function: script_dir partial_function_scriptable  */
#line 864 "parser.yy"
        {
		if (SCM_UNBNDP (yyvsp[-1]))
			yyvsp[-1] = SCM_INUM0;
		yyval = scm_acons (Syntax::create_script_function, scm_list_1 (yyvsp[-1]), yyvsp[0]);
	}
#line 4090 "./out/parser.cc"
    break;

  case 107: /* partial_function: script_dir  */
#line 870 "parser.yy"
        {
		if (SCM_UNBNDP (yyvsp[0]))
			yyvsp[0] = SCM_INUM0;
		yyval = scm_acons (Syntax::create_script_function, scm_list_1 (yyvsp[0]), SCM_EOL);
	}
#line 4100 "./out/parser.cc"
    break;

  case 108: /* context_def_spec_block: "\\context" '{' context_def_spec_body '}'  */
#line 879 "parser.yy"
        {
		yyval = yyvsp[-1];
		Context_def *td = unsmob<Context_def> (yyval);
		if (!td) {
			yyval = Context_def::make_scm ();
			td = unsmob<Context_def> (yyval);
		}
		td->origin ()->set_spot ((yyloc));
	}
#line 4114 "./out/parser.cc"
    break;

  case 110: /* $@3: %empty  */
#line 893 "parser.yy"
        {
		parser->lexer_->push_note_state ();
	}
#line 4122 "./out/parser.cc"
    break;

  case 111: /* context_mod_arg: $@3 composite_music  */
#line 897 "parser.yy"
        {
		parser->lexer_->pop_state ();
		yyval = yyvsp[0];
	}
#line 4131 "./out/parser.cc"
    break;

  case 112: /* context_def_spec_body: %empty  */
#line 905 "parser.yy"
             {
		yyval = SCM_UNSPECIFIED;
	}
#line 4139 "./out/parser.cc"
    break;

  case 113: /* context_def_spec_body: context_def_spec_body context_mod  */
#line 908 "parser.yy"
                                            {
		if (!SCM_UNBNDP (yyvsp[0])) {
			Context_def *td = unsmob<Context_def> (yyval);
			if (!td) {
				yyval = Context_def::make_scm ();
				td = unsmob<Context_def> (yyval);
			}
			unsmob<Context_def> (yyval)->add_context_mod (yyvsp[0]);
		}
	}
#line 4154 "./out/parser.cc"
    break;

  case 114: /* context_def_spec_body: context_def_spec_body context_modification  */
#line 918 "parser.yy"
                                                     {
                Context_def *td = unsmob<Context_def> (yyval);
		if (!td) {
			yyval = Context_def::make_scm ();
			td = unsmob<Context_def> (yyval);
		}
                SCM new_mods = unsmob<Context_mod> (yyvsp[0])->get_mods ();
                for (SCM m = new_mods; scm_is_pair (m); m = scm_cdr (m)) {
                    td->add_context_mod (scm_car (m));
                }
	}
#line 4170 "./out/parser.cc"
    break;

  case 115: /* context_def_spec_body: context_def_spec_body context_mod_arg  */
#line 929 "parser.yy"
                                                {
		Context_def *td = unsmob<Context_def> (yyvsp[-1]);
		if (scm_is_eq (yyvsp[0], SCM_UNSPECIFIED))
			;
		else if (!td && unsmob<Context_def> (yyvsp[0]))
			yyval = yyvsp[0];
		else {
			if (!td) {
				yyval = Context_def::make_scm ();
				td = unsmob<Context_def> (yyval);
			}
			if (unsmob<Music> (yyvsp[0])) {
				SCM proc = parser->lexer_->lookup_identifier ("context-mod-music-handler");
				yyvsp[0] = scm_call_1 (proc, yyvsp[0]);
			}
			if (Context_mod *cm = unsmob<Context_mod> (yyvsp[0])) {
				for (SCM m = cm->get_mods (); scm_is_pair (m); m = scm_cdr (m)) {
					td->add_context_mod (scm_car (m));
				}
			} else
				parser->parser_error ((yylsp[0]), _ ("not a context mod"));
		}
	}
#line 4198 "./out/parser.cc"
    break;

  case 116: /* book_block: "\\book" '{' book_body '}'  */
#line 957 "parser.yy"
                                {
		yyval = yyvsp[-1];
		unsmob<Book> (yyval)->origin ()->set_spot ((yyloc));
		pop_paper (parser);
		parser->lexer_->set_identifier (ly_symbol2scm ("$current-book"), SCM_BOOL_F);
	}
#line 4209 "./out/parser.cc"
    break;

  case 117: /* book_body: %empty  */
#line 969 "parser.yy"
        {
		Book *book = new Book;
		init_papers (parser);
		book->paper_ = unsmob<Output_def> (parser->lexer_->lookup_identifier ("$defaultpaper"))->clone ();
		book->paper_->unprotect ();
		push_paper (parser, book->paper_);
		book->header_ = get_header (parser);
                yyval = book->unprotect ();
		parser->lexer_->set_identifier (ly_symbol2scm ("$current-book"), yyval);
	}
#line 4224 "./out/parser.cc"
    break;

  case 118: /* book_body: BOOK_IDENTIFIER  */
#line 979 "parser.yy"
                          {
		parser->lexer_->set_identifier (ly_symbol2scm ("$current-book"), yyvsp[0]);
	}
#line 4232 "./out/parser.cc"
    break;

  case 119: /* book_body: book_body paper_block  */
#line 982 "parser.yy"
                                {
		unsmob<Book> (yyvsp[-1])->paper_ = unsmob<Output_def> (yyvsp[0]);
		set_paper (parser, unsmob<Output_def> (yyvsp[0]));
	}
#line 4241 "./out/parser.cc"
    break;

  case 120: /* book_body: book_body bookpart_block  */
#line 986 "parser.yy"
                                   {
		SCM proc = parser->lexer_->lookup_identifier ("book-bookpart-handler");
		scm_call_2 (proc, yyvsp[-1], yyvsp[0]);
	}
#line 4250 "./out/parser.cc"
    break;

  case 121: /* book_body: book_body score_block  */
#line 990 "parser.yy"
                                {
		SCM proc = parser->lexer_->lookup_identifier ("book-score-handler");
		scm_call_2 (proc, yyvsp[-1], yyvsp[0]);
	}
#line 4259 "./out/parser.cc"
    break;

  case 122: /* book_body: book_body composite_music  */
#line 994 "parser.yy"
                                    {
		SCM proc = parser->lexer_->lookup_identifier ("book-music-handler");
		scm_call_2 (proc, yyvsp[-1], yyvsp[0]);
	}
#line 4268 "./out/parser.cc"
    break;

  case 123: /* book_body: book_body full_markup  */
#line 998 "parser.yy"
                                {
		SCM proc = parser->lexer_->lookup_identifier ("book-text-handler");
		scm_call_2 (proc, yyvsp[-1], scm_list_1 (yyvsp[0]));
	}
#line 4277 "./out/parser.cc"
    break;

  case 124: /* book_body: book_body full_markup_list  */
#line 1002 "parser.yy"
                                     {
		SCM proc = parser->lexer_->lookup_identifier ("book-text-handler");
		scm_call_2 (proc, yyvsp[-1], yyvsp[0]);
	}
#line 4286 "./out/parser.cc"
    break;

  case 125: /* book_body: book_body SCM_TOKEN  */
#line 1006 "parser.yy"
                              {
		// Evaluate and ignore #xxx, as opposed to \xxx
		parser->lexer_->eval_scm_token (yyvsp[0], (yylsp[0]));
	}
#line 4295 "./out/parser.cc"
    break;

  case 126: /* book_body: book_body embedded_scm_active  */
#line 1011 "parser.yy"
        {
		SCM out = SCM_UNDEFINED;
		if (Text_interface::is_markup (yyvsp[0]))
			out = scm_list_1 (yyvsp[0]);
		else if (Text_interface::is_markup_list (yyvsp[0]))
			out = yyvsp[0];
		if (scm_is_pair (out))
		{
			SCM proc = parser->lexer_->lookup_identifier ("book-text-handler");
			scm_call_2 (proc, yyvsp[-1], out);
		} else if (unsmob<Score> (yyvsp[0]))
		{
			SCM proc = parser->lexer_->lookup_identifier ("book-score-handler");
			scm_call_2 (proc, yyvsp[-1], yyvsp[0]);
		} else if (Output_def *od = unsmob<Output_def> (yyvsp[0])) {
			if (from_scm<bool> (od->lookup_variable (ly_symbol2scm ("is-paper")))) {
				unsmob<Book> (yyvsp[-1])->paper_ = od;
				set_paper (parser, od);
			} else {
				parser->parser_error ((yylsp[0]), _ ("need \\paper for paper block"));
			}
		} else if (ly_is_module (yyvsp[0]))
		{
			ly_module_copy (unsmob<Book> (yyvsp[-1])->header_, yyvsp[0]);
		} else if (!scm_is_eq (yyvsp[0], SCM_UNSPECIFIED))
			parser->parser_error ((yylsp[0]), _("bad expression type"));
	}
#line 4327 "./out/parser.cc"
    break;

  case 127: /* $@4: %empty  */
#line 1039 "parser.yy"
        {
		parser->lexer_->add_scope (unsmob<Book> (yyvsp[0])->header_);
	}
#line 4335 "./out/parser.cc"
    break;

  case 129: /* book_body: book_body error  */
#line 1042 "parser.yy"
                          {
                Book *book = unsmob<Book> (yyvsp[-1]);
		book->paper_ = 0;
		book->scores_ = SCM_EOL;
		book->bookparts_ = SCM_EOL;
	}
#line 4346 "./out/parser.cc"
    break;

  case 130: /* bookpart_block: "\\bookpart" '{' bookpart_body '}'  */
#line 1051 "parser.yy"
                                       {
		yyval = yyvsp[-1];
		unsmob<Book> (yyval)->origin ()->set_spot ((yyloc));
		parser->lexer_->set_identifier (ly_symbol2scm ("$current-bookpart"), SCM_BOOL_F);
	}
#line 4356 "./out/parser.cc"
    break;

  case 131: /* bookpart_body: %empty  */
#line 1059 "parser.yy"
        {
		Book *book = new Book;
                yyval = book->unprotect ();
		parser->lexer_->set_identifier (ly_symbol2scm ("$current-bookpart"), yyval);
	}
#line 4366 "./out/parser.cc"
    break;

  case 132: /* bookpart_body: BOOK_IDENTIFIER  */
#line 1064 "parser.yy"
                          {
		parser->lexer_->set_identifier (ly_symbol2scm ("$current-bookpart"), yyvsp[0]);
	}
#line 4374 "./out/parser.cc"
    break;

  case 133: /* bookpart_body: bookpart_body paper_block  */
#line 1067 "parser.yy"
                                    {
		unsmob<Book> (yyval)->paper_ = unsmob<Output_def> (yyvsp[0]);
	}
#line 4382 "./out/parser.cc"
    break;

  case 134: /* bookpart_body: bookpart_body score_block  */
#line 1070 "parser.yy"
                                    {
		SCM proc = parser->lexer_->lookup_identifier ("bookpart-score-handler");
		scm_call_2 (proc, yyvsp[-1], yyvsp[0]);
	}
#line 4391 "./out/parser.cc"
    break;

  case 135: /* bookpart_body: bookpart_body composite_music  */
#line 1074 "parser.yy"
                                        {
		SCM proc = parser->lexer_->lookup_identifier ("bookpart-music-handler");
		scm_call_2 (proc, yyvsp[-1], yyvsp[0]);
	}
#line 4400 "./out/parser.cc"
    break;

  case 136: /* bookpart_body: bookpart_body full_markup  */
#line 1078 "parser.yy"
                                    {
		SCM proc = parser->lexer_->lookup_identifier ("bookpart-text-handler");
		scm_call_2 (proc, yyvsp[-1], scm_list_1 (yyvsp[0]));
	}
#line 4409 "./out/parser.cc"
    break;

  case 137: /* bookpart_body: bookpart_body full_markup_list  */
#line 1082 "parser.yy"
                                         {
		SCM proc = parser->lexer_->lookup_identifier ("bookpart-text-handler");
		scm_call_2 (proc, yyvsp[-1], yyvsp[0]);
	}
#line 4418 "./out/parser.cc"
    break;

  case 138: /* bookpart_body: bookpart_body SCM_TOKEN  */
#line 1086 "parser.yy"
                                  {
		// Evaluate and ignore #xxx, as opposed to \xxx
		parser->lexer_->eval_scm_token (yyvsp[0], (yylsp[0]));
	}
#line 4427 "./out/parser.cc"
    break;

  case 139: /* bookpart_body: bookpart_body embedded_scm_active  */
#line 1091 "parser.yy"
        {
		SCM out = SCM_UNDEFINED;
		if (Text_interface::is_markup (yyvsp[0]))
			out = scm_list_1 (yyvsp[0]);
		else if (Text_interface::is_markup_list (yyvsp[0]))
			out = yyvsp[0];
		if (scm_is_pair (out))
		{
			SCM proc = parser->lexer_->lookup_identifier ("bookpart-text-handler");
			scm_call_2 (proc, yyvsp[-1], out);
		} else if (unsmob<Score> (yyvsp[0]))
		{
			SCM proc = parser->lexer_->lookup_identifier ("bookpart-score-handler");
			scm_call_2 (proc, yyvsp[-1], yyvsp[0]);
		} else if (Output_def *od = unsmob<Output_def> (yyvsp[0])) {
			if (from_scm<bool> (od->lookup_variable (ly_symbol2scm ("is-paper")))) {
				unsmob<Book> (yyvsp[-1])->paper_ = od;
			} else {
				parser->parser_error ((yylsp[0]), _ ("need \\paper for paper block"));
			}
		} else if (ly_is_module (yyvsp[0])) {
			Book *book = unsmob<Book> (yyvsp[-1]);
			if (!ly_is_module (book->header_))
				book->header_ = ly_make_module (false);
			ly_module_copy (book->header_, yyvsp[0]);
		} else if (!scm_is_eq (yyvsp[0], SCM_UNSPECIFIED))
			parser->parser_error ((yylsp[0]), _("bad expression type"));
	}
#line 4460 "./out/parser.cc"
    break;

  case 140: /* $@5: %empty  */
#line 1120 "parser.yy"
        {
                Book *book = unsmob<Book> (yyvsp[0]);
		if (!ly_is_module (book->header_))
			book->header_ = ly_make_module (false);
		parser->lexer_->add_scope (book->header_);
	}
#line 4471 "./out/parser.cc"
    break;

  case 142: /* bookpart_body: bookpart_body error  */
#line 1126 "parser.yy"
                              {
                Book *book = unsmob<Book> (yyvsp[-1]);
		book->paper_ = 0;
		book->scores_ = SCM_EOL;
	}
#line 4481 "./out/parser.cc"
    break;

  case 143: /* score_block: "\\score" '{' score_body '}'  */
#line 1134 "parser.yy"
                                        {
		unsmob<Score> (yyvsp[-1])->origin ()->set_spot ((yyloc));
		yyval = yyvsp[-1];
	}
#line 4490 "./out/parser.cc"
    break;

  case 144: /* score_body: score_items  */
#line 1141 "parser.yy"
                    {
		if (!unsmob<Score> (yyvsp[0])) {
			parser->parser_error ((yylsp[0]), _("Missing music in \\score"));
			yyval = (new Score)->unprotect ();
			if (scm_is_pair (yyvsp[0]) && ly_is_module (scm_car (yyvsp[0])))
			{
				unsmob<Score> (yyval)->set_header (scm_car (yyvsp[0]));
				yyvsp[0] = scm_cdr (yyvsp[0]);
			}
			for (SCM p = scm_reverse_x (yyvsp[0], SCM_EOL);
			     scm_is_pair (p); p = scm_cdr (p))
			{
				unsmob<Score> (yyval)->
					add_output_def (unsmob<Output_def> (scm_car (p)));
			}
		}
	}
#line 4512 "./out/parser.cc"
    break;

  case 145: /* score_body: score_body error  */
#line 1158 "parser.yy"
                           {
		unsmob<Score> (yyval)->error_found_ = true;
	}
#line 4520 "./out/parser.cc"
    break;

  case 149: /* score_items: %empty  */
#line 1171 "parser.yy"
        {
		yyval = SCM_EOL;
	}
#line 4528 "./out/parser.cc"
    break;

  case 150: /* score_items: score_items score_item  */
#line 1175 "parser.yy"
        {
		Output_def *od = unsmob<Output_def> (yyvsp[0]);
		if (od) {
			if (from_scm<bool> (od->lookup_variable (ly_symbol2scm ("is-paper"))))
			{
				parser->parser_error ((yylsp[0]), _("\\paper cannot be used in \\score, use \\layout instead"));
				od = 0;
				yyvsp[0] = SCM_UNSPECIFIED;
			}
		} else if (!unsmob<Score> (yyval)) {
			if (unsmob<Music> (yyvsp[0])) {
				yyvsp[0] = Lily::scorify_music (yyvsp[0]);
			}
			if (unsmob<Score> (yyvsp[0]))
			{
				yyval = yyvsp[0];
				yyvsp[0] = SCM_UNSPECIFIED;
			}
		}
		Score *score = unsmob<Score> (yyval);
		if (score && scm_is_pair (yyvsp[-1])) {
			if (ly_is_module (scm_car (yyvsp[-1])))
			{
				score->set_header (scm_car (yyvsp[-1]));
				yyvsp[-1] = scm_cdr (yyvsp[-1]);
			}
			for (SCM p = scm_reverse_x (yyvsp[-1], SCM_EOL);
			     scm_is_pair (p); p = scm_cdr (p))
			{
				score->add_output_def (unsmob<Output_def> (scm_car (p)));
			}
		}
		if (od) {
			if (score)
				score->add_output_def (od);
			else if (scm_is_pair (yyval) && ly_is_module (scm_car (yyval)))
				scm_set_cdr_x (yyval, scm_cons (yyvsp[0], scm_cdr (yyval)));
			else
				yyval = scm_cons (yyvsp[0], yyval);
		} else if (ly_is_module (yyvsp[0])) {
			SCM module = SCM_UNSPECIFIED;
			if (score) {
				module = score->get_header ();
				if (!ly_is_module (module))
				{
					module = ly_make_module (false);
					score->set_header (module);
				}
			} else if (scm_is_pair (yyval) && ly_is_module (scm_car (yyval)))
				module = scm_car (yyval);
			else {
				module = ly_make_module (false);
				yyval = scm_cons (module, yyval);
			}
			ly_module_copy (module, yyvsp[0]);
		} else if (!scm_is_eq (yyvsp[0], SCM_UNSPECIFIED))
			parser->parser_error ((yylsp[0]), _("Spurious expression in \\score"));
	}
#line 4591 "./out/parser.cc"
    break;

  case 151: /* $@6: %empty  */
#line 1234 "parser.yy"
        {
		if (Score *score = unsmob<Score> (yyvsp[0])) {
			if (!ly_is_module (score->get_header ()))
				score->set_header (ly_make_module (false));
			parser->lexer_->add_scope (score->get_header ());
		} else {
			if (!scm_is_pair (yyvsp[0]) || !ly_is_module (scm_car (yyvsp[0])))
				yyvsp[0] = scm_cons (ly_make_module (false), yyvsp[0]);
			parser->lexer_->add_scope (scm_car (yyvsp[0]));
		}
	}
#line 4607 "./out/parser.cc"
    break;

  case 152: /* score_items: score_items $@6 lilypond_header  */
#line 1245 "parser.yy"
        {
		yyval = yyvsp[-2];
	}
#line 4615 "./out/parser.cc"
    break;

  case 153: /* paper_block: output_def  */
#line 1256 "parser.yy"
                   {
                Output_def *od = unsmob<Output_def> (yyvsp[0]);

		if (!from_scm<bool> (od->lookup_variable (ly_symbol2scm ("is-paper"))))
		{
			parser->parser_error ((yylsp[0]), _ ("need \\paper for paper block"));
			yyval = get_paper (parser)->unprotect ();
		}
	}
#line 4629 "./out/parser.cc"
    break;

  case 154: /* output_def: output_def_body '}'  */
#line 1269 "parser.yy"
                            {
		if (scm_is_pair (yyvsp[-1]))
			yyval = scm_car (yyvsp[-1]);

		parser->lexer_->remove_scope ();
		parser->lexer_->pop_state ();
	}
#line 4641 "./out/parser.cc"
    break;

  case 155: /* output_def_head: "\\paper"  */
#line 1279 "parser.yy"
              {
                Output_def *p = get_paper (parser);
		p->input_origin_ = (yyloc);
		parser->lexer_->add_scope (p->scope_);
                yyval = p->unprotect ();
	}
#line 4652 "./out/parser.cc"
    break;

  case 156: /* output_def_head: "\\midi"  */
#line 1285 "parser.yy"
                  {
		Output_def *p = get_midi (parser);
		yyval = p->unprotect ();
		parser->lexer_->add_scope (p->scope_);
	}
#line 4662 "./out/parser.cc"
    break;

  case 157: /* output_def_head: "\\layout"  */
#line 1290 "parser.yy"
                        {
		Output_def *p = get_layout (parser);

		parser->lexer_->add_scope (p->scope_);
		yyval = p->unprotect ();
	}
#line 4673 "./out/parser.cc"
    break;

  case 158: /* output_def_head_with_mode_switch: output_def_head  */
#line 1299 "parser.yy"
                        {
		parser->lexer_->push_initial_state ();
		yyval = yyvsp[0];
	}
#line 4682 "./out/parser.cc"
    break;

  case 161: /* output_def_body: output_def_head_with_mode_switch '{'  */
#line 1316 "parser.yy"
                                             {
		unsmob<Output_def> (yyvsp[-1])->input_origin_.set_spot ((yyloc));
		// This is a stupid trick to mark the beginning of the
		// body for deciding whether to allow
		// embedded_scm_active to have an output definition
		yyval = scm_list_1 (yyvsp[-1]);
	}
#line 4694 "./out/parser.cc"
    break;

  case 162: /* output_def_body: output_def_body assignment  */
#line 1323 "parser.yy"
                                      {
		if (scm_is_pair (yyvsp[-1]))
			yyval = scm_car (yyvsp[-1]);
	}
#line 4703 "./out/parser.cc"
    break;

  case 163: /* output_def_body: output_def_body embedded_scm_active  */
#line 1328 "parser.yy"
        {
		// We don't switch into note mode for Scheme functions
		// here.  Does not seem warranted/required in output
		// definitions.
		if (scm_is_pair (yyvsp[-1]))
		{
			Output_def *o = unsmob<Output_def> (yyvsp[0]);
			if (o) {
				o->input_origin_.set_spot ((yyloc));
				yyvsp[-1] = o->self_scm ();
				parser->lexer_->remove_scope ();
				parser->lexer_->add_scope (o->scope_);
				yyvsp[0] = SCM_UNSPECIFIED;
			} else
				yyvsp[-1] = scm_car (yyvsp[-1]);
		}
		if (unsmob<Context_def> (yyvsp[0]))
			assign_context_def (unsmob<Output_def> (yyvsp[-1]), yyvsp[0]);
		// Seems unlikely, but let's be complete:
		else if (unsmob<Music> (yyvsp[0]))
		{
			SCM proc = parser->lexer_->lookup_identifier ("output-def-music-handler");
			scm_call_2 (proc, yyvsp[-1], yyvsp[0]);
		} else if (!scm_is_eq (yyvsp[0], SCM_UNSPECIFIED))
			parser->parser_error ((yylsp[0]), _("bad expression type"));
		yyval = yyvsp[-1];
	}
#line 4735 "./out/parser.cc"
    break;

  case 164: /* output_def_body: output_def_body SCM_TOKEN  */
#line 1355 "parser.yy"
                                    {
		if (scm_is_pair (yyvsp[-1]))
			yyval = scm_car (yyvsp[-1]);
		// Evaluate and ignore #xxx, as opposed to \xxx
		parser->lexer_->eval_scm_token (yyvsp[0], (yylsp[0]));
	}
#line 4746 "./out/parser.cc"
    break;

  case 165: /* $@7: %empty  */
#line 1362 "parser.yy"
        {
		if (scm_is_pair (yyvsp[0]))
			yyvsp[0] = scm_car (yyvsp[0]);
		parser->lexer_->push_note_state ();
	}
#line 4756 "./out/parser.cc"
    break;

  case 166: /* output_def_body: output_def_body $@7 music_or_context_def  */
#line 1367 "parser.yy"
        {
		parser->lexer_->pop_state ();
		if (unsmob<Context_def> (yyvsp[0]))
			assign_context_def (unsmob<Output_def> (yyvsp[-2]), yyvsp[0]);
		else {

			SCM proc = parser->lexer_->lookup_identifier ("output-def-music-handler");
			scm_call_2 (proc, yyvsp[-2], yyvsp[0]);
		}
		yyval = yyvsp[-2];
	}
#line 4772 "./out/parser.cc"
    break;

  case 167: /* output_def_body: output_def_body error  */
#line 1378 "parser.yy"
                                {

	}
#line 4780 "./out/parser.cc"
    break;

  case 168: /* tempo_event: "\\tempo" steno_duration '=' tempo_range  */
#line 1384 "parser.yy"
                                                {
		yyval = MAKE_SYNTAX (tempo, (yyloc), SCM_EOL, yyvsp[-2], yyvsp[0]);
	}
#line 4788 "./out/parser.cc"
    break;

  case 169: /* tempo_event: "\\tempo" text steno_duration '=' tempo_range  */
#line 1387 "parser.yy"
                                                        {
		yyval = MAKE_SYNTAX (tempo, (yyloc), yyvsp[-3], yyvsp[-2], yyvsp[0]);
	}
#line 4796 "./out/parser.cc"
    break;

  case 170: /* tempo_event: "\\tempo" text  */
#line 1390 "parser.yy"
                     {
		yyval = MAKE_SYNTAX (tempo, (yyloc), yyvsp[0]);
	}
#line 4804 "./out/parser.cc"
    break;

  case 171: /* music_list: %empty  */
#line 1399 "parser.yy"
                    {
		yyval = SCM_EOL;
	}
#line 4812 "./out/parser.cc"
    break;

  case 172: /* music_list: music_list music_embedded  */
#line 1402 "parser.yy"
                                    {
		if (unsmob<Music> (yyvsp[0]))
			yyval = scm_cons (yyvsp[0], yyvsp[-1]);
	}
#line 4821 "./out/parser.cc"
    break;

  case 173: /* music_list: music_list error  */
#line 1406 "parser.yy"
                           {
		Music *m = MY_MAKE_MUSIC("Music", (yyloc));
		// ugh. code dup
		set_property (m, "error-found", SCM_BOOL_T);
		yyval = scm_cons (m->self_scm (), yyvsp[-1]);
		m->unprotect (); /* UGH */
	}
#line 4833 "./out/parser.cc"
    break;

  case 174: /* braced_music_list: '{' music_list '}'  */
#line 1417 "parser.yy"
        {
		yyval = reverse_music_list (parser, (yyloc), yyvsp[-1], true, false);
	}
#line 4841 "./out/parser.cc"
    break;

  case 178: /* pitch_as_music: pitch_or_music  */
#line 1429 "parser.yy"
        {
	        yyval = make_music_from_simple (parser, (yylsp[0]), yyvsp[0]);
                if (!unsmob<Music> (yyval))
		{
                        parser->parser_error ((yylsp[0]), _ ("music expected"));
			yyval = MAKE_SYNTAX (void_music, (yyloc));
		}
	}
#line 4854 "./out/parser.cc"
    break;

  case 181: /* music_embedded: music_embedded_backup  */
#line 1443 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 4862 "./out/parser.cc"
    break;

  case 182: /* music_embedded: music_embedded_backup "(backed-up?)" lyric_element_music  */
#line 1447 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 4870 "./out/parser.cc"
    break;

  case 183: /* music_embedded: duration post_events  */
#line 1451 "parser.yy"
        {
		Music *n = MY_MAKE_MUSIC ("NoteEvent", (yyloc));

		parser->default_duration_ = *unsmob<Duration> (yyvsp[-1]);
		set_property (n, "duration", yyvsp[-1]);

		if (scm_is_pair (yyvsp[0]))
			set_property (n, "articulations",
					 scm_reverse_x (yyvsp[0], SCM_EOL));
		yyval = n->unprotect ();
	}
#line 4886 "./out/parser.cc"
    break;

  case 184: /* music_embedded_backup: embedded_scm  */
#line 1466 "parser.yy"
        {
		if (scm_is_eq (yyvsp[0], SCM_UNSPECIFIED)
		    || unsmob<Music> (yyvsp[0]))
			yyval = yyvsp[0];
		else if (parser->lexer_->is_lyric_state ()
			   && Text_interface::is_markup (yyvsp[0]))
			MYBACKUP (LYRIC_ELEMENT, yyvsp[0], (yylsp[0]));
		else {
			(yyloc).warning (_ ("Ignoring non-music expression"));
			yyval = SCM_UNSPECIFIED;
		}
	}
#line 4903 "./out/parser.cc"
    break;

  case 187: /* repeated_music: "\\repeat" simple_string unsigned_number music  */
#line 1489 "parser.yy"
        {
		yyval = MAKE_SYNTAX (repeat, (yyloc), yyvsp[-2], yyvsp[-1], yyvsp[0], SCM_EOL);
	}
#line 4911 "./out/parser.cc"
    break;

  case 188: /* repeated_music: "\\repeat" simple_string unsigned_number music sequential_alternative_music  */
#line 1493 "parser.yy"
        {
		yyval = MAKE_SYNTAX (repeat, (yyloc), yyvsp[-3], yyvsp[-2], yyvsp[-1], yyvsp[0]);
	}
#line 4919 "./out/parser.cc"
    break;

  case 189: /* sequential_alternative_music: "\\alternative" braced_music_list  */
#line 1499 "parser.yy"
                                      {
		yyval = MAKE_SYNTAX (sequential_alternative_music, (yyloc), yyvsp[0]);
	}
#line 4927 "./out/parser.cc"
    break;

  case 190: /* sequential_alternative_music: "\\alternative" MUSIC_IDENTIFIER  */
#line 1503 "parser.yy"
                                     { yyval = yyvsp[0]; }
#line 4933 "./out/parser.cc"
    break;

  case 191: /* sequential_music: sequential_alternative_music  */
#line 1507 "parser.yy"
                                     {
		yyval = yyvsp[0];
	}
#line 4941 "./out/parser.cc"
    break;

  case 192: /* sequential_music: "\\sequential" braced_music_list  */
#line 1510 "parser.yy"
                                       {
		yyval = MAKE_SYNTAX (sequential_music, (yyloc), yyvsp[0]);
	}
#line 4949 "./out/parser.cc"
    break;

  case 193: /* sequential_music: braced_music_list  */
#line 1513 "parser.yy"
                            {
		yyval = MAKE_SYNTAX (sequential_music, (yyloc), yyvsp[0]);
	}
#line 4957 "./out/parser.cc"
    break;

  case 194: /* simultaneous_music: "\\simultaneous" braced_music_list  */
#line 1519 "parser.yy"
                                       {
		yyval = MAKE_SYNTAX (simultaneous_music, (yyloc), yyvsp[0]);
	}
#line 4965 "./out/parser.cc"
    break;

  case 195: /* simultaneous_music: "<<" music_list ">>"  */
#line 1522 "parser.yy"
                                                                {
		yyval = MAKE_SYNTAX (simultaneous_music, (yyloc),
				  reverse_music_list (parser, (yyloc), yyvsp[-1],
						      true, false));
	}
#line 4975 "./out/parser.cc"
    break;

  case 199: /* $@8: %empty  */
#line 1537 "parser.yy"
        {
		parser->lexer_->push_note_state ();
	}
#line 4983 "./out/parser.cc"
    break;

  case 200: /* context_modification: "\\with" $@8 '{' context_mod_list '}'  */
#line 1540 "parser.yy"
        {
                parser->lexer_->pop_state ();
                yyval = yyvsp[-1];
        }
#line 4992 "./out/parser.cc"
    break;

  case 201: /* context_modification: "\\with" context_modification_arg  */
#line 1545 "parser.yy"
        {
		if (unsmob<Music> (yyvsp[0])) {
			SCM proc = parser->lexer_->lookup_identifier ("context-mod-music-handler");
			yyvsp[0] = scm_call_1 (proc, yyvsp[0]);
		}
		if (unsmob<Context_mod> (yyvsp[0]))
			yyval = yyvsp[0];
		else {
			// let's permit \with #*unspecified* to go for
			// an empty context mod
			if (!scm_is_eq (yyvsp[0], SCM_UNSPECIFIED))
				parser->parser_error ((yylsp[0]), _ ("not a context mod"));
			yyval = Context_mod ().smobbed_copy ();
		}
	}
#line 5012 "./out/parser.cc"
    break;

  case 204: /* optional_context_mods: context_modification_mods_list  */
#line 1573 "parser.yy"
        {
		if (scm_is_pair (yyvsp[0]))
			yyval = scm_append_x (scm_reverse_x (yyvsp[0], SCM_EOL));
        }
#line 5021 "./out/parser.cc"
    break;

  case 205: /* context_modification_mods_list: %empty  */
#line 1586 "parser.yy"
             {
		yyval = SCM_EOL;
	}
#line 5029 "./out/parser.cc"
    break;

  case 206: /* context_modification_mods_list: context_modification_mods_list context_modification  */
#line 1590 "parser.yy"
        {
		if (Context_mod *m = unsmob<Context_mod> (yyvsp[0]))
			yyval = scm_cons (m->get_mods (), yyvsp[-1]);
	}
#line 5038 "./out/parser.cc"
    break;

  case 207: /* context_mod_list: %empty  */
#line 1602 "parser.yy"
             {
            yyval = Context_mod ().smobbed_copy ();
        }
#line 5046 "./out/parser.cc"
    break;

  case 208: /* context_mod_list: context_mod_list context_mod  */
#line 1605 "parser.yy"
                                        {
		if (!SCM_UNBNDP (yyvsp[0]))
			unsmob<Context_mod> (yyvsp[-1])->add_context_mod (yyvsp[0]);
        }
#line 5055 "./out/parser.cc"
    break;

  case 209: /* context_mod_list: context_mod_list context_mod_arg  */
#line 1609 "parser.yy"
                                           {
		if (unsmob<Music> (yyvsp[0])) {
			SCM proc = parser->lexer_->lookup_identifier ("context-mod-music-handler");
			yyvsp[0] = scm_call_1 (proc, yyvsp[0]);
		}
		if (unsmob<Context_mod> (yyvsp[0]))
			unsmob<Context_mod> (yyval)->add_context_mods
				(unsmob<Context_mod> (yyvsp[0])->get_mods ());
		else if (!scm_is_eq (yyvsp[0], SCM_UNSPECIFIED))
			parser->parser_error ((yylsp[0]), _ ("not a context mod"));
        }
#line 5071 "./out/parser.cc"
    break;

  case 210: /* context_prefix: "\\context" symbol optional_id optional_context_mods  */
#line 1623 "parser.yy"
                                                         {
		yyval = START_MAKE_SYNTAX (context_find_or_create, yyvsp[-2], yyvsp[-1], yyvsp[0]);
	}
#line 5079 "./out/parser.cc"
    break;

  case 211: /* context_prefix: "\\new" symbol optional_id optional_context_mods  */
#line 1626 "parser.yy"
                                                              {
		yyval = START_MAKE_SYNTAX (context_create, yyvsp[-2], yyvsp[-1], yyvsp[0]);
	}
#line 5087 "./out/parser.cc"
    break;

  case 212: /* new_lyrics: "\\addlyrics" optional_context_mods lyric_mode_music  */
#line 1632 "parser.yy"
                                                         {
		yyval = scm_acons (yyvsp[0], yyvsp[-1], SCM_EOL);
	}
#line 5095 "./out/parser.cc"
    break;

  case 213: /* new_lyrics: new_lyrics "\\addlyrics" optional_context_mods lyric_mode_music  */
#line 1635 "parser.yy"
                                                                      {
		yyval = scm_acons (yyvsp[0], yyvsp[-1], yyvsp[-3]);
	}
#line 5103 "./out/parser.cc"
    break;

  case 217: /* basic_music: "\\lyricsto" simple_string lyric_mode_music  */
#line 1660 "parser.yy"
                                                  {
		yyval = MAKE_SYNTAX (lyric_combine, (yyloc), yyvsp[-1], SCM_EOL, yyvsp[0]);
	}
#line 5111 "./out/parser.cc"
    break;

  case 218: /* basic_music: "\\lyricsto" symbol '=' simple_string lyric_mode_music  */
#line 1664 "parser.yy"
        {
		yyval = MAKE_SYNTAX (lyric_combine, (yyloc), yyvsp[-1], yyvsp[-3], yyvsp[0]);
	}
#line 5119 "./out/parser.cc"
    break;

  case 222: /* contexted_basic_music: context_prefix contextable_music new_lyrics  */
#line 1677 "parser.yy"
        {
		Input i;
		i.set_location ((yylsp[-2]), (yylsp[-1]));
		yyval = FINISH_MAKE_SYNTAX (yyvsp[-2], i, yyvsp[-1]);
		yyval = MAKE_SYNTAX (add_lyrics, (yyloc), yyval, scm_reverse_x (yyvsp[0], SCM_EOL));
	}
#line 5130 "./out/parser.cc"
    break;

  case 223: /* contexted_basic_music: context_prefix contextable_music  */
#line 1684 "parser.yy"
        {
		yyval = FINISH_MAKE_SYNTAX (yyvsp[-1], (yyloc), yyvsp[0]);
	}
#line 5138 "./out/parser.cc"
    break;

  case 224: /* contexted_basic_music: context_prefix contexted_basic_music  */
#line 1688 "parser.yy"
        {
		yyval = FINISH_MAKE_SYNTAX (yyvsp[-1], (yyloc), yyvsp[0]);
	}
#line 5146 "./out/parser.cc"
    break;

  case 227: /* composite_music: basic_music new_lyrics  */
#line 1697 "parser.yy"
        {
		yyval = MAKE_SYNTAX (add_lyrics, (yyloc), yyvsp[-1], scm_reverse_x (yyvsp[0], SCM_EOL));
	}
#line 5154 "./out/parser.cc"
    break;

  case 231: /* grouped_music_list: simultaneous_music  */
#line 1709 "parser.yy"
                                        { yyval = yyvsp[0]; }
#line 5160 "./out/parser.cc"
    break;

  case 232: /* grouped_music_list: sequential_music  */
#line 1710 "parser.yy"
                                        { yyval = yyvsp[0]; }
#line 5166 "./out/parser.cc"
    break;

  case 234: /* symbol_list_arg: SYMBOL_LIST '.' symbol_list_rev  */
#line 1769 "parser.yy"
        {
		yyval = scm_append (scm_list_2 (yyvsp[-2], scm_reverse_x (yyvsp[0], SCM_EOL)));
	}
#line 5174 "./out/parser.cc"
    break;

  case 235: /* symbol_list_arg: SYMBOL_LIST ',' symbol_list_rev  */
#line 1773 "parser.yy"
        {
		yyval = scm_append (scm_list_2 (yyvsp[-2], scm_reverse_x (yyvsp[0], SCM_EOL)));
	}
#line 5182 "./out/parser.cc"
    break;

  case 237: /* symbol_list_rev: symbol_list_rev '.' symbol_list_part  */
#line 1781 "parser.yy"
        {
		yyval = scm_append_x (scm_list_2 (yyvsp[0], yyvsp[-2]));
	}
#line 5190 "./out/parser.cc"
    break;

  case 238: /* symbol_list_rev: symbol_list_rev ',' symbol_list_part  */
#line 1785 "parser.yy"
        {
		yyval = scm_append_x (scm_list_2 (yyvsp[0], yyvsp[-2]));
	}
#line 5198 "./out/parser.cc"
    break;

  case 240: /* symbol_list_part: embedded_scm_bare  */
#line 1795 "parser.yy"
        {
		yyval = make_reverse_key_list (yyvsp[0]);
		if (SCM_UNBNDP (yyval)) {
			parser->parser_error ((yylsp[0]), _("not a key"));
			yyval = SCM_EOL;
		}
	}
#line 5210 "./out/parser.cc"
    break;

  case 241: /* symbol_list_element: STRING  */
#line 1807 "parser.yy"
        {
		yyval = scm_string_to_symbol (yyvsp[0]);
	}
#line 5218 "./out/parser.cc"
    break;

  case 243: /* symbol_list_part_bare: SYMBOL  */
#line 1816 "parser.yy"
        {
		yyval = try_word_variants (Lily::key_list_p, yyvsp[0]);
		if (SCM_UNBNDP (yyval)) {
			parser->parser_error ((yylsp[0]), _("not a key"));
			yyval = SCM_EOL;
		} else
			yyval = scm_reverse (yyval);
	}
#line 5231 "./out/parser.cc"
    break;

  case 244: /* symbol_list_part_bare: symbol_list_element  */
#line 1825 "parser.yy"
        {
		yyval = scm_list_1 (yyvsp[0]);
	}
#line 5239 "./out/parser.cc"
    break;

  case 246: /* function_arglist_nonbackup: "optional?" "scheme?" function_arglist_nonbackup post_event_nofinger  */
#line 1833 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-1], yyvsp[-2]);
	}
#line 5247 "./out/parser.cc"
    break;

  case 247: /* function_arglist_nonbackup: "optional?" "scheme?" function_arglist_nonbackup '-' UNSIGNED  */
#line 1837 "parser.yy"
        {
		SCM n = scm_difference (yyvsp[0], SCM_UNDEFINED);
		if (scm_is_true (scm_call_1 (yyvsp[-3], n)))
			yyval = scm_cons (n, yyvsp[-2]);
		else {
			Music *t = MY_MAKE_MUSIC ("FingeringEvent", (yylsp[0]));
			set_property (t, "digit", yyvsp[0]);
			yyval = check_scheme_arg (parser, (yylsp[-1]), t->unprotect (),
					       yyvsp[-2], yyvsp[-3], n);
		}
	}
#line 5263 "./out/parser.cc"
    break;

  case 248: /* function_arglist_nonbackup: "optional?" "scheme?" function_arglist_nonbackup '-' REAL  */
#line 1849 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[-1]),
				       scm_difference (yyvsp[0], SCM_UNDEFINED),
				       yyvsp[-2], yyvsp[-3]);
	}
#line 5273 "./out/parser.cc"
    break;

  case 249: /* function_arglist_nonbackup: "optional?" "scheme?" function_arglist_nonbackup '-' NUMBER_IDENTIFIER  */
#line 1855 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[-1]),
				       scm_difference (yyvsp[0], SCM_UNDEFINED),
				       yyvsp[-2], yyvsp[-3]);
	}
#line 5283 "./out/parser.cc"
    break;

  case 250: /* function_arglist_nonbackup: "optional?" "scheme?" function_arglist_nonbackup embedded_scm_arg  */
#line 1861 "parser.yy"
        {
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			yyval = scm_cons (yyvsp[0], yyvsp[-1]);
		else
			yyval = check_scheme_arg (parser, (yylsp[0]),
					       make_music_from_simple
					       (parser, (yylsp[0]), yyvsp[0]),
					       yyvsp[-1], yyvsp[-2], yyvsp[0]);
	}
#line 5297 "./out/parser.cc"
    break;

  case 251: /* function_arglist_nonbackup: "optional?" "scheme?" function_arglist_nonbackup bare_number_common  */
#line 1871 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-1], yyvsp[-2]);
	}
#line 5305 "./out/parser.cc"
    break;

  case 252: /* function_arglist_nonbackup: function_arglist_nonbackup_reparse "(reparsed?)" pitch_or_music  */
#line 1875 "parser.yy"
        {
		if (scm_is_true (scm_call_1 (yyvsp[-1], yyvsp[0])))
			yyval = scm_cons (yyvsp[0], yyvsp[-2]);
		else
			yyval = check_scheme_arg (parser, (yylsp[0]),
					       make_music_from_simple
					       (parser, (yylsp[0]), yyvsp[0]),
					       yyvsp[-2], yyvsp[-1], yyvsp[0]);
	}
#line 5319 "./out/parser.cc"
    break;

  case 253: /* function_arglist_nonbackup: function_arglist_nonbackup_reparse "(reparsed?)" duration  */
#line 1885 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5327 "./out/parser.cc"
    break;

  case 254: /* function_arglist_nonbackup: function_arglist_nonbackup_reparse "(reparsed?)" reparsed_rhythm  */
#line 1889 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5335 "./out/parser.cc"
    break;

  case 255: /* function_arglist_nonbackup: function_arglist_nonbackup_reparse "(reparsed?)" bare_number_common  */
#line 1893 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5343 "./out/parser.cc"
    break;

  case 256: /* function_arglist_nonbackup: function_arglist_nonbackup_reparse "(reparsed?)" SCM_ARG  */
#line 1897 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5351 "./out/parser.cc"
    break;

  case 257: /* function_arglist_nonbackup: function_arglist_nonbackup_reparse "(reparsed?)" lyric_element_music  */
#line 1901 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5359 "./out/parser.cc"
    break;

  case 258: /* function_arglist_nonbackup: function_arglist_nonbackup_reparse "(reparsed?)" symbol_list_arg  */
#line 1905 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5367 "./out/parser.cc"
    break;

  case 259: /* reparsed_rhythm: DURATION_ARG dots multipliers post_events  */
#line 1913 "parser.yy"
        {
		SCM d = make_duration (yyvsp[-3], scm_to_int (yyvsp[-2]), yyvsp[-1]);
		parser->default_duration_ = *unsmob<Duration> (d);
		yyval = make_music_from_simple (parser, (yyloc), d);
		Music *m = unsmob<Music> (yyval);
		assert (m);
		if (scm_is_pair (yyvsp[0]))
			set_property (m, "articulations",
					 scm_reverse_x (yyvsp[0], SCM_EOL));
	}
#line 5382 "./out/parser.cc"
    break;

  case 260: /* function_arglist_nonbackup_reparse: "optional?" "scheme?" function_arglist_nonbackup SCM_IDENTIFIER  */
#line 1927 "parser.yy"
        {
		yyval = yyvsp[-1];
		SCM res = try_string_variants (yyvsp[-2], yyvsp[0]);
		if (!SCM_UNBNDP (res))
			if (scm_is_pair (res))
				MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, res);
			else
				MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, res);
		else if (scm_is_true
			 (scm_call_1
			  (yyvsp[-2], make_music_from_simple
			   (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], STRING, yyvsp[0]);
		else
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 5403 "./out/parser.cc"
    break;

  case 261: /* function_arglist_nonbackup_reparse: "optional?" "scheme?" function_arglist_nonbackup pitch  */
#line 1944 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true
		    (scm_call_1
		     (yyvsp[-2], make_music_from_simple
		      (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], PITCH_IDENTIFIER, yyvsp[0]);
		else
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 5418 "./out/parser.cc"
    break;

  case 262: /* function_arglist_nonbackup_reparse: "optional?" "scheme?" function_arglist_nonbackup steno_tonic_pitch  */
#line 1955 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true
		    (scm_call_1
		     (yyvsp[-2], make_music_from_simple
		      (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], TONICNAME_PITCH, yyvsp[0]);
		else
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 5433 "./out/parser.cc"
    break;

  case 263: /* function_arglist_nonbackup_reparse: "optional?" "scheme?" function_arglist_nonbackup STRING  */
#line 1966 "parser.yy"
        {
		yyval = yyvsp[-1];
		SCM res = try_string_variants (yyvsp[-2], yyvsp[0]);
		if (!SCM_UNBNDP (res))
			if (scm_is_pair (res))
				MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, res);
			else
				MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, res);
		else if (scm_is_true
			 (scm_call_1
			  (yyvsp[-2], make_music_from_simple
			   (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], STRING, yyvsp[0]);
		else
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 5454 "./out/parser.cc"
    break;

  case 264: /* function_arglist_nonbackup_reparse: "optional?" "scheme?" function_arglist_nonbackup SYMBOL  */
#line 1983 "parser.yy"
        {
		yyval = yyvsp[-1];
		SCM res = try_word_variants (yyvsp[-2], yyvsp[0]);
		if (!SCM_UNBNDP (res))
			if (scm_is_pair (res))
				MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, res);
			else
				MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, res);
		else if (scm_is_true
			 (scm_call_1
			  (yyvsp[-2], make_music_from_simple
			   (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], STRING, yyvsp[0]);
		else
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 5475 "./out/parser.cc"
    break;

  case 265: /* function_arglist_nonbackup_reparse: "optional?" "scheme?" function_arglist_nonbackup full_markup  */
#line 2000 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
		else if (scm_is_true
			 (scm_call_1
			  (yyvsp[-2], make_music_from_simple
			   (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], STRING, yyvsp[0]);
		else
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 5492 "./out/parser.cc"
    break;

  case 266: /* function_arglist_nonbackup_reparse: "optional?" "scheme?" function_arglist_nonbackup UNSIGNED  */
#line 2013 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			// May be 3 \cm or similar
			MYREPARSE ((yylsp[0]), yyvsp[-2], REAL, yyvsp[0]);
		else if (scm_is_true (scm_call_1 (yyvsp[-2], scm_list_1 (yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, scm_list_1 (yyvsp[0]));
		else {
			SCM d = make_duration (yyvsp[0]);
			if (!SCM_UNBNDP (d)) {
				if (scm_is_true (scm_call_1 (yyvsp[-2], d)))
					MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_IDENTIFIER, d);
				else if (scm_is_true
					 (scm_call_1
					  (yyvsp[-2], make_music_from_simple (parser, (yylsp[0]), d))))
					MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_ARG, d);
				else
					MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]); // trigger error
			} else
				MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]); // trigger error
		}
	}
#line 5519 "./out/parser.cc"
    break;

  case 267: /* function_arglist_nonbackup_reparse: "optional?" "scheme?" function_arglist_nonbackup DURATION_IDENTIFIER  */
#line 2036 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_IDENTIFIER, yyvsp[0]);
		else if (scm_is_true
			 (scm_call_1
			  (yyvsp[-2], make_music_from_simple (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_ARG, yyvsp[0]);
		else
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]); // trigger error
	}
#line 5535 "./out/parser.cc"
    break;

  case 269: /* function_arglist_backup: "optional?" "scheme?" function_arglist_backup embedded_scm_arg  */
#line 2055 "parser.yy"
        {
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			yyval = scm_cons (yyvsp[0], yyvsp[-1]);
		else {
			yyval = make_music_from_simple (parser, (yylsp[0]), yyvsp[0]);
			if (scm_is_true (scm_call_1 (yyvsp[-2], yyval)))
				yyval = scm_cons (yyval, yyvsp[-1]);
			else
			{
				yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
				MYBACKUP (SCM_ARG, yyvsp[0], (yylsp[0]));
			}
		}
	}
#line 5554 "./out/parser.cc"
    break;

  case 270: /* function_arglist_backup: "optional?" "scheme?" function_arglist_backup post_event_nofinger  */
#line 2070 "parser.yy"
        {
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
		{
			yyval = scm_cons (yyvsp[0], yyvsp[-1]);
		} else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
			MYBACKUP (EVENT_IDENTIFIER, yyvsp[0], (yylsp[0]));
		}
	}
#line 5568 "./out/parser.cc"
    break;

  case 271: /* function_arglist_backup: "optional?" "scheme?" function_arglist_backup pitch  */
#line 2080 "parser.yy"
        {
		if (scm_is_true
		    (scm_call_1
		     (yyvsp[-2], make_music_from_simple
		      (parser, (yylsp[0]), yyvsp[0]))))
		{
			yyval = yyvsp[-1];
			MYREPARSE ((yylsp[0]), yyvsp[-2], PITCH_IDENTIFIER, yyvsp[0]);
		} else if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			yyval = scm_cons (yyvsp[0], yyvsp[-1]);
		else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
			MYBACKUP (PITCH_IDENTIFIER, yyvsp[0], (yylsp[0]));
		}
	}
#line 5588 "./out/parser.cc"
    break;

  case 272: /* function_arglist_backup: "optional?" "scheme?" function_arglist_backup steno_tonic_pitch  */
#line 2096 "parser.yy"
        {
		if (scm_is_true
		    (scm_call_1
		     (yyvsp[-2], make_music_from_simple
		      (parser, (yylsp[0]), yyvsp[0]))))
		{
			yyval = yyvsp[-1];
			MYREPARSE ((yylsp[0]), yyvsp[-2], TONICNAME_PITCH, yyvsp[0]);
		} else if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			yyval = scm_cons (yyvsp[0], yyvsp[-1]);
		else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
			MYBACKUP (TONICNAME_PITCH, yyvsp[0], (yylsp[0]));
		}
	}
#line 5608 "./out/parser.cc"
    break;

  case 273: /* function_arglist_backup: "optional?" "scheme?" function_arglist_backup full_markup  */
#line 2112 "parser.yy"
        {
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			yyval = scm_cons (yyvsp[0], yyvsp[-1]);
		else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
			MYBACKUP (SCM_IDENTIFIER, yyvsp[0], (yylsp[0]));
		}
	}
#line 5621 "./out/parser.cc"
    break;

  case 274: /* function_arglist_backup: "optional?" "scheme?" function_arglist_backup UNSIGNED  */
#line 2121 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			// May be 3 \cm or similar
			MYREPARSE ((yylsp[0]), yyvsp[-2], REAL, yyvsp[0]);
		else if (scm_is_true (scm_call_1 (yyvsp[-2], scm_list_1 (yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, scm_list_1 (yyvsp[0]));
		else {
			SCM d = make_duration (yyvsp[0]);
			if (!SCM_UNBNDP (d)) {
				if (scm_is_true (scm_call_1 (yyvsp[-2], d)))
					MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_IDENTIFIER, d);
				else if (scm_is_true
					 (scm_call_1
					  (yyvsp[-2], make_music_from_simple (parser, (yylsp[0]), d))))
					MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_ARG, d);
				else {
					yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
					MYBACKUP (UNSIGNED, yyvsp[0], (yylsp[0]));
				}
			} else {
				yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
				MYBACKUP (UNSIGNED, yyvsp[0], (yylsp[0]));
			}
		}
	}
#line 5652 "./out/parser.cc"
    break;

  case 275: /* function_arglist_backup: "optional?" "scheme?" function_arglist_backup REAL  */
#line 2148 "parser.yy"
        {
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
		{
			yyval = yyvsp[-1];
			MYREPARSE ((yylsp[0]), yyvsp[-2], REAL, yyvsp[0]);
		} else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
			MYBACKUP (REAL, yyvsp[0], (yylsp[0]));
		}
	}
#line 5667 "./out/parser.cc"
    break;

  case 276: /* function_arglist_backup: "optional?" "scheme?" function_arglist_backup NUMBER_IDENTIFIER  */
#line 2159 "parser.yy"
        {
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
		{
			yyval = scm_cons (yyvsp[0], yyvsp[-1]);
		} else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
			MYBACKUP (NUMBER_IDENTIFIER, yyvsp[0], (yylsp[0]));
		}
	}
#line 5681 "./out/parser.cc"
    break;

  case 277: /* function_arglist_backup: "optional?" "scheme?" function_arglist_backup '-' UNSIGNED  */
#line 2169 "parser.yy"
        {
		SCM n = scm_difference (yyvsp[0], SCM_UNDEFINED);
		if (scm_is_true (scm_call_1 (yyvsp[-3], n))) {
			yyval = yyvsp[-2];
			MYREPARSE ((yylsp[0]), yyvsp[-3], REAL, n);
		} else {
			Music *t = MY_MAKE_MUSIC ("FingeringEvent", (yylsp[0]));
			set_property (t, "digit", yyvsp[0]);
			yyval = t->unprotect ();
			if (scm_is_true (scm_call_1 (yyvsp[-3], yyval)))
				yyval = scm_cons (yyval, yyvsp[-2]);
			else {
				yyval = scm_cons (loc_on_copy (parser, (yylsp[-2]), yyvsp[-4]), yyvsp[-2]);
				MYBACKUP (UNSIGNED, yyvsp[0], (yylsp[0]));
				parser->lexer_->push_extra_token ((yylsp[-1]), '-');
			}
		}
	}
#line 5704 "./out/parser.cc"
    break;

  case 278: /* function_arglist_backup: "optional?" "scheme?" function_arglist_backup '-' REAL  */
#line 2188 "parser.yy"
        {
		SCM n = scm_difference (yyvsp[0], SCM_UNDEFINED);
		if (scm_is_true (scm_call_1 (yyvsp[-3], n))) {
			MYREPARSE ((yylsp[0]), yyvsp[-3], REAL, n);
			yyval = yyvsp[-2];
		} else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-2]), yyvsp[-4]), yyvsp[-2]);
			MYBACKUP (REAL, n, (yylsp[0]));
		}
	}
#line 5719 "./out/parser.cc"
    break;

  case 279: /* function_arglist_backup: "optional?" "scheme?" function_arglist_backup '-' NUMBER_IDENTIFIER  */
#line 2199 "parser.yy"
        {
		SCM n = scm_difference (yyvsp[0], SCM_UNDEFINED);
		if (scm_is_true (scm_call_1 (yyvsp[-3], n))) {
			yyval = scm_cons (n, yyvsp[-2]);
		} else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-2]), yyvsp[-4]), yyvsp[-2]);
			MYBACKUP (NUMBER_IDENTIFIER, n, (yylsp[0]));
		}
	}
#line 5733 "./out/parser.cc"
    break;

  case 280: /* function_arglist_backup: "optional?" "scheme?" function_arglist_backup DURATION_IDENTIFIER  */
#line 2209 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_IDENTIFIER, yyvsp[0]);
		else if (scm_is_true
			 (scm_call_1
			  (yyvsp[-2], make_music_from_simple (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_ARG, yyvsp[0]);
		else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
			MYBACKUP (DURATION_IDENTIFIER, yyvsp[0], (yylsp[0]));
		}
	}
#line 5751 "./out/parser.cc"
    break;

  case 281: /* function_arglist_backup: "optional?" "scheme?" function_arglist_backup SCM_IDENTIFIER  */
#line 2223 "parser.yy"
        {
		SCM res = try_string_variants (yyvsp[-2], yyvsp[0]);
		if (!SCM_UNBNDP (res))
			if (scm_is_pair (res)) {
				yyval = yyvsp[-1];
				MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, res);
			}
			else
				yyval = scm_cons (res, yyvsp[-1]);
		else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
			MYBACKUP (SCM_IDENTIFIER, yyvsp[0], (yylsp[0]));
		}
	}
#line 5770 "./out/parser.cc"
    break;

  case 282: /* function_arglist_backup: "optional?" "scheme?" function_arglist_backup STRING  */
#line 2238 "parser.yy"
        {
		SCM res = try_string_variants (yyvsp[-2], yyvsp[0]);
		if (!SCM_UNBNDP (res))
			if (scm_is_pair (res)) {
				yyval = yyvsp[-1];
				MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, res);
			}
			else
				yyval = scm_cons (res, yyvsp[-1]);
		else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
			MYBACKUP (STRING, yyvsp[0], (yylsp[0]));
		}
	}
#line 5789 "./out/parser.cc"
    break;

  case 283: /* function_arglist_backup: "optional?" "scheme?" function_arglist_backup SYMBOL  */
#line 2253 "parser.yy"
        {
		SCM res = try_word_variants (yyvsp[-2], yyvsp[0]);
		if (!SCM_UNBNDP (res))
			if (scm_is_pair (res)) {
				yyval = yyvsp[-1];
				MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, res);
			}
			else
				yyval = scm_cons (res, yyvsp[-1]);
		else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
			MYBACKUP (STRING, yyvsp[0], (yylsp[0]));
		}
	}
#line 5808 "./out/parser.cc"
    break;

  case 284: /* function_arglist_backup: function_arglist_backup "(reparsed?)" pitch_or_music  */
#line 2268 "parser.yy"
        {
		if (scm_is_true (scm_call_1 (yyvsp[-1], yyvsp[0])))
			yyval = scm_cons (yyvsp[0], yyvsp[-2]);
		else
			yyval = check_scheme_arg (parser, (yylsp[0]),
					       make_music_from_simple
					       (parser, (yylsp[0]), yyvsp[0]),
					       yyvsp[-2], yyvsp[-1]);
	}
#line 5822 "./out/parser.cc"
    break;

  case 285: /* function_arglist_backup: function_arglist_backup "(reparsed?)" bare_number_common  */
#line 2278 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]),
				       yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5831 "./out/parser.cc"
    break;

  case 286: /* function_arglist_backup: function_arglist_backup "(reparsed?)" duration  */
#line 2283 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]),
				       yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5840 "./out/parser.cc"
    break;

  case 287: /* function_arglist_backup: function_arglist_backup "(reparsed?)" reparsed_rhythm  */
#line 2288 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]),
				       yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5849 "./out/parser.cc"
    break;

  case 288: /* function_arglist_backup: function_arglist_backup "(reparsed?)" symbol_list_arg  */
#line 2293 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5857 "./out/parser.cc"
    break;

  case 290: /* function_arglist: "optional?" "scheme?" function_arglist_skip_nonbackup "\\default"  */
#line 2301 "parser.yy"
        {
		yyval = scm_cons (loc_on_copy (parser, (yylsp[0]), yyvsp[-3]), yyvsp[-1]);
	}
#line 5865 "./out/parser.cc"
    break;

  case 292: /* function_arglist_skip_nonbackup: "optional?" "scheme?" function_arglist_skip_nonbackup  */
#line 2309 "parser.yy"
        {
		yyval = scm_cons (loc_on_copy (parser, (yylsp[0]), yyvsp[-2]), yyvsp[0]);
	}
#line 5873 "./out/parser.cc"
    break;

  case 293: /* function_arglist_partial: "scheme?" function_arglist_optional  */
#line 2328 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 5881 "./out/parser.cc"
    break;

  case 294: /* function_arglist_partial: "scheme?" function_arglist_partial_optional  */
#line 2332 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 5889 "./out/parser.cc"
    break;

  case 295: /* function_arglist_partial: "optional?" "scheme?" function_arglist_nonbackup  */
#line 2336 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 5897 "./out/parser.cc"
    break;

  case 296: /* function_arglist_partial: "optional?" "scheme?" function_arglist_partial  */
#line 2340 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 5905 "./out/parser.cc"
    break;

  case 297: /* function_arglist_partial_optional: "scheme?" function_arglist_optional  */
#line 2347 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 5913 "./out/parser.cc"
    break;

  case 298: /* function_arglist_partial_optional: "scheme?" function_arglist_partial_optional  */
#line 2351 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 5921 "./out/parser.cc"
    break;

  case 299: /* function_arglist_partial_optional: "optional?" "scheme?" function_arglist_backup  */
#line 2355 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 5929 "./out/parser.cc"
    break;

  case 300: /* function_arglist_partial_optional: "optional?" "scheme?" function_arglist_partial_optional  */
#line 2359 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 5937 "./out/parser.cc"
    break;

  case 301: /* function_arglist_common: EXPECT_NO_MORE_ARGS  */
#line 2365 "parser.yy"
                            {
		yyval = SCM_EOL;
	}
#line 5945 "./out/parser.cc"
    break;

  case 302: /* function_arglist_common: "scheme?" function_arglist_optional embedded_scm_arg  */
#line 2369 "parser.yy"
        {
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			yyval = scm_cons (yyvsp[0], yyvsp[-1]);
		else
			yyval = check_scheme_arg (parser, (yylsp[0]),
					       make_music_from_simple
					       (parser, (yylsp[0]), yyvsp[0]),
					       yyvsp[-1], yyvsp[-2], yyvsp[0]);
	}
#line 5959 "./out/parser.cc"
    break;

  case 303: /* function_arglist_common: "scheme?" function_arglist_optional bare_number_common  */
#line 2379 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]),
				       yyvsp[0], yyvsp[-1], yyvsp[-2]);
	}
#line 5968 "./out/parser.cc"
    break;

  case 304: /* function_arglist_common: "scheme?" function_arglist_optional post_event_nofinger  */
#line 2384 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]),
				       yyvsp[0], yyvsp[-1], yyvsp[-2]);
	}
#line 5977 "./out/parser.cc"
    break;

  case 305: /* function_arglist_common: "scheme?" function_arglist_optional '-' NUMBER_IDENTIFIER  */
#line 2389 "parser.yy"
        {
		SCM n = scm_difference (yyvsp[0], SCM_UNDEFINED);
		yyval = check_scheme_arg (parser, (yylsp[0]), n, yyvsp[-2], yyvsp[-3]);
	}
#line 5986 "./out/parser.cc"
    break;

  case 306: /* function_arglist_common: function_arglist_common_reparse "(reparsed?)" SCM_ARG  */
#line 2394 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]),
				       yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5995 "./out/parser.cc"
    break;

  case 307: /* function_arglist_common: function_arglist_common_reparse "(reparsed?)" lyric_element_music  */
#line 2399 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]),
				       yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 6004 "./out/parser.cc"
    break;

  case 308: /* function_arglist_common: function_arglist_common_reparse "(reparsed?)" pitch_or_music  */
#line 2404 "parser.yy"
        {
		if (scm_is_true (scm_call_1 (yyvsp[-1], yyvsp[0])))
			yyval = scm_cons (yyvsp[0], yyvsp[-2]);
		else
			yyval = check_scheme_arg (parser, (yylsp[0]),
					       make_music_from_simple
					       (parser, (yylsp[0]), yyvsp[0]),
					       yyvsp[-2], yyvsp[-1], yyvsp[0]);
	}
#line 6018 "./out/parser.cc"
    break;

  case 309: /* function_arglist_common: function_arglist_common_reparse "(reparsed?)" bare_number_common  */
#line 2414 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]),
				       yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 6027 "./out/parser.cc"
    break;

  case 310: /* function_arglist_common: function_arglist_common_reparse "(reparsed?)" duration  */
#line 2419 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]),
				       yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 6036 "./out/parser.cc"
    break;

  case 311: /* function_arglist_common: function_arglist_common_reparse "(reparsed?)" reparsed_rhythm  */
#line 2424 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]),
				       yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 6045 "./out/parser.cc"
    break;

  case 312: /* function_arglist_common: function_arglist_common_reparse "(reparsed?)" symbol_list_arg  */
#line 2429 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 6053 "./out/parser.cc"
    break;

  case 313: /* function_arglist_common_reparse: "scheme?" function_arglist_optional SCM_IDENTIFIER  */
#line 2436 "parser.yy"
        {
		yyval = yyvsp[-1];
		SCM res = try_string_variants (yyvsp[-2], yyvsp[0]);
		if (!SCM_UNBNDP (res))
			if (scm_is_pair (res))
				MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, res);
			else
				MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, res);
		else if (scm_is_true
			 (scm_call_1
			  (yyvsp[-2], make_music_from_simple (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], LYRIC_ELEMENT, yyvsp[0]);
		else
			// This is going to flag a syntax error, we
			// know the predicate to be false.
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 6075 "./out/parser.cc"
    break;

  case 314: /* function_arglist_common_reparse: "scheme?" function_arglist_optional pitch  */
#line 2454 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true
		    (scm_call_1
		     (yyvsp[-2], make_music_from_simple
		      (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], PITCH_IDENTIFIER, yyvsp[0]);
		else
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 6090 "./out/parser.cc"
    break;

  case 315: /* function_arglist_common_reparse: "scheme?" function_arglist_optional steno_tonic_pitch  */
#line 2465 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true
		    (scm_call_1
		     (yyvsp[-2], make_music_from_simple
		      (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], TONICNAME_PITCH, yyvsp[0]);
		else
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 6105 "./out/parser.cc"
    break;

  case 316: /* function_arglist_common_reparse: "scheme?" function_arglist_optional STRING  */
#line 2476 "parser.yy"
        {
		yyval = yyvsp[-1];
		SCM res = try_string_variants (yyvsp[-2], yyvsp[0]);
		if (!SCM_UNBNDP (res))
			if (scm_is_pair (res))
				MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, res);
			else
				MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, res);
		else if (scm_is_true
			 (scm_call_1
			  (yyvsp[-2], make_music_from_simple (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], LYRIC_ELEMENT, yyvsp[0]);
		else
			// This is going to flag a syntax error, we
			// know the predicate to be false.
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 6127 "./out/parser.cc"
    break;

  case 317: /* function_arglist_common_reparse: "scheme?" function_arglist_optional SYMBOL  */
#line 2494 "parser.yy"
        {
		yyval = yyvsp[-1];
		SCM res = try_word_variants (yyvsp[-2], yyvsp[0]);
		if (!SCM_UNBNDP (res))
			if (scm_is_pair (res))
				MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, res);
			else
				MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, res);
		else if (scm_is_true
			 (scm_call_1
			  (yyvsp[-2], make_music_from_simple (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], LYRIC_ELEMENT, yyvsp[0]);
		else
			// This is going to flag a syntax error, we
			// know the predicate to be false.
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 6149 "./out/parser.cc"
    break;

  case 318: /* function_arglist_common_reparse: "scheme?" function_arglist_optional full_markup  */
#line 2512 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
		else if (scm_is_true
			 (scm_call_1
			  (yyvsp[-2], make_music_from_simple (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], LYRIC_ELEMENT, yyvsp[0]);
		else
			// This is going to flag a syntax error, we
			// know the predicate to be false.
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 6167 "./out/parser.cc"
    break;

  case 319: /* function_arglist_common_reparse: "scheme?" function_arglist_optional UNSIGNED  */
#line 2526 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			// May be 3 \cm or similar
			MYREPARSE ((yylsp[0]), yyvsp[-2], REAL, yyvsp[0]);
		else if (scm_is_true (scm_call_1 (yyvsp[-2], scm_list_1 (yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, scm_list_1 (yyvsp[0]));
		else {
			SCM d = make_duration (yyvsp[0]);
			if (!SCM_UNBNDP (d)) {
				if (scm_is_true (scm_call_1 (yyvsp[-2], d)))
					MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_IDENTIFIER, d);
				else if (scm_is_true
					 (scm_call_1
					  (yyvsp[-2], make_music_from_simple (parser, (yylsp[0]), d))))
					MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_ARG, d);
				else
					MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]); // trigger error
			} else
				MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]); // trigger error
		}
	}
#line 6194 "./out/parser.cc"
    break;

  case 320: /* function_arglist_common_reparse: "scheme?" function_arglist_optional DURATION_IDENTIFIER  */
#line 2549 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_IDENTIFIER, yyvsp[0]);
		else if (scm_is_true
			 (scm_call_1
			  (yyvsp[-2], make_music_from_simple (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_ARG, yyvsp[0]);
		else
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]); // trigger error
	}
#line 6210 "./out/parser.cc"
    break;

  case 321: /* function_arglist_common_reparse: "scheme?" function_arglist_optional '-' UNSIGNED  */
#line 2561 "parser.yy"
        {
		yyval = yyvsp[-2];
		SCM n = scm_difference (yyvsp[0], SCM_UNDEFINED);
		if (scm_is_true (scm_call_1 (yyvsp[-3], n)))
			MYREPARSE ((yylsp[0]), yyvsp[-3], REAL, n);
		else {
			Music *t = MY_MAKE_MUSIC ("FingeringEvent", (yylsp[0]));
			set_property (t, "digit", yyvsp[0]);
			SCM m = t->unprotect ();
			if (scm_is_true (scm_call_1 (yyvsp[-3], m)))
				MYREPARSE ((yylsp[0]), yyvsp[-3], SCM_ARG, m);
			else
				MYREPARSE ((yylsp[0]), yyvsp[-3], SCM_ARG, yyvsp[0]);
		}
	}
#line 6230 "./out/parser.cc"
    break;

  case 322: /* function_arglist_common_reparse: "scheme?" function_arglist_optional '-' REAL  */
#line 2577 "parser.yy"
        {
		yyval = yyvsp[-2];
		SCM n = scm_difference (yyvsp[0], SCM_UNDEFINED);
		MYREPARSE ((yylsp[0]), yyvsp[-3], REAL, n);
	}
#line 6240 "./out/parser.cc"
    break;

  case 324: /* function_arglist_optional: "optional?" "scheme?" function_arglist_skip_backup "\\default"  */
#line 2587 "parser.yy"
        {
		yyval = scm_cons (loc_on_copy (parser, (yylsp[0]), yyvsp[-3]), yyvsp[-1]);
	}
#line 6248 "./out/parser.cc"
    break;

  case 327: /* function_arglist_skip_backup: "optional?" "scheme?" function_arglist_skip_backup  */
#line 2596 "parser.yy"
        {
		yyval = scm_cons (loc_on_copy (parser, (yylsp[0]), yyvsp[-2]), yyvsp[0]);
	}
#line 6256 "./out/parser.cc"
    break;

  case 328: /* music_function_call: MUSIC_FUNCTION function_arglist  */
#line 2602 "parser.yy"
                                        {
		yyval = MAKE_SYNTAX (music_function, (yyloc),
				  yyvsp[-1], yyvsp[0]);
	}
#line 6265 "./out/parser.cc"
    break;

  case 329: /* optional_id: %empty  */
#line 2610 "parser.yy"
             { yyval = SCM_EOL; }
#line 6271 "./out/parser.cc"
    break;

  case 330: /* optional_id: '=' simple_string  */
#line 2611 "parser.yy"
                            {
		yyval = yyvsp[0];
	}
#line 6279 "./out/parser.cc"
    break;

  case 331: /* $@9: %empty  */
#line 2623 "parser.yy"
        {
		parser->lexer_->push_lyric_state ();
	}
#line 6287 "./out/parser.cc"
    break;

  case 332: /* lyric_mode_music: $@9 grouped_music_list  */
#line 2626 "parser.yy"
        {
		parser->lexer_->pop_state ();
		yyval = yyvsp[0];
	}
#line 6296 "./out/parser.cc"
    break;

  case 334: /* mode_changed_music: mode_changing_head grouped_music_list  */
#line 2634 "parser.yy"
                                              {
		if (scm_is_eq (yyvsp[-1], ly_symbol2scm ("chords")))
		{
		  yyval = MAKE_SYNTAX (unrelativable_music, (yyloc), yyvsp[0]);
		}
		else
		{
		  yyval = yyvsp[0];
		}
		parser->lexer_->pop_state ();
	}
#line 6312 "./out/parser.cc"
    break;

  case 335: /* mode_changed_music: mode_changing_head_with_context optional_context_mods grouped_music_list  */
#line 2645 "parser.yy"
                                                                                   {
		yyval = MAKE_SYNTAX (context_create, (yyloc), yyvsp[-2], SCM_EOL, yyvsp[-1], yyvsp[0]);
		if (scm_is_eq (yyvsp[-2], ly_symbol2scm ("ChordNames")))
		{
		  yyval = MAKE_SYNTAX (unrelativable_music, (yyloc), yyval);
		}
		parser->lexer_->pop_state ();
	}
#line 6325 "./out/parser.cc"
    break;

  case 336: /* mode_changing_head: "\\notemode"  */
#line 2656 "parser.yy"
                 {
		parser->lexer_->push_note_state ();

		yyval = ly_symbol2scm ("notes");
	}
#line 6335 "./out/parser.cc"
    break;

  case 337: /* mode_changing_head: "\\drummode"  */
#line 2662 "parser.yy"
                {
		parser->lexer_->push_drum_state ();
		yyval = ly_symbol2scm ("drums");
	}
#line 6344 "./out/parser.cc"
    break;

  case 338: /* mode_changing_head: "\\figuremode"  */
#line 2666 "parser.yy"
                     {
		parser->lexer_->push_figuredbass_state ();

		yyval = ly_symbol2scm ("figures");
	}
#line 6354 "./out/parser.cc"
    break;

  case 339: /* mode_changing_head: "\\chordmode"  */
#line 2671 "parser.yy"
                    {
		SCM mods = parser->lexer_->lookup_identifier_symbol (ly_symbol2scm ("chordmodifiers"));
		parser->lexer_->chordmodifier_tab_ = alist_to_hashq (mods);
		parser->lexer_->push_chord_state ();
		yyval = ly_symbol2scm ("chords");

	}
#line 6366 "./out/parser.cc"
    break;

  case 340: /* mode_changing_head: "\\lyricmode"  */
#line 2679 "parser.yy"
                { parser->lexer_->push_lyric_state ();
		yyval = ly_symbol2scm ("lyrics");
	}
#line 6374 "./out/parser.cc"
    break;

  case 341: /* mode_changing_head_with_context: "\\drums"  */
#line 2685 "parser.yy"
              {
		parser->lexer_->push_drum_state();
		yyval = ly_symbol2scm ("DrumStaff");
	}
#line 6383 "./out/parser.cc"
    break;

  case 342: /* mode_changing_head_with_context: "\\figures"  */
#line 2689 "parser.yy"
                  {
		parser->lexer_->push_figuredbass_state ();

		yyval = ly_symbol2scm ("FiguredBass");
	}
#line 6393 "./out/parser.cc"
    break;

  case 343: /* mode_changing_head_with_context: "\\chords"  */
#line 2694 "parser.yy"
                 {
		SCM mods = parser->lexer_->lookup_identifier_symbol (ly_symbol2scm ("chordmodifiers"));
		parser->lexer_->chordmodifier_tab_ = alist_to_hashq (mods);
		parser->lexer_->push_chord_state ();
		yyval = ly_symbol2scm ("ChordNames");
	}
#line 6404 "./out/parser.cc"
    break;

  case 344: /* mode_changing_head_with_context: "\\lyrics"  */
#line 2701 "parser.yy"
                { parser->lexer_->push_lyric_state ();
		yyval = ly_symbol2scm ("Lyrics");
	}
#line 6412 "./out/parser.cc"
    break;

  case 345: /* context_change: "\\change" symbol '=' simple_string  */
#line 2707 "parser.yy"
                                         {
		yyval = MAKE_SYNTAX (context_change, (yyloc), yyvsp[-2], yyvsp[0]);
	}
#line 6420 "./out/parser.cc"
    break;

  case 346: /* property_path: symbol_list_rev  */
#line 2714 "parser.yy"
                         {
		yyval = scm_reverse_x (yyvsp[0], SCM_EOL);
	}
#line 6428 "./out/parser.cc"
    break;

  case 347: /* property_operation: symbol '=' scalar  */
#line 2720 "parser.yy"
                          {
		yyval = scm_list_3 (ly_symbol2scm ("assign"), yyvsp[-2], yyvsp[0]);
	}
#line 6436 "./out/parser.cc"
    break;

  case 348: /* property_operation: "\\unset" symbol  */
#line 2723 "parser.yy"
                       {
		yyval = scm_list_2 (ly_symbol2scm ("unset"), yyvsp[0]);
	}
#line 6444 "./out/parser.cc"
    break;

  case 349: /* property_operation: "\\override" revert_arg '=' scalar  */
#line 2726 "parser.yy"
                                         {
		if (scm_ilength (yyvsp[-2]) < 2) {
			parser->parser_error ((yylsp[-2]), _("bad grob property path"));
			yyval = SCM_UNDEFINED;
		} else {
			yyval = scm_cons (ly_symbol2scm ("push"),
				       scm_cons2 (scm_car (yyvsp[-2]),
						  yyvsp[0],
						  scm_cdr (yyvsp[-2])));
		}
	}
#line 6460 "./out/parser.cc"
    break;

  case 350: /* property_operation: "\\revert" revert_arg  */
#line 2737 "parser.yy"
                            {
		yyval = scm_cons (ly_symbol2scm ("pop"), yyvsp[0]);
	}
#line 6468 "./out/parser.cc"
    break;

  case 351: /* revert_arg: revert_arg_backup "(backed-up?)" symbol_list_arg  */
#line 2767 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 6476 "./out/parser.cc"
    break;

  case 352: /* revert_arg_backup: revert_arg_part  */
#line 2774 "parser.yy"
        {
		if (scm_is_null (yyvsp[0])
		    || scm_is_null (scm_cdr (yyvsp[0])))
			MYBACKUP (SCM_ARG, yyvsp[0], (yylsp[0]));
		else
			MYBACKUP (SYMBOL_LIST, scm_reverse_x (yyvsp[0], SCM_EOL), (yylsp[0]));
	}
#line 6488 "./out/parser.cc"
    break;

  case 354: /* revert_arg_part: revert_arg_backup "(backed-up?)" SCM_ARG '.' symbol_list_part  */
#line 2787 "parser.yy"
        {
		yyval = scm_append_x (scm_list_2 (yyvsp[0], yyvsp[-2]));
	}
#line 6496 "./out/parser.cc"
    break;

  case 355: /* revert_arg_part: revert_arg_backup "(backed-up?)" SCM_ARG ',' symbol_list_part  */
#line 2791 "parser.yy"
        {
		yyval = scm_append_x (scm_list_2 (yyvsp[0], yyvsp[-2]));
	}
#line 6504 "./out/parser.cc"
    break;

  case 356: /* revert_arg_part: revert_arg_backup "(backed-up?)" SCM_ARG symbol_list_part  */
#line 2795 "parser.yy"
        {
		yyval = scm_append_x (scm_list_2 (yyvsp[0], yyvsp[-1]));
	}
#line 6512 "./out/parser.cc"
    break;

  case 357: /* context_def_mod: "\\consists"  */
#line 2801 "parser.yy"
                 { yyval = ly_symbol2scm ("consists"); }
#line 6518 "./out/parser.cc"
    break;

  case 358: /* context_def_mod: "\\remove"  */
#line 2802 "parser.yy"
                 { yyval = ly_symbol2scm ("remove"); }
#line 6524 "./out/parser.cc"
    break;

  case 359: /* context_def_mod: "\\accepts"  */
#line 2804 "parser.yy"
                  { yyval = ly_symbol2scm ("accepts"); }
#line 6530 "./out/parser.cc"
    break;

  case 360: /* context_def_mod: "\\defaultchild"  */
#line 2805 "parser.yy"
                       { yyval = ly_symbol2scm ("default-child"); }
#line 6536 "./out/parser.cc"
    break;

  case 361: /* context_def_mod: "\\denies"  */
#line 2806 "parser.yy"
                 { yyval = ly_symbol2scm ("denies"); }
#line 6542 "./out/parser.cc"
    break;

  case 362: /* context_def_mod: "\\alias"  */
#line 2808 "parser.yy"
                { yyval = ly_symbol2scm ("alias"); }
#line 6548 "./out/parser.cc"
    break;

  case 363: /* context_def_mod: "\\type"  */
#line 2809 "parser.yy"
               { yyval = ly_symbol2scm ("translator-type"); }
#line 6554 "./out/parser.cc"
    break;

  case 364: /* context_def_mod: "\\description"  */
#line 2810 "parser.yy"
                      { yyval = ly_symbol2scm ("description"); }
#line 6560 "./out/parser.cc"
    break;

  case 365: /* context_def_mod: "\\name"  */
#line 2811 "parser.yy"
               { yyval = ly_symbol2scm ("context-name"); }
#line 6566 "./out/parser.cc"
    break;

  case 366: /* context_mod: property_operation  */
#line 2815 "parser.yy"
                           { yyval = yyvsp[0]; }
#line 6572 "./out/parser.cc"
    break;

  case 367: /* context_mod: context_def_mod STRING  */
#line 2816 "parser.yy"
                                 {
		yyval = scm_list_2 (yyvsp[-1], yyvsp[0]);
	}
#line 6580 "./out/parser.cc"
    break;

  case 368: /* context_mod: context_def_mod SYMBOL  */
#line 2819 "parser.yy"
                                 {
		yyval = scm_list_2 (yyvsp[-1], yyvsp[0]);
	}
#line 6588 "./out/parser.cc"
    break;

  case 369: /* context_mod: context_def_mod embedded_scm  */
#line 2823 "parser.yy"
        {
		if (!scm_is_string (yyvsp[0])
		    && !scm_is_eq (yyvsp[-1], ly_symbol2scm ("consists"))
		    && !scm_is_eq (yyvsp[-1], ly_symbol2scm ("remove")))
		{
			yyval = SCM_EOL;
			parser->parser_error ((yylsp[-1]), _ ("only \\consists and \\remove take non-string argument."));
		}
		else
		{
			yyval = scm_list_2 (yyvsp[-1], yyvsp[0]);
		}
	}
#line 6606 "./out/parser.cc"
    break;

  case 370: /* grob_prop_spec: symbol_list_rev  */
#line 2841 "parser.yy"
        {
		SCM l = scm_reverse_x (yyvsp[0], SCM_EOL);
		if (scm_is_pair (l)
		    && from_scm<bool>
		    (scm_object_property (scm_car (l),
					  ly_symbol2scm ("is-grob?"))))
			l = scm_cons (ly_symbol2scm ("Bottom"), l);
		if (scm_is_null (l) || scm_is_null (scm_cdr (l))) {
			parser->parser_error ((yylsp[0]), _ ("bad grob property path"));
			l = SCM_UNDEFINED;
		}
		yyval = l;
	}
#line 6624 "./out/parser.cc"
    break;

  case 371: /* grob_prop_path: grob_prop_spec  */
#line 2859 "parser.yy"
        {
		if (!SCM_UNBNDP (yyvsp[0]) && scm_is_null (scm_cddr (yyvsp[0])))
		{
			parser->parser_error ((yylsp[0]), _ ("bad grob property path"));
			yyval = SCM_UNDEFINED;
		}
	}
#line 6636 "./out/parser.cc"
    break;

  case 372: /* grob_prop_path: grob_prop_spec property_path  */
#line 2867 "parser.yy"
        {
		if (!SCM_UNBNDP (yyvsp[-1])) {
			yyval = scm_append_x (scm_list_2 (yyvsp[-1], yyvsp[0]));
			if (scm_is_null (scm_cddr (yyval))) {
				parser->parser_error ((yyloc), _ ("bad grob property path"));
				yyval = SCM_UNDEFINED;
			}
		}

	}
#line 6651 "./out/parser.cc"
    break;

  case 373: /* context_prop_spec: symbol_list_rev  */
#line 2882 "parser.yy"
        {
		SCM l = scm_reverse_x (yyvsp[0], SCM_EOL);
		switch (scm_ilength (l)) {
		case 1:
			l = scm_cons (ly_symbol2scm ("Bottom"), l);
		case 2:
			break;
		default:
			parser->parser_error ((yylsp[0]), _ ("bad context property path"));
			l = SCM_UNDEFINED;
		}
		yyval = l;
	}
#line 6669 "./out/parser.cc"
    break;

  case 374: /* simple_revert_context: symbol_list_part  */
#line 2914 "parser.yy"
        {
		yyvsp[0] = scm_reverse_x (yyvsp[0], SCM_EOL);
		if (scm_is_null (yyvsp[0])
		    || from_scm<bool>
		    (scm_object_property (scm_car (yyvsp[0]),
					  ly_symbol2scm ("is-grob?")))) {
			yyval = ly_symbol2scm ("Bottom");
			parser->lexer_->push_extra_token ((yylsp[0]), SCM_IDENTIFIER, yyvsp[0]);
		} else {
			yyval = scm_car (yyvsp[0]);
			parser->lexer_->push_extra_token ((yylsp[0]), SCM_IDENTIFIER,
							  scm_cdr (yyvsp[0]));
		}
	}
#line 6688 "./out/parser.cc"
    break;

  case 375: /* music_property_def: "\\override" grob_prop_path '=' scalar  */
#line 2931 "parser.yy"
                                           {
		if (SCM_UNBNDP (yyvsp[-2]))
			yyval = MAKE_SYNTAX (void_music, (yyloc));
		else
			yyval = MAKE_SYNTAX (property_override, (yyloc),
					  scm_car (yyvsp[-2]),
					  scm_cdr (yyvsp[-2]),
					  yyvsp[0]);
	}
#line 6702 "./out/parser.cc"
    break;

  case 376: /* music_property_def: "\\revert" simple_revert_context revert_arg  */
#line 2940 "parser.yy"
                                                  {
		yyval = MAKE_SYNTAX (property_revert, (yyloc), yyvsp[-1], yyvsp[0]);
	}
#line 6710 "./out/parser.cc"
    break;

  case 377: /* music_property_def: "\\set" context_prop_spec '=' scalar  */
#line 2943 "parser.yy"
                                           {
		if (SCM_UNBNDP (yyvsp[-2]))
			yyval = MAKE_SYNTAX (void_music, (yyloc));
		else
			yyval = MAKE_SYNTAX (property_set, (yyloc),
					  scm_car (yyvsp[-2]),
					  scm_cadr (yyvsp[-2]),
					  yyvsp[0]);
	}
#line 6724 "./out/parser.cc"
    break;

  case 378: /* music_property_def: "\\unset" context_prop_spec  */
#line 2952 "parser.yy"
                                  {
		if (SCM_UNBNDP (yyvsp[0]))
			yyval = MAKE_SYNTAX (void_music, (yyloc));
		else
			yyval = MAKE_SYNTAX (property_unset, (yyloc),
					  scm_car (yyvsp[0]),
					  scm_cadr (yyvsp[0]));
	}
#line 6737 "./out/parser.cc"
    break;

  case 385: /* text: embedded_scm_bare  */
#line 2973 "parser.yy"
        {
		if (Text_interface::is_markup (yyvsp[0])) {
			yyval = yyvsp[0];
		} else {
			parser->parser_error ((yylsp[0]), (_ ("markup expected")));
			yyval = scm_string (SCM_EOL);
		}
	}
#line 6750 "./out/parser.cc"
    break;

  case 388: /* simple_string: embedded_scm_bare  */
#line 2986 "parser.yy"
        {
		if (scm_is_string (yyvsp[0])) {
			yyval = yyvsp[0];
		} else {
			parser->parser_error ((yylsp[0]), (_ ("simple string expected")));
			yyval = scm_string (SCM_EOL);
		}
	}
#line 6763 "./out/parser.cc"
    break;

  case 389: /* symbol: STRING  */
#line 2997 "parser.yy"
               {
		yyval = scm_string_to_symbol (yyvsp[0]);
	}
#line 6771 "./out/parser.cc"
    break;

  case 390: /* symbol: SYMBOL  */
#line 3001 "parser.yy"
        {
		if (!is_regular_identifier (yyvsp[0], false))
			parser->parser_error ((yylsp[0]), (_ ("symbol expected")));
		yyval = scm_string_to_symbol (yyvsp[0]);
	}
#line 6781 "./out/parser.cc"
    break;

  case 391: /* symbol: embedded_scm_bare  */
#line 3007 "parser.yy"
        {
		// This is a bit of overkill but makes the same
		// routine responsible for all symbol interpretations.
		yyval = try_string_variants (Guile_user::symbol_p, yyvsp[0]);
		if (SCM_UNBNDP (yyval))
		{
			parser->parser_error ((yylsp[0]), (_ ("symbol expected")));
			// Generate a unique symbol in case it is used
			// for an assignment or similar
			yyval = scm_make_symbol (ly_string2scm ("undefined"));
		}
	}
#line 6798 "./out/parser.cc"
    break;

  case 396: /* scalar: '-' bare_number  */
#line 3034 "parser.yy"
        {
		yyval = scm_difference (yyvsp[0], SCM_UNDEFINED);
	}
#line 6806 "./out/parser.cc"
    break;

  case 398: /* scalar: symbol_list_part_bare '.' property_path  */
#line 3039 "parser.yy"
        {
		yyval = scm_reverse_x (yyvsp[-2], yyvsp[0]);
	}
#line 6814 "./out/parser.cc"
    break;

  case 399: /* scalar: symbol_list_part_bare ',' property_path  */
#line 3043 "parser.yy"
        {
		yyval = scm_reverse_x (yyvsp[-2], yyvsp[0]);
	}
#line 6822 "./out/parser.cc"
    break;

  case 400: /* event_chord: simple_element post_events  */
#line 3049 "parser.yy"
                                   {
		// Let the rhythmic music iterator sort this mess out.
		if (scm_is_pair (yyvsp[0])) {
			set_property (unsmob<Music> (yyval), "articulations",
							 scm_reverse_x (yyvsp[0], SCM_EOL));
		}
	}
#line 6834 "./out/parser.cc"
    break;

  case 401: /* event_chord: CHORD_REPETITION optional_notemode_duration post_events  */
#line 3056 "parser.yy"
                                                                  {
		yyval = MAKE_SYNTAX (repetition_chord, (yyloc),
				  yyvsp[-1], scm_reverse_x (yyvsp[0], SCM_EOL));
	}
#line 6843 "./out/parser.cc"
    break;

  case 402: /* event_chord: MULTI_MEASURE_REST optional_notemode_duration post_events  */
#line 3060 "parser.yy"
                                                                    {
		yyval = MAKE_SYNTAX (multi_measure_rest, (yyloc), yyvsp[-1],
				  scm_reverse_x (yyvsp[0], SCM_EOL));
	}
#line 6852 "./out/parser.cc"
    break;

  case 405: /* note_chord_element: chord_body optional_notemode_duration post_events  */
#line 3071 "parser.yy"
        {
		Music *m = unsmob<Music> (yyvsp[-2]);
		SCM dur = unsmob<Duration> (yyvsp[-1])->smobbed_copy ();
		SCM es = get_property (m, "elements");
		SCM postevs = scm_reverse_x (yyvsp[0], SCM_EOL);

		for (SCM s = es; scm_is_pair (s); s = scm_cdr (s))
			set_property (unsmob<Music> (scm_car (s)), "duration", dur);
		es = ly_append2 (es, postevs);

		set_property (m, "elements", es);
		m->set_spot (parser->lexer_->override_input ((yyloc)));
		yyval = m->self_scm ();
	}
#line 6871 "./out/parser.cc"
    break;

  case 406: /* chord_body: "<" chord_body_elements ">"  */
#line 3089 "parser.yy"
        {
		yyval = MAKE_SYNTAX (event_chord, (yyloc),
				  reverse_music_list (parser, (yyloc),
						      yyvsp[-1], false, false));
	}
#line 6881 "./out/parser.cc"
    break;

  case 407: /* chord_body: FIGURE_OPEN figure_list FIGURE_CLOSE  */
#line 3095 "parser.yy"
        {
		yyval = MAKE_SYNTAX (event_chord, (yyloc), scm_reverse_x (yyvsp[-1], SCM_EOL));
	}
#line 6889 "./out/parser.cc"
    break;

  case 408: /* chord_body_elements: %empty  */
#line 3101 "parser.yy"
                                { yyval = SCM_EOL; }
#line 6895 "./out/parser.cc"
    break;

  case 409: /* chord_body_elements: chord_body_elements chord_body_element  */
#line 3102 "parser.yy"
                                                 {
		if (unsmob<Music> (yyvsp[0]))
			yyval = scm_cons (yyvsp[0], yyvsp[-1]);
	}
#line 6904 "./out/parser.cc"
    break;

  case 410: /* chord_body_element: pitch_or_tonic_pitch exclamations questions octave_check post_events  */
#line 3110 "parser.yy"
        {
		bool q = from_scm<bool> (yyvsp[-2]);
		bool ex = from_scm<bool> (yyvsp[-3]);
		SCM check = yyvsp[-1];
		SCM post = yyvsp[0];

		Music *n = MY_MAKE_MUSIC ("NoteEvent", (yyloc));
		set_property (n, "pitch", yyvsp[-4]);
		if (q)
			set_property (n, "cautionary", SCM_BOOL_T);
                if (ex || q)
			set_property (n, "force-accidental", SCM_BOOL_T);

		if (scm_is_pair (post)) {
			SCM arts = scm_reverse_x (post, SCM_EOL);
			set_property (n, "articulations", arts);
		}
		if (scm_is_number (check))
		{
			int q = scm_to_int (check);
			set_property (n, "absolute-octave", to_scm (q-1));
		}

		yyval = n->unprotect ();
	}
#line 6934 "./out/parser.cc"
    break;

  case 411: /* chord_body_element: DRUM_PITCH post_events  */
#line 3135 "parser.yy"
                                           {
		Music *n = MY_MAKE_MUSIC ("NoteEvent", (yyloc));
		set_property (n, "drum-type", yyvsp[-1]);

		if (scm_is_pair (yyvsp[0])) {
			SCM arts = scm_reverse_x (yyvsp[0], SCM_EOL);
			set_property (n, "articulations", arts);
		}
		yyval = n->unprotect ();
	}
#line 6949 "./out/parser.cc"
    break;

  case 412: /* chord_body_element: music_function_chord_body  */
#line 3146 "parser.yy"
        {
		Music *m = unsmob<Music> (yyvsp[0]);

		if (m && !m->is_mus_type ("post-event")) {
			while (m && m->is_mus_type ("music-wrapper-music")) {
				yyval = get_property (m, "element");
				m = unsmob<Music> (yyval);
			}

			if (!(m && m->is_mus_type ("rhythmic-event"))) {
				parser->parser_error ((yyloc), _ ("not a rhythmic event"));
				yyval = SCM_UNSPECIFIED;
			}
		}
	}
#line 6969 "./out/parser.cc"
    break;

  case 417: /* event_function_event: EVENT_FUNCTION function_arglist  */
#line 3171 "parser.yy"
                                        {
		yyval = MAKE_SYNTAX (music_function, (yyloc),
				  yyvsp[-1], yyvsp[0]);
	}
#line 6978 "./out/parser.cc"
    break;

  case 418: /* post_events: %empty  */
#line 3178 "parser.yy"
                    {
		yyval = SCM_EOL;
	}
#line 6986 "./out/parser.cc"
    break;

  case 419: /* post_events: post_events post_event  */
#line 3181 "parser.yy"
                                 {
		yyval = post_event_cons (yyvsp[0], yyvsp[-1]);
	}
#line 6994 "./out/parser.cc"
    break;

  case 420: /* post_event_nofinger: direction_less_event  */
#line 3187 "parser.yy"
                             {
		yyval = yyvsp[0];
	}
#line 7002 "./out/parser.cc"
    break;

  case 421: /* post_event_nofinger: script_dir music_function_call  */
#line 3190 "parser.yy"
                                         {
		Music *m = unsmob<Music> (yyvsp[0]);
		if (!m->is_mus_type ("post-event")) {
			parser->parser_error ((yylsp[0]), _ ("post-event expected"));
			yyval = SCM_UNSPECIFIED;
		} else {
			m->set_spot (parser->lexer_->override_input ((yyloc)));
			if (!SCM_UNBNDP (yyvsp[-1]))
				set_property (m, "direction", yyvsp[-1]);
			yyval = yyvsp[0];
		}
	}
#line 7019 "./out/parser.cc"
    break;

  case 422: /* post_event_nofinger: "--"  */
#line 3202 "parser.yy"
                 {
		if (!parser->lexer_->is_lyric_state ())
			parser->parser_error ((yylsp[0]), _ ("have to be in Lyric mode for lyrics"));
		yyval = MY_MAKE_MUSIC ("HyphenEvent", (yyloc))->unprotect ();
	}
#line 7029 "./out/parser.cc"
    break;

  case 423: /* post_event_nofinger: "__"  */
#line 3207 "parser.yy"
                   {
		if (!parser->lexer_->is_lyric_state ())
			parser->parser_error ((yylsp[0]), _ ("have to be in Lyric mode for lyrics"));
		yyval = MY_MAKE_MUSIC ("ExtenderEvent", (yyloc))->unprotect ();
	}
#line 7039 "./out/parser.cc"
    break;

  case 424: /* post_event_nofinger: script_dir direction_reqd_event  */
#line 3212 "parser.yy"
                                          {
		if (Music *m = unsmob<Music> (yyvsp[0])) {
			m->set_spot (parser->lexer_->override_input ((yyloc)));
			if (!SCM_UNBNDP (yyvsp[-1]))
			{
				set_property (m, "direction", yyvsp[-1]);
			}
		}
		yyval = yyvsp[0];
	}
#line 7054 "./out/parser.cc"
    break;

  case 425: /* post_event_nofinger: script_dir direction_less_event  */
#line 3222 "parser.yy"
                                          {
		Music *m = unsmob<Music> (yyvsp[0]);
		m->set_spot (parser->lexer_->override_input ((yyloc)));
		if (!SCM_UNBNDP (yyvsp[-1]))
			set_property (m, "direction", yyvsp[-1]);
		yyval = yyvsp[0];
	}
#line 7066 "./out/parser.cc"
    break;

  case 426: /* post_event_nofinger: '^' fingering  */
#line 3230 "parser.yy"
        {
		Music *m = unsmob<Music> (yyvsp[0]);
		m->set_spot (parser->lexer_->override_input ((yyloc)));
		set_property (m, "direction", to_scm (UP));
		yyval = yyvsp[0];
	}
#line 7077 "./out/parser.cc"
    break;

  case 427: /* post_event_nofinger: '_' fingering  */
#line 3237 "parser.yy"
        {
		Music *m = unsmob<Music> (yyvsp[0]);
		m->set_spot (parser->lexer_->override_input ((yyloc)));
		set_property (m, "direction", to_scm (DOWN));
		yyval = yyvsp[0];
	}
#line 7088 "./out/parser.cc"
    break;

  case 429: /* post_event: '-' fingering  */
#line 3247 "parser.yy"
                        {
		unsmob<Music> (yyvsp[0])->set_spot (parser->lexer_->override_input ((yyloc)));
		yyval = yyvsp[0];
	}
#line 7097 "./out/parser.cc"
    break;

  case 430: /* string_number_event: E_UNSIGNED  */
#line 3254 "parser.yy"
                   {
		Music *s = MY_MAKE_MUSIC ("StringNumberEvent", (yyloc));
		set_property (s, "string-number", yyvsp[0]);
		yyval = s->unprotect ();
	}
#line 7107 "./out/parser.cc"
    break;

  case 432: /* direction_less_event: EVENT_IDENTIFIER  */
#line 3263 "parser.yy"
                                {
		yyval = yyvsp[0];
	}
#line 7115 "./out/parser.cc"
    break;

  case 433: /* direction_less_event: tremolo_type  */
#line 3266 "parser.yy"
                        {
               Music *a = MY_MAKE_MUSIC ("TremoloEvent", (yyloc));
               set_property (a, "tremolo-type", yyvsp[0]);
               yyval = a->unprotect ();
        }
#line 7125 "./out/parser.cc"
    break;

  case 435: /* direction_reqd_event: gen_text_def  */
#line 3275 "parser.yy"
                     {
		yyval = yyvsp[0];
	}
#line 7133 "./out/parser.cc"
    break;

  case 436: /* direction_reqd_event: script_abbreviation  */
#line 3278 "parser.yy"
                              {
		SCM sym = ly_symbol2scm (("dash" + ly_scm2string (yyvsp[0])).c_str());
		SCM s = parser->lexer_->lookup_identifier_symbol (sym);
		if (scm_is_string (s)) {
			Music *a = MY_MAKE_MUSIC ("ArticulationEvent", (yyloc));
			set_property (a, "articulation-type", s);
			yyval = a->unprotect ();
		} else {
			Music *original = unsmob<Music> (s);
			if (original && original->is_mus_type ("post-event")) {
				Music *a = original->clone ();
				// origin will be set by post_event_nofinger
				yyval = a->unprotect ();
			} else {
				parser->parser_error ((yylsp[0]), _ ("expecting string or post-event as script definition"));
				yyval = SCM_UNSPECIFIED;
			}
		}
	}
#line 7157 "./out/parser.cc"
    break;

  case 437: /* octave_check: %empty  */
#line 3300 "parser.yy"
             { yyval = SCM_EOL; }
#line 7163 "./out/parser.cc"
    break;

  case 438: /* octave_check: '=' quotes  */
#line 3301 "parser.yy"
                     { yyval = yyvsp[0]; }
#line 7169 "./out/parser.cc"
    break;

  case 439: /* quotes: %empty  */
#line 3306 "parser.yy"
        {
                yyval = SCM_INUM0;
	}
#line 7177 "./out/parser.cc"
    break;

  case 442: /* erroneous_quotes: quotes  */
#line 3315 "parser.yy"
               {
		if (scm_is_eq (SCM_INUM0, yyvsp[0]))
			yyval = SCM_UNDEFINED;
	}
#line 7186 "./out/parser.cc"
    break;

  case 443: /* sup_quotes: '\''  */
#line 3322 "parser.yy"
             {
		yyval = to_scm (1);
	}
#line 7194 "./out/parser.cc"
    break;

  case 444: /* sup_quotes: sup_quotes '\''  */
#line 3325 "parser.yy"
                          {
		yyval = scm_oneplus (yyvsp[-1]);
	}
#line 7202 "./out/parser.cc"
    break;

  case 445: /* sub_quotes: ','  */
#line 3331 "parser.yy"
            {
		yyval = to_scm (-1);
	}
#line 7210 "./out/parser.cc"
    break;

  case 446: /* sub_quotes: sub_quotes ','  */
#line 3334 "parser.yy"
                         {
		yyval = scm_oneminus (yyvsp[-1]);
	}
#line 7218 "./out/parser.cc"
    break;

  case 447: /* steno_pitch: NOTENAME_PITCH quotes  */
#line 3340 "parser.yy"
                              {
                if (!scm_is_eq (SCM_INUM0, yyvsp[0]))
                {
                        Pitch p = *unsmob<Pitch> (yyvsp[-1]);
                        p = p.transposed (Pitch (scm_to_int (yyvsp[0]), 0));
                        yyval = p.smobbed_copy ();
                }
	}
#line 7231 "./out/parser.cc"
    break;

  case 448: /* steno_tonic_pitch: TONICNAME_PITCH quotes  */
#line 3355 "parser.yy"
                               {
                if (!scm_is_eq (SCM_INUM0, yyvsp[0]))
                {
                        Pitch p = *unsmob<Pitch> (yyvsp[-1]);
                        p = p.transposed (Pitch (scm_to_int (yyvsp[0]), 0));
                        yyval = p.smobbed_copy ();
                }
	}
#line 7244 "./out/parser.cc"
    break;

  case 450: /* pitch: PITCH_IDENTIFIER quotes  */
#line 3367 "parser.yy"
                                  {
                if (!scm_is_eq (SCM_INUM0, yyvsp[0]))
                {
                        Pitch p = *unsmob<Pitch> (yyvsp[-1]);
                        p = p.transposed (Pitch (scm_to_int (yyvsp[0]), 0));
                        yyval = p.smobbed_copy ();
                }
	}
#line 7257 "./out/parser.cc"
    break;

  case 453: /* gen_text_def: full_markup  */
#line 3383 "parser.yy"
                    {
		Music *t = MY_MAKE_MUSIC ("TextScriptEvent", (yyloc));
		set_property (t, "text", yyvsp[0]);
		yyval = t->unprotect ();
	}
#line 7267 "./out/parser.cc"
    break;

  case 454: /* gen_text_def: STRING  */
#line 3388 "parser.yy"
                 {
		Music *t = MY_MAKE_MUSIC ("TextScriptEvent", (yyloc));
		set_property (t, "text",
			make_simple_markup (yyvsp[0]));
		yyval = t->unprotect ();
	}
#line 7278 "./out/parser.cc"
    break;

  case 455: /* gen_text_def: SYMBOL  */
#line 3394 "parser.yy"
                 {
		// Flag a warning? could be unintentional
		Music *t = MY_MAKE_MUSIC ("TextScriptEvent", (yyloc));
		set_property (t, "text",
			make_simple_markup (yyvsp[0]));
		yyval = t->unprotect ();
	}
#line 7290 "./out/parser.cc"
    break;

  case 456: /* gen_text_def: embedded_scm  */
#line 3402 "parser.yy"
        {
		// Could be using this for every gen_text_def but for speed
		yyval = MAKE_SYNTAX (create_script, (yylsp[0]), yyvsp[0]);
	}
#line 7299 "./out/parser.cc"
    break;

  case 457: /* fingering: UNSIGNED  */
#line 3409 "parser.yy"
                 {
		Music *t = MY_MAKE_MUSIC ("FingeringEvent", (yyloc));
		set_property (t, "digit", yyvsp[0]);
		yyval = t->unprotect ();
	}
#line 7309 "./out/parser.cc"
    break;

  case 458: /* script_abbreviation: '^'  */
#line 3417 "parser.yy"
                        {
		yyval = scm_from_ascii_string ("Hat");
	}
#line 7317 "./out/parser.cc"
    break;

  case 459: /* script_abbreviation: '+'  */
#line 3420 "parser.yy"
                        {
		yyval = scm_from_ascii_string ("Plus");
	}
#line 7325 "./out/parser.cc"
    break;

  case 460: /* script_abbreviation: '-'  */
#line 3423 "parser.yy"
                        {
		yyval = scm_from_ascii_string ("Dash");
	}
#line 7333 "./out/parser.cc"
    break;

  case 461: /* script_abbreviation: '!'  */
#line 3426 "parser.yy"
                        {
		yyval = scm_from_ascii_string ("Bang");
	}
#line 7341 "./out/parser.cc"
    break;

  case 462: /* script_abbreviation: ">"  */
#line 3429 "parser.yy"
                        {
		yyval = scm_from_ascii_string ("Larger");
	}
#line 7349 "./out/parser.cc"
    break;

  case 463: /* script_abbreviation: '.'  */
#line 3432 "parser.yy"
                        {
		yyval = scm_from_ascii_string ("Dot");
	}
#line 7357 "./out/parser.cc"
    break;

  case 464: /* script_abbreviation: '_'  */
#line 3435 "parser.yy"
              {
		yyval = scm_from_ascii_string ("Underscore");
	}
#line 7365 "./out/parser.cc"
    break;

  case 465: /* script_dir: '_'  */
#line 3441 "parser.yy"
                { yyval = to_scm (DOWN); }
#line 7371 "./out/parser.cc"
    break;

  case 466: /* script_dir: '^'  */
#line 3442 "parser.yy"
                { yyval = to_scm (UP); }
#line 7377 "./out/parser.cc"
    break;

  case 467: /* script_dir: '-'  */
#line 3443 "parser.yy"
                { yyval = SCM_UNDEFINED; }
#line 7383 "./out/parser.cc"
    break;

  case 468: /* maybe_notemode_duration: %empty  */
#line 3447 "parser.yy"
        {
		yyval = SCM_UNDEFINED;
	}
#line 7391 "./out/parser.cc"
    break;

  case 469: /* maybe_notemode_duration: duration  */
#line 3450 "parser.yy"
                        {
		yyval = yyvsp[0];
		parser->default_duration_ = *unsmob<Duration> (yyval);
	}
#line 7400 "./out/parser.cc"
    break;

  case 470: /* optional_notemode_duration: maybe_notemode_duration  */
#line 3459 "parser.yy"
        {
		if (SCM_UNBNDP (yyval))
			yyval = parser->default_duration_.smobbed_copy ();
	}
#line 7409 "./out/parser.cc"
    break;

  case 471: /* steno_duration: UNSIGNED dots  */
#line 3466 "parser.yy"
                                {
		yyval = make_duration (yyvsp[-1], scm_to_int (yyvsp[0]));
		if (SCM_UNBNDP (yyval))
		{
			parser->parser_error ((yylsp[-1]), _ ("not a duration"));
			yyval = Duration ().smobbed_copy ();
		}
	}
#line 7422 "./out/parser.cc"
    break;

  case 472: /* steno_duration: DURATION_IDENTIFIER dots  */
#line 3474 "parser.yy"
                                        {
		yyval = make_duration (yyvsp[-1], scm_to_int (yyvsp[0]));
	}
#line 7430 "./out/parser.cc"
    break;

  case 473: /* duration: steno_duration multipliers  */
#line 3480 "parser.yy"
                                   {
		yyval = make_duration (yyvsp[-1], 0, yyvsp[0]);
	}
#line 7438 "./out/parser.cc"
    break;

  case 474: /* dots: %empty  */
#line 3486 "parser.yy"
                        {
		yyval = SCM_INUM0;
	}
#line 7446 "./out/parser.cc"
    break;

  case 475: /* dots: dots '.'  */
#line 3489 "parser.yy"
                   {
		yyval = scm_oneplus (yyvsp[-1]);
	}
#line 7454 "./out/parser.cc"
    break;

  case 478: /* multipliers: %empty  */
#line 3501 "parser.yy"
        {
		yyval = SCM_UNDEFINED;
	}
#line 7462 "./out/parser.cc"
    break;

  case 479: /* multipliers: multipliers '*' UNSIGNED  */
#line 3505 "parser.yy"
        {
		if (!SCM_UNBNDP (yyvsp[-2]))
			yyval = scm_product (yyvsp[-2], yyvsp[0]);
		else
			yyval = yyvsp[0];
	}
#line 7473 "./out/parser.cc"
    break;

  case 480: /* multipliers: multipliers '*' FRACTION  */
#line 3512 "parser.yy"
        {
		if (!SCM_UNBNDP (yyvsp[-2]))
			yyval = scm_product (yyvsp[-2], scm_divide (scm_car (yyvsp[0]),
							  scm_cdr (yyvsp[0])));
		else
			yyval = scm_divide (scm_car (yyvsp[0]), scm_cdr (yyvsp[0]));
	}
#line 7485 "./out/parser.cc"
    break;

  case 481: /* multipliers: multipliers '*' multiplier_scm  */
#line 3520 "parser.yy"
        {
		if (scm_is_false (Lily::scale_p (yyvsp[0])))
		{
			parser->parser_error ((yylsp[0]), _ ("not a multiplier"));
		} else if (SCM_UNBNDP (yyvsp[-2]))
			yyval = Lily::scale_to_factor (yyvsp[0]);
		else
			yyval = scm_product (yyvsp[-2], Lily::scale_to_factor (yyvsp[0]));
	}
#line 7499 "./out/parser.cc"
    break;

  case 482: /* tremolo_type: ':'  */
#line 3532 "parser.yy"
                {
		yyval = to_scm (parser->default_tremolo_type_);
	}
#line 7507 "./out/parser.cc"
    break;

  case 483: /* tremolo_type: ':' UNSIGNED  */
#line 3535 "parser.yy"
                       {
		if (SCM_UNBNDP (make_duration (yyvsp[0]))) {
			parser->parser_error ((yylsp[0]), _ ("not a duration"));
			yyval = to_scm (parser->default_tremolo_type_);
		} else {
			yyval = yyvsp[0];
			parser->default_tremolo_type_ = scm_to_int (yyvsp[0]);
		}
	}
#line 7521 "./out/parser.cc"
    break;

  case 488: /* bass_number: embedded_scm_bare  */
#line 3552 "parser.yy"
        {
		// as an integer, it needs to be non-negative, and otherwise
		// it needs to be suitable as a markup.
		if (scm_is_integer (yyvsp[0])
		    ? scm_is_true (scm_negative_p (yyvsp[0]))
		    : !Text_interface::is_markup (yyvsp[0]))
		{
			parser->parser_error ((yylsp[0]), _ ("bass number expected"));
			yyval = SCM_INUM0;
		}
	}
#line 7537 "./out/parser.cc"
    break;

  case 489: /* figured_bass_alteration: '-'  */
#line 3566 "parser.yy"
                { yyval = to_scm (FLAT_ALTERATION); }
#line 7543 "./out/parser.cc"
    break;

  case 490: /* figured_bass_alteration: '+'  */
#line 3567 "parser.yy"
                { yyval = to_scm (SHARP_ALTERATION); }
#line 7549 "./out/parser.cc"
    break;

  case 491: /* figured_bass_alteration: '!'  */
#line 3568 "parser.yy"
                { yyval = to_scm (0); }
#line 7555 "./out/parser.cc"
    break;

  case 492: /* bass_figure: "_"  */
#line 3572 "parser.yy"
                     {
		Music *bfr = MY_MAKE_MUSIC ("BassFigureEvent", (yyloc));
		yyval = bfr->unprotect ();
	}
#line 7564 "./out/parser.cc"
    break;

  case 493: /* bass_figure: bass_number  */
#line 3576 "parser.yy"
                       {
		Music *bfr = MY_MAKE_MUSIC ("BassFigureEvent", (yyloc));
		yyval = bfr->self_scm ();

		if (scm_is_number (yyvsp[0]))
			set_property (bfr, "figure", yyvsp[0]);
		else if (Text_interface::is_markup (yyvsp[0]))
			set_property (bfr, "text", yyvsp[0]);

		bfr->unprotect ();
	}
#line 7580 "./out/parser.cc"
    break;

  case 494: /* bass_figure: bass_figure ']'  */
#line 3587 "parser.yy"
                          {
		yyval = yyvsp[-1];
		set_property (unsmob<Music> (yyvsp[-1]), "bracket-stop", SCM_BOOL_T);
	}
#line 7589 "./out/parser.cc"
    break;

  case 495: /* bass_figure: bass_figure figured_bass_alteration  */
#line 3591 "parser.yy"
                                              {
		Music *m = unsmob<Music> (yyvsp[-1]);
		if (scm_to_double (yyvsp[0])) {
			SCM salter = get_property (m, "alteration");
			SCM alter = scm_is_number (salter) ? salter : to_scm (0);
			set_property (m, "alteration",
					 scm_sum (alter, yyvsp[0]));
		} else {
			set_property (m, "alteration", to_scm (0));
		}
	}
#line 7605 "./out/parser.cc"
    break;

  case 496: /* bass_figure: bass_figure figured_bass_modification  */
#line 3602 "parser.yy"
                                                 {
		Music *m = unsmob<Music> (yyvsp[-1]);
		set_property (m, yyvsp[0], SCM_BOOL_T);
	}
#line 7614 "./out/parser.cc"
    break;

  case 497: /* figured_bass_modification: "\\+"  */
#line 3610 "parser.yy"
                        {
		yyval = ly_symbol2scm ("augmented");
	}
#line 7622 "./out/parser.cc"
    break;

  case 498: /* figured_bass_modification: "\\!"  */
#line 3613 "parser.yy"
                        {
		yyval = ly_symbol2scm ("no-continuation");
	}
#line 7630 "./out/parser.cc"
    break;

  case 499: /* figured_bass_modification: '/'  */
#line 3616 "parser.yy"
                        {
		yyval = ly_symbol2scm ("diminished");
	}
#line 7638 "./out/parser.cc"
    break;

  case 500: /* figured_bass_modification: "\\\\"  */
#line 3619 "parser.yy"
                      {
		yyval = ly_symbol2scm ("augmented-slash");
	}
#line 7646 "./out/parser.cc"
    break;

  case 501: /* br_bass_figure: bass_figure  */
#line 3625 "parser.yy"
                    {
		yyval = yyvsp[0];
	}
#line 7654 "./out/parser.cc"
    break;

  case 502: /* br_bass_figure: '[' bass_figure  */
#line 3628 "parser.yy"
                          {
		yyval = yyvsp[0];
		set_property (unsmob<Music> (yyval), "bracket-start", SCM_BOOL_T);
	}
#line 7663 "./out/parser.cc"
    break;

  case 503: /* figure_list: %empty  */
#line 3635 "parser.yy"
                        {
		yyval = SCM_EOL;
	}
#line 7671 "./out/parser.cc"
    break;

  case 504: /* figure_list: figure_list br_bass_figure  */
#line 3638 "parser.yy"
                                     {
		yyval = scm_cons (yyvsp[0], yyvsp[-1]);
	}
#line 7679 "./out/parser.cc"
    break;

  case 505: /* optional_rest: %empty  */
#line 3644 "parser.yy"
               { yyval = SCM_BOOL_F; }
#line 7685 "./out/parser.cc"
    break;

  case 506: /* optional_rest: "\\rest"  */
#line 3645 "parser.yy"
               { yyval = SCM_BOOL_T; }
#line 7691 "./out/parser.cc"
    break;

  case 507: /* pitch_or_music: pitch exclamations questions octave_check maybe_notemode_duration erroneous_quotes optional_rest post_events  */
#line 3653 "parser.yy"
                                                                                                                     {
		if (!parser->lexer_->is_note_state ())
			parser->parser_error ((yylsp[-7]), _ ("have to be in Note mode for notes"));
		if (!SCM_UNBNDP (yyvsp[-2]))
		{
			// It's possible to get here without a
			// duration, like when there is no
			// octave_check but a question mark.  But we
			// point out the most frequent error of an
			// interspersed duration specifically
			if (!SCM_UNBNDP (yyvsp[-3]))
				parser->parser_error ((yylsp[-2]), _ ("octave marks must precede duration"));
			else
				parser->parser_error ((yylsp[-2]), _ ("badly placed octave marks"));
			// Try sorting the quotes to where they likely belong
			if (scm_is_number (yyvsp[-4])) {
				yyvsp[-4] = scm_sum (yyvsp[-4], yyvsp[-2]);
			} else {
				yyvsp[-7] = unsmob<Pitch> (yyvsp[-7])->transposed
					(Pitch (scm_to_int (yyvsp[-2]), 0)).smobbed_copy ();
			}
		}

		if (!SCM_UNBNDP (yyvsp[-6])
                    || !SCM_UNBNDP (yyvsp[-5])
                    || scm_is_number (yyvsp[-4])
                    || !SCM_UNBNDP (yyvsp[-3])
		    || scm_is_true (yyvsp[-1])
		    || scm_is_pair (yyvsp[0]))
		{
			Music *n = 0;
			if (scm_is_true (yyvsp[-1]))
				n = MY_MAKE_MUSIC ("RestEvent", (yyloc));
			else
				n = MY_MAKE_MUSIC ("NoteEvent", (yyloc));

			set_property (n, "pitch", yyvsp[-7]);
			if (SCM_UNBNDP (yyvsp[-3]))
				set_property (n, "duration",
						 parser->default_duration_.smobbed_copy ());
			else
				set_property (n, "duration", yyvsp[-3]);

			if (scm_is_number (yyvsp[-4]))
			{
				int q = scm_to_int (yyvsp[-4]);
				set_property (n, "absolute-octave", to_scm (q-1));
			}

			if (from_scm<bool> (yyvsp[-5]))
				set_property (n, "cautionary", SCM_BOOL_T);
			if (from_scm<bool> (yyvsp[-6]) || from_scm<bool> (yyvsp[-5]))
				set_property (n, "force-accidental", SCM_BOOL_T);
			if (scm_is_pair (yyvsp[0]))
				set_property (n, "articulations",
						 scm_reverse_x (yyvsp[0], SCM_EOL));
			yyval = n->unprotect ();
		}
	}
#line 7755 "./out/parser.cc"
    break;

  case 508: /* pitch_or_music: new_chord post_events  */
#line 3712 "parser.yy"
                                {
		if (!parser->lexer_->is_chord_state ())
                        parser->parser_error ((yylsp[-1]), _ ("have to be in Chord mode for chords"));
		if (scm_is_pair (yyvsp[0])) {
			if (unsmob<Pitch> (yyvsp[-1]))
				yyvsp[-1] = make_chord_elements ((yylsp[-1]),
							  yyvsp[-1],
							  parser->default_duration_.smobbed_copy (),
							  SCM_EOL);

			SCM elts = ly_append2 (yyvsp[-1], scm_reverse_x (yyvsp[0], SCM_EOL));

			yyval = MAKE_SYNTAX (event_chord, (yylsp[-1]), elts);
		} else if (!unsmob<Pitch> (yyvsp[-1]))
			yyval = MAKE_SYNTAX (event_chord, (yylsp[-1]), yyvsp[-1]);
		// A mere pitch drops through.
	}
#line 7777 "./out/parser.cc"
    break;

  case 509: /* simple_element: DRUM_PITCH optional_notemode_duration  */
#line 3732 "parser.yy"
                                              {
		Music *n = MY_MAKE_MUSIC ("NoteEvent", (yyloc));
		set_property (n, "duration", yyvsp[0]);
		set_property (n, "drum-type", yyvsp[-1]);

		yyval = n->unprotect ();
	}
#line 7789 "./out/parser.cc"
    break;

  case 510: /* simple_element: RESTNAME optional_notemode_duration  */
#line 3739 "parser.yy"
                                                        {
		Music *ev = 0;
 		if (ly_scm2string (yyvsp[-1]) == "s") {
			/* Space */
			ev = MY_MAKE_MUSIC ("SkipEvent", (yyloc));
		  }
		else {
			ev = MY_MAKE_MUSIC ("RestEvent", (yyloc));

		    }
		set_property (ev, "duration", yyvsp[0]);
 		yyval = ev->unprotect ();
	}
#line 7807 "./out/parser.cc"
    break;

  case 511: /* lyric_element: full_markup  */
#line 3755 "parser.yy"
                    {
		if (!parser->lexer_->is_lyric_state ())
			parser->parser_error ((yylsp[0]), _ ("markup outside of text script or \\lyricmode"));
		yyval = yyvsp[0];
	}
#line 7817 "./out/parser.cc"
    break;

  case 512: /* lyric_element: SYMBOL  */
#line 3760 "parser.yy"
                 {
		if (!parser->lexer_->is_lyric_state ())
			parser->parser_error ((yylsp[0]), _f ("not a note name: %s", ly_scm2string (yyvsp[0])));
		yyval = yyvsp[0];
	}
#line 7827 "./out/parser.cc"
    break;

  case 513: /* lyric_element: STRING  */
#line 3765 "parser.yy"
                 {
		if (!parser->lexer_->is_lyric_state ())
			parser->parser_error ((yylsp[0]), _ ("string outside of text script or \\lyricmode"));
		yyval = yyvsp[0];
	}
#line 7837 "./out/parser.cc"
    break;

  case 515: /* lyric_element_music: lyric_element optional_notemode_duration post_events  */
#line 3774 "parser.yy"
                                                             {
		yyval = MAKE_SYNTAX (lyric_event, (yyloc), yyvsp[-2], yyvsp[-1]);
		if (scm_is_pair (yyvsp[0]))
			set_property
				(unsmob<Music> (yyval), "articulations", scm_reverse_x (yyvsp[0], SCM_EOL));
	}
#line 7848 "./out/parser.cc"
    break;

  case 516: /* new_chord: steno_tonic_pitch maybe_notemode_duration  */
#line 3784 "parser.yy"
                                                    {
		if (SCM_UNBNDP (yyvsp[0]))
			yyval = yyvsp[-1];
		else
			yyval = make_chord_elements ((yyloc), yyvsp[-1], yyvsp[0], SCM_EOL);
	}
#line 7859 "./out/parser.cc"
    break;

  case 517: /* new_chord: steno_tonic_pitch optional_notemode_duration chord_separator chord_items  */
#line 3790 "parser.yy"
                                                                                   {
		SCM its = scm_reverse_x (yyvsp[0], SCM_EOL);
		yyval = make_chord_elements ((yyloc), yyvsp[-3], yyvsp[-2], scm_cons (yyvsp[-1], its));
	}
#line 7868 "./out/parser.cc"
    break;

  case 518: /* chord_items: %empty  */
#line 3797 "parser.yy"
             {
		yyval = SCM_EOL;
	}
#line 7876 "./out/parser.cc"
    break;

  case 519: /* chord_items: chord_items chord_item  */
#line 3800 "parser.yy"
                                 {
		yyval = scm_cons (yyvsp[0], yyval);
	}
#line 7884 "./out/parser.cc"
    break;

  case 520: /* chord_separator: ":"  */
#line 3806 "parser.yy"
                    {
		yyval = ly_symbol2scm ("chord-colon");
	}
#line 7892 "./out/parser.cc"
    break;

  case 521: /* chord_separator: "^"  */
#line 3809 "parser.yy"
                      {
		yyval = ly_symbol2scm ("chord-caret");
	}
#line 7900 "./out/parser.cc"
    break;

  case 522: /* chord_separator: "/" steno_tonic_pitch  */
#line 3812 "parser.yy"
                                        {
 		yyval = scm_list_2 (ly_symbol2scm ("chord-slash"), yyvsp[0]);
	}
#line 7908 "./out/parser.cc"
    break;

  case 523: /* chord_separator: "/+" steno_tonic_pitch  */
#line 3815 "parser.yy"
                                       {
		yyval = scm_list_2 (ly_symbol2scm ("chord-bass"), yyvsp[0]);
	}
#line 7916 "./out/parser.cc"
    break;

  case 524: /* chord_item: chord_separator  */
#line 3821 "parser.yy"
                        {
		yyval = yyvsp[0];
	}
#line 7924 "./out/parser.cc"
    break;

  case 525: /* chord_item: step_numbers  */
#line 3824 "parser.yy"
                       {
		yyval = scm_reverse_x (yyvsp[0], SCM_EOL);
	}
#line 7932 "./out/parser.cc"
    break;

  case 526: /* chord_item: CHORD_MODIFIER  */
#line 3827 "parser.yy"
                          {
		yyval = yyvsp[0];
	}
#line 7940 "./out/parser.cc"
    break;

  case 527: /* step_numbers: step_number  */
#line 3833 "parser.yy"
                    { yyval = scm_cons (yyvsp[0], SCM_EOL); }
#line 7946 "./out/parser.cc"
    break;

  case 528: /* step_numbers: step_numbers '.' step_number  */
#line 3834 "parser.yy"
                                       {
		yyval = scm_cons (yyvsp[0], yyval);
	}
#line 7954 "./out/parser.cc"
    break;

  case 529: /* step_number: UNSIGNED  */
#line 3840 "parser.yy"
                 {
		yyval = make_chord_step (yyvsp[0], 0);
        }
#line 7962 "./out/parser.cc"
    break;

  case 530: /* step_number: UNSIGNED '+'  */
#line 3843 "parser.yy"
                       {
		yyval = make_chord_step (yyvsp[-1], SHARP_ALTERATION);
	}
#line 7970 "./out/parser.cc"
    break;

  case 531: /* step_number: UNSIGNED "-"  */
#line 3846 "parser.yy"
                               {
		yyval = make_chord_step (yyvsp[-1], FLAT_ALTERATION);
	}
#line 7978 "./out/parser.cc"
    break;

  case 532: /* tempo_range: unsigned_number  */
#line 3852 "parser.yy"
                        {
		yyval = yyvsp[0];
	}
#line 7986 "./out/parser.cc"
    break;

  case 533: /* tempo_range: unsigned_number '-' unsigned_number  */
#line 3855 "parser.yy"
                                              {
		yyval = scm_cons (yyvsp[-2], yyvsp[0]);
	}
#line 7994 "./out/parser.cc"
    break;

  case 534: /* number_expression: number_expression '+' number_term  */
#line 3867 "parser.yy"
                                          {
		yyval = scm_sum (yyvsp[-2], yyvsp[0]);
	}
#line 8002 "./out/parser.cc"
    break;

  case 535: /* number_expression: number_expression '-' number_term  */
#line 3870 "parser.yy"
                                            {
		yyval = scm_difference (yyvsp[-2], yyvsp[0]);
	}
#line 8010 "./out/parser.cc"
    break;

  case 537: /* number_term: number_factor  */
#line 3877 "parser.yy"
                      {
		yyval = yyvsp[0];
	}
#line 8018 "./out/parser.cc"
    break;

  case 538: /* number_term: number_factor '*' number_factor  */
#line 3880 "parser.yy"
                                          {
		yyval = scm_product (yyvsp[-2], yyvsp[0]);
	}
#line 8026 "./out/parser.cc"
    break;

  case 539: /* number_term: number_factor '/' number_factor  */
#line 3883 "parser.yy"
                                          {
		yyval = scm_divide (yyvsp[-2], yyvsp[0]);
	}
#line 8034 "./out/parser.cc"
    break;

  case 540: /* number_factor: '-' number_factor  */
#line 3889 "parser.yy"
                           { /* %prec UNARY_MINUS */
		yyval = scm_difference (yyvsp[0], SCM_UNDEFINED);
	}
#line 8042 "./out/parser.cc"
    break;

  case 544: /* bare_number_common: REAL NUMBER_IDENTIFIER  */
#line 3899 "parser.yy"
        {
		yyval = scm_product (yyvsp[-1], yyvsp[0]);
	}
#line 8050 "./out/parser.cc"
    break;

  case 547: /* bare_number: UNSIGNED NUMBER_IDENTIFIER  */
#line 3907 "parser.yy"
                                        {
		yyval = scm_product (yyvsp[-1], yyvsp[0]);
	}
#line 8058 "./out/parser.cc"
    break;

  case 549: /* unsigned_number: NUMBER_IDENTIFIER  */
#line 3915 "parser.yy"
        {
		if (!scm_is_integer (yyvsp[0])
		    || scm_is_true (scm_negative_p (yyvsp[0])))
		{
			parser->parser_error ((yylsp[0]), _("not an unsigned integer"));
			yyval = SCM_INUM0;
		}
	}
#line 8071 "./out/parser.cc"
    break;

  case 550: /* unsigned_number: embedded_scm  */
#line 3924 "parser.yy"
        {
		if (!scm_is_integer (yyvsp[0])
		    || scm_is_true (scm_negative_p (yyvsp[0])))
		{
			parser->parser_error ((yylsp[0]), _("not an unsigned integer"));
			yyval = SCM_INUM0;
		}
	}
#line 8084 "./out/parser.cc"
    break;

  case 551: /* exclamations: %empty  */
#line 3935 "parser.yy"
                { yyval = SCM_UNDEFINED; }
#line 8090 "./out/parser.cc"
    break;

  case 552: /* exclamations: exclamations '!'  */
#line 3937 "parser.yy"
        {
                if (SCM_UNBNDP (yyvsp[-1]))
                        yyval = SCM_BOOL_T;
                else
                        yyval = scm_not (yyvsp[-1]);
        }
#line 8101 "./out/parser.cc"
    break;

  case 553: /* questions: %empty  */
#line 3952 "parser.yy"
        { yyval = SCM_UNDEFINED; }
#line 8107 "./out/parser.cc"
    break;

  case 554: /* questions: questions '?'  */
#line 3954 "parser.yy"
        {
                if (SCM_UNBNDP (yyvsp[-1]))
                        yyval = SCM_BOOL_T;
                else
                        yyval = scm_not (yyvsp[-1]);
        }
#line 8118 "./out/parser.cc"
    break;

  case 555: /* $@10: %empty  */
#line 3964 "parser.yy"
                { parser->lexer_->push_markup_state (); }
#line 8124 "./out/parser.cc"
    break;

  case 556: /* full_markup_list: "\\markuplist" $@10 markup_list  */
#line 3965 "parser.yy"
                    {
		yyval = yyvsp[0];
		parser->lexer_->pop_state ();
	}
#line 8133 "./out/parser.cc"
    break;

  case 557: /* markup_mode: "\\markup"  */
#line 3973 "parser.yy"
        {
		parser->lexer_->push_markup_state ();
	}
#line 8141 "./out/parser.cc"
    break;

  case 558: /* markup_mode_word: markup_mode markup_word  */
#line 3989 "parser.yy"
        {
		yyval = yyvsp[0];
		parser->lexer_->pop_state ();
	}
#line 8150 "./out/parser.cc"
    break;

  case 559: /* full_markup: markup_mode markup_top  */
#line 3997 "parser.yy"
                               {
		yyval = yyvsp[0];
		parser->lexer_->pop_state ();
	}
#line 8159 "./out/parser.cc"
    break;

  case 560: /* full_markup: markup_mode_word  */
#line 4002 "parser.yy"
        {
		yyval = make_simple_markup (yyvsp[0]);
	}
#line 8167 "./out/parser.cc"
    break;

  case 561: /* partial_markup: markup_mode markup_partial_function "\\etc"  */
#line 4009 "parser.yy"
        {
		yyval = MAKE_SYNTAX (partial_markup, (yylsp[-1]), yyvsp[-1]);
		parser->lexer_->pop_state ();
	}
#line 8176 "./out/parser.cc"
    break;

  case 562: /* markup_top: markup_list  */
#line 4016 "parser.yy"
                    {
		yyval = scm_list_2 (Lily::line_markup,  yyvsp[0]);
	}
#line 8184 "./out/parser.cc"
    break;

  case 563: /* markup_top: markup_head_1_list simple_markup  */
#line 4020 "parser.yy"
        {
		yyval = scm_car (MAKE_SYNTAX (composed_markup_list,
					   (yylsp[0]), yyvsp[-1], scm_list_1 (yyvsp[0])));
	}
#line 8193 "./out/parser.cc"
    break;

  case 564: /* markup_top: simple_markup_noword  */
#line 4024 "parser.yy"
                               {
		yyval = yyvsp[0];
	}
#line 8201 "./out/parser.cc"
    break;

  case 565: /* $@11: %empty  */
#line 4031 "parser.yy"
        {
		if (Text_interface::is_markup (yyvsp[0]))
			MYBACKUP (MARKUP_IDENTIFIER, yyvsp[0], (yylsp[0]));
		else if (Text_interface::is_markup_list (yyvsp[0]))
			MYBACKUP (MARKUPLIST_IDENTIFIER, yyvsp[0], (yylsp[0]));
		else {
			parser->parser_error ((yylsp[0]), _ ("not a markup"));
			MYBACKUP (MARKUP_IDENTIFIER, scm_string (SCM_EOL), (yylsp[0]));
		}
	}
#line 8216 "./out/parser.cc"
    break;

  case 567: /* markup_list: markup_composed_list  */
#line 4045 "parser.yy"
                             {
		yyval = yyvsp[0];
	}
#line 8224 "./out/parser.cc"
    break;

  case 569: /* markup_uncomposed_list: markup_braced_list  */
#line 4052 "parser.yy"
                           {
		yyval = yyvsp[0];
	}
#line 8232 "./out/parser.cc"
    break;

  case 570: /* markup_uncomposed_list: markup_command_list  */
#line 4055 "parser.yy"
                              {
		yyval = scm_list_1 (yyvsp[0]);
	}
#line 8240 "./out/parser.cc"
    break;

  case 571: /* markup_uncomposed_list: markup_scm MARKUPLIST_IDENTIFIER  */
#line 4059 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 8248 "./out/parser.cc"
    break;

  case 572: /* $@12: %empty  */
#line 4062 "parser.yy"
                     {
		parser->lexer_->push_note_state ();
	}
#line 8256 "./out/parser.cc"
    break;

  case 573: /* markup_uncomposed_list: "\\score-lines" $@12 '{' score_body '}'  */
#line 4064 "parser.yy"
                             {
		Score *sc = unsmob<Score> (yyvsp[-1]);
		sc->origin ()->set_spot ((yyloc));
		if (sc->defs_.empty ()) {
			Output_def *od = get_layout (parser);
			sc->add_output_def (od);
			od->unprotect ();
		}
		yyval = scm_list_1 (scm_list_2 (Lily::score_lines_markup_list, yyvsp[-1]));
		parser->lexer_->pop_state ();
	}
#line 8272 "./out/parser.cc"
    break;

  case 574: /* markup_composed_list: markup_head_1_list markup_uncomposed_list  */
#line 4078 "parser.yy"
                                                  {
		yyval = MAKE_SYNTAX (composed_markup_list,
				  (yylsp[0]), yyvsp[-1], yyvsp[0]);
	}
#line 8281 "./out/parser.cc"
    break;

  case 575: /* markup_braced_list: '{' markup_braced_list_body '}'  */
#line 4085 "parser.yy"
                                        {
		yyval = scm_reverse_x (yyvsp[-1], SCM_EOL);
	}
#line 8289 "./out/parser.cc"
    break;

  case 576: /* markup_braced_list_body: %empty  */
#line 4091 "parser.yy"
                        {  yyval = SCM_EOL; }
#line 8295 "./out/parser.cc"
    break;

  case 577: /* markup_braced_list_body: markup_braced_list_body markup  */
#line 4092 "parser.yy"
                                         {
		yyval = scm_cons (yyvsp[0], yyvsp[-1]);
	}
#line 8303 "./out/parser.cc"
    break;

  case 578: /* markup_braced_list_body: markup_braced_list_body markup_list  */
#line 4095 "parser.yy"
                                              {
		yyval = Srfi_1::append_reverse (yyvsp[0], yyvsp[-1]);
	}
#line 8311 "./out/parser.cc"
    break;

  case 579: /* markup_command_list: MARKUP_LIST_FUNCTION markup_command_list_arguments  */
#line 4101 "parser.yy"
                                                           {
	  yyval = scm_cons (yyvsp[-1], scm_reverse_x (yyvsp[0], SCM_EOL));
	}
#line 8319 "./out/parser.cc"
    break;

  case 580: /* $@13: %empty  */
#line 4107 "parser.yy"
            {
		parser->lexer_->push_note_state ();
	}
#line 8327 "./out/parser.cc"
    break;

  case 581: /* markup_command_embedded_lilypond: '{' $@13 embedded_lilypond '}'  */
#line 4109 "parser.yy"
                                {
		parser->lexer_->pop_state ();
                yyval = yyvsp[-1];
	}
#line 8336 "./out/parser.cc"
    break;

  case 582: /* markup_command_basic_arguments: "markup-list?" markup_command_list_arguments markup_list  */
#line 4117 "parser.yy"
                                                                     {
		yyval = scm_cons (yyvsp[0], yyvsp[-1]);
	}
#line 8344 "./out/parser.cc"
    break;

  case 583: /* markup_command_basic_arguments: "scheme?" markup_command_list_arguments embedded_scm  */
#line 4120 "parser.yy"
                                                                {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-1], yyvsp[-2]);
	}
#line 8352 "./out/parser.cc"
    break;

  case 584: /* markup_command_basic_arguments: "scheme?" markup_command_list_arguments markup_command_embedded_lilypond  */
#line 4124 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-1], yyvsp[-2]);
	}
#line 8360 "./out/parser.cc"
    break;

  case 585: /* markup_command_basic_arguments: "scheme?" markup_command_list_arguments mode_changed_music  */
#line 4127 "parser.yy"
                                                                      {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-1], yyvsp[-2]);
	}
#line 8368 "./out/parser.cc"
    break;

  case 586: /* markup_command_basic_arguments: "scheme?" markup_command_list_arguments MUSIC_IDENTIFIER  */
#line 4130 "parser.yy"
                                                                    {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-1], yyvsp[-2]);
	}
#line 8376 "./out/parser.cc"
    break;

  case 587: /* markup_command_basic_arguments: "scheme?" markup_command_list_arguments STRING  */
#line 4133 "parser.yy"
                                                          {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-1], yyvsp[-2]);
	}
#line 8384 "./out/parser.cc"
    break;

  case 588: /* markup_command_basic_arguments: EXPECT_NO_MORE_ARGS  */
#line 4136 "parser.yy"
                              {
		yyval = SCM_EOL;
	}
#line 8392 "./out/parser.cc"
    break;

  case 589: /* markup_command_list_arguments: markup_command_basic_arguments  */
#line 4142 "parser.yy"
                                       { yyval = yyvsp[0]; }
#line 8398 "./out/parser.cc"
    break;

  case 590: /* markup_command_list_arguments: "markup?" markup_command_list_arguments markup  */
#line 4143 "parser.yy"
                                                             {
	  yyval = scm_cons (yyvsp[0], yyvsp[-1]);
	}
#line 8406 "./out/parser.cc"
    break;

  case 591: /* markup_partial_function: MARKUP_FUNCTION markup_arglist_partial  */
#line 4150 "parser.yy"
        {
		yyval = scm_list_1 (scm_cons (yyvsp[-1], scm_reverse_x (yyvsp[0], SCM_EOL)));
	}
#line 8414 "./out/parser.cc"
    break;

  case 592: /* markup_partial_function: markup_head_1_list MARKUP_FUNCTION markup_arglist_partial  */
#line 4154 "parser.yy"
        {
		yyval = scm_cons (scm_cons (yyvsp[-1], scm_reverse_x (yyvsp[0], SCM_EOL)),
			       yyvsp[-2]);
	}
#line 8423 "./out/parser.cc"
    break;

  case 593: /* markup_arglist_partial: "markup?" markup_arglist_partial  */
#line 4162 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 8431 "./out/parser.cc"
    break;

  case 594: /* markup_arglist_partial: "scheme?" markup_arglist_partial  */
#line 4166 "parser.yy"
        {
		yyval= yyvsp[0];
	}
#line 8439 "./out/parser.cc"
    break;

  case 595: /* markup_arglist_partial: "markup?" markup_command_list_arguments  */
#line 4170 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 8447 "./out/parser.cc"
    break;

  case 596: /* markup_arglist_partial: "scheme?" markup_command_list_arguments  */
#line 4174 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 8455 "./out/parser.cc"
    break;

  case 597: /* markup_head_1_item: MARKUP_FUNCTION "markup?" markup_command_list_arguments  */
#line 4180 "parser.yy"
                                                                    {
	  yyval = scm_cons (yyvsp[-2], scm_reverse_x (yyvsp[0], SCM_EOL));
	}
#line 8463 "./out/parser.cc"
    break;

  case 598: /* markup_head_1_list: markup_head_1_item  */
#line 4186 "parser.yy"
                                {
		yyval = scm_list_1 (yyvsp[0]);
	}
#line 8471 "./out/parser.cc"
    break;

  case 599: /* markup_head_1_list: markup_head_1_list markup_head_1_item  */
#line 4189 "parser.yy"
                                                {
		yyval = scm_cons (yyvsp[0], yyvsp[-1]);
	}
#line 8479 "./out/parser.cc"
    break;

  case 602: /* simple_markup: markup_word  */
#line 4201 "parser.yy"
        {
		yyval = make_simple_markup (yyvsp[0]);
	}
#line 8487 "./out/parser.cc"
    break;

  case 604: /* $@14: %empty  */
#line 4208 "parser.yy"
              {
		parser->lexer_->push_note_state ();
	}
#line 8495 "./out/parser.cc"
    break;

  case 605: /* simple_markup_noword: "\\score" $@14 '{' score_body '}'  */
#line 4210 "parser.yy"
                             {
		Score *sc = unsmob<Score> (yyvsp[-1]);
		sc->origin ()->set_spot ((yyloc));
		if (sc->defs_.empty ()) {
			Output_def *od = get_layout (parser);
			sc->add_output_def (od);
			od->unprotect ();
		}
		yyval = scm_list_2 (Lily::score_markup, yyvsp[-1]);
		parser->lexer_->pop_state ();
	}
#line 8511 "./out/parser.cc"
    break;

  case 606: /* simple_markup_noword: MARKUP_FUNCTION markup_command_basic_arguments  */
#line 4221 "parser.yy"
                                                         {
		yyval = scm_cons (yyvsp[-1], scm_reverse_x (yyvsp[0], SCM_EOL));
	}
#line 8519 "./out/parser.cc"
    break;

  case 607: /* simple_markup_noword: markup_scm MARKUP_IDENTIFIER  */
#line 4225 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 8527 "./out/parser.cc"
    break;

  case 608: /* markup: markup_head_1_list simple_markup  */
#line 4232 "parser.yy"
        {
		yyval = scm_car (MAKE_SYNTAX (composed_markup_list,
					   (yylsp[0]), yyvsp[-1], scm_list_1 (yyvsp[0])));
	}
#line 8536 "./out/parser.cc"
    break;

  case 609: /* markup: simple_markup  */
#line 4236 "parser.yy"
                        {
		yyval = yyvsp[0];
	}
#line 8544 "./out/parser.cc"
    break;


#line 8548 "./out/parser.cc"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      {
        yypcontext_t yyctx
          = {yyssp, yytoken, &yylloc};
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == -1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *,
                             YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (yymsg)
              {
                yysyntax_error_status
                  = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
                yymsgp = yymsg;
              }
            else
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = YYENOMEM;
              }
          }
        yyerror (&yylloc, parser, retval, yymsgp);
        if (yysyntax_error_status == YYENOMEM)
          goto yyexhaustedlab;
      }
    }

  yyerror_range[1] = yylloc;
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= END_OF_FILE)
        {
          /* Return failure if at end of input.  */
          if (yychar == END_OF_FILE)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc, parser, retval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, yylsp, parser, retval);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  ++yylsp;
  YYLLOC_DEFAULT (*yylsp, yyerror_range, 2);

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if 1
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (&yylloc, parser, retval, YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturn;
#endif


/*-------------------------------------------------------.
| yyreturn -- parsing is finished, clean up and return.  |
`-------------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc, parser, retval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, yylsp, parser, retval);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
  return yyresult;
}

#line 4241 "parser.yy"


void
Lily_parser::set_yydebug (bool x)
{
	yydebug = x;
}

SCM
Lily_parser::do_yyparse ()
{
	return scm_c_with_fluid (Lily::f_parser,
				 self_scm (),
				 do_yyparse_trampoline,
				 static_cast <void *>(this));
}

SCM
Lily_parser::do_yyparse_trampoline (void *parser)
{
	SCM retval = SCM_UNDEFINED;
	yyparse (static_cast <Lily_parser *>(parser), &retval);
	return retval;
}



/*

It is a little strange to have this function in this file, but
otherwise, we have to import music classes into the lexer.

*/
int
Lily_lexer::try_special_identifiers (SCM *destination, SCM sid)
{
	if (unsmob<Book> (sid)) {
		Book *book =  unsmob<Book> (sid)->clone ();
		*destination = book->self_scm ();
		book->unprotect ();

		return BOOK_IDENTIFIER;
	} else if (scm_is_number (sid)) {
		*destination = sid;
		return NUMBER_IDENTIFIER;
	} else if (unsmob<Context_def> (sid))
	{
		*destination = unsmob<Context_def> (sid)->clone ()->unprotect ();
		return SCM_IDENTIFIER;
        } else if (unsmob<Context_mod> (sid)) {
                *destination = unsmob<Context_mod> (sid)->smobbed_copy ();
                return SCM_IDENTIFIER;
	} else if (Music *mus = unsmob<Music> (sid)) {
		mus = mus->clone ();
		*destination = mus->self_scm ();
		bool is_event = mus->is_mus_type ("post-event");
		mus->unprotect ();
		return is_event ? EVENT_IDENTIFIER : MUSIC_IDENTIFIER;
	} else if (unsmob<Pitch> (sid)) {
		*destination = unsmob<Pitch> (sid)->smobbed_copy ();
		return PITCH_IDENTIFIER;
	} else if (unsmob<Duration> (sid)) {
		*destination = unsmob<Duration> (sid)->smobbed_copy ();
		return DURATION_IDENTIFIER;
	} else if (unsmob<Output_def> (sid)) {
		*destination = unsmob<Output_def> (sid)->clone ()->unprotect ();
		return SCM_IDENTIFIER;
	} else if (unsmob<Score> (sid)) {
		*destination = unsmob<Score> (sid)->clone ()->unprotect ();
		return SCM_IDENTIFIER;
	} else if (scm_is_pair (sid)
		   && scm_is_pair (scm_car (sid))
		   && scm_is_true (Lily::key_p (scm_caar (sid)))) {
		*destination = sid;
		return LOOKUP_IDENTIFIER;
	}
	return -1;
}

// check_scheme_arg checks one argument with a given predicate for use
// in an argument list and throws a syntax error if it is unusable.
// The argument is prepended to the argument list in any case.  After
// throwing a syntax error, the argument list is terminated with #f as
// its last cdr in order to mark it as uncallable while not losing
// track of its total length.
//
// There are a few special considerations: if optional argument disp
// is given (otherwise it defaults to SCM_UNDEFINED), it will be used
// instead of arg in a prospective error message.  This is useful if
// arg is not the actual argument but rather a transformation of it.
//
// If arg itself is SCM_UNDEFINED, the predicate is considered false
// and an error message using disp is produced unconditionally.

SCM check_scheme_arg (Lily_parser *parser, Input loc,
		      SCM arg, SCM args, SCM pred, SCM disp)
{
	if (SCM_UNBNDP (arg))
		args = scm_cons (disp, args);
	else {
		args = scm_cons (arg, args);
		if (scm_is_true (scm_call_1 (pred, arg)))
			return args;
	}
	scm_set_cdr_x (scm_last_pair (args), SCM_EOL);
	MAKE_SYNTAX (argument_error, loc, scm_length (args), pred,
		     SCM_UNBNDP (disp) ? arg : disp);
	scm_set_cdr_x (scm_last_pair (args), SCM_BOOL_F);
	return args;
}

SCM loc_on_copy (Lily_parser *parser, Input loc, SCM arg)
{
	if (Music *m = unsmob<Music> (arg))
	{
		m = m->clone ();
		m->set_spot (parser->lexer_->override_input (loc));
		return m->unprotect ();
	}
	if (Book *b = unsmob<Book> (arg))
	{
		b = b->clone ();
		b->origin ()->set_spot (parser->lexer_->override_input (loc));
		return b->unprotect ();
	}
	if (Context_def *cd = unsmob<Context_def> (arg))
	{
		cd = cd->clone ();
		cd->origin ()->set_spot (parser->lexer_->override_input (loc));
		return cd->unprotect ();
	}
	if (Output_def *od = unsmob<Output_def> (arg))
	{
		od = od->clone ();
		od->input_origin_ = parser->lexer_->override_input (loc);
		return od->unprotect ();
	}
	if (Score *s = unsmob<Score> (arg))
	{
		s = s->clone ();
		s->origin ()->set_spot (parser->lexer_->override_input (loc));
		return s->unprotect ();
	}
	if (Context_mod *cm = unsmob<Context_mod> (arg))
	{
		return cm->smobbed_copy ();
	}
	return arg;
}

SCM
make_reverse_key_list (SCM keys)
{
	if (scm_is_true (Lily::key_p (keys)))
		return scm_list_1 (keys);
	if (scm_is_string (keys))
		return scm_list_1 (scm_string_to_symbol (keys));
	if (!ly_is_list (keys))
		return SCM_UNDEFINED;
	SCM res = SCM_EOL;
	for (; scm_is_pair (keys); keys = scm_cdr (keys))
	{
		SCM elt = scm_car (keys);
		if (scm_is_true (Lily::key_p (elt)))
			res = scm_cons (elt, res);
		else if (scm_is_string (elt))
			res = scm_cons (scm_string_to_symbol (elt), res);
		else return SCM_UNDEFINED;
	}
	return res;
}

SCM
try_string_variants (SCM pred, SCM str)
{
	// a matching predicate is always ok
	if (scm_is_true (scm_call_1 (pred, str)))
		return str;
	// a key may be interpreted as a list of keys if it helps
	if (scm_is_true (Lily::key_p (str))) {
		str = scm_list_1 (str);
		if (scm_is_true (scm_call_1 (pred, str)))
			return str;
		return SCM_UNDEFINED;
	}

	if (!scm_is_string (str))
		return SCM_UNDEFINED;

	// Let's attempt the symbol list interpretation first.

	str = scm_string_to_symbol (str);

	SCM lst = scm_list_1 (str);

	if (scm_is_true (scm_call_1 (pred, lst)))
		return lst;

	// Try the single symbol interpretation

	if (scm_is_true (scm_call_1 (pred, str)))
		return str;

	return SCM_UNDEFINED;
}

SCM
try_word_variants (SCM pred, SCM str)
{
	// str is always a string when we come here

	if (scm_is_true (scm_call_1 (pred, str)))
		return str;

	// If this cannot be a string representation of a symbol list,
	// we are through.

	if (!is_regular_identifier (str, true))
		return SCM_UNDEFINED;

	str = scm_string_split (str, SCM_MAKE_CHAR ('.'));
	for (SCM &p : as_ly_scm_list (str))
		p = scm_string_split (p, SCM_MAKE_CHAR (','));
	str = scm_append_x (str);
	for (SCM &p : as_ly_scm_list (str))
		p = scm_string_to_symbol (p);

	// Let's attempt the symbol list interpretation first.

	if (scm_is_true (scm_call_1 (pred, str)))
		return str;

	// If there is just one symbol in the list, we might interpret
	// it as a single symbol

	if (scm_is_null (scm_cdr (str)))
	{
		str = scm_car (str);
		if (scm_is_true (scm_call_1 (pred, str)))
			return str;
	}

	return SCM_UNDEFINED;
}

bool
is_regular_identifier (SCM id, bool multiple)
{
  if (!scm_is_string (id))
	  return false;

  string str = ly_scm2string (id);

  bool middle = false;

  for (string::iterator it=str.begin(); it != str.end (); it++)
  {
	  int c = *it & 0xff;
	  if ((c >= 'a' && c <= 'z')
	      || (c >= 'A' && c <= 'Z')
	      || c > 0x7f)
		  middle = true;
	  else if (middle && (c == '-' || c == '_' || (multiple &&
						       (c == '.' || c == ','))))
		  middle = false;
	  else
		  return false;
  }
  return middle;
}

SCM
make_music_from_simple (Lily_parser *parser, Input loc, SCM simple)
{
	if (unsmob<Music> (simple))
		return simple;

	if (scm_is_symbol (simple))
	{
		SCM out = SCM_UNDEFINED;
		switch (parser->lexer_->scan_word (out, simple))
		{
		case DRUM_PITCH:
		{
			Music *n = MY_MAKE_MUSIC ("NoteEvent", loc);
			set_property (n, "duration", parser->default_duration_.smobbed_copy ());
			set_property (n, "drum-type", out);
			return n->unprotect ();
		}
		case NOTENAME_PITCH:
		case TONICNAME_PITCH:
			// Take the parsed pitch
			simple = out;
			break;
		// Don't scan CHORD_MODIFIER etc.
		}
	}

	if (parser->lexer_->is_note_state ()) {
		if (unsmob<Pitch> (simple)) {
			Music *n = MY_MAKE_MUSIC ("NoteEvent", loc);
			set_property (n, "duration", parser->default_duration_.smobbed_copy ());
			set_property (n, "pitch", simple);
			return n->unprotect ();
		}
		SCM d = simple;
		if (scm_is_integer (simple))
			d = make_duration (simple);
		if (unsmob<Duration> (d)) {
			Music *n = MY_MAKE_MUSIC ("NoteEvent", loc);
			set_property (n, "duration", d);
			return n->unprotect ();
		}
		return simple;
	} else if (parser->lexer_->is_lyric_state ()) {
		if (Text_interface::is_markup (simple))
			return MAKE_SYNTAX (lyric_event, loc, simple,
					    parser->default_duration_.smobbed_copy ());
	} else if (parser->lexer_->is_chord_state ()) {
		if (unsmob<Pitch> (simple))
			return MAKE_SYNTAX
				(event_chord,
				 loc,
				 make_chord_elements (loc, simple,
						      parser->default_duration_.smobbed_copy (),
						      SCM_EOL));
	}
	return simple;
}

Music *
make_music_with_input (SCM name, Input where)
{
       Music *m = make_music_by_name (name);
       m->set_spot (where);
       return m;
}

SCM
make_simple_markup (SCM a)
{
	return a;
}

SCM
make_duration (SCM d, int dots, SCM factor)
{
	Duration k;

	if (Duration *dur = unsmob<Duration> (d)) {
		if (!dots && SCM_UNBNDP (factor))
			return d;
		k = *dur;
		if (dots)
			k = Duration (k.duration_log (), k.dot_count () + dots)
				.compressed (k.factor ());
	} else {
		int t = scm_to_int (d);
		if (t > 0 && (t & (t-1)) == 0)
			k = Duration (intlog2 (t), dots);
		else
			return SCM_UNDEFINED;
	}

	if (!SCM_UNBNDP (factor))
		k = k.compressed (from_scm<Rational> (factor));

	return k.smobbed_copy ();
}

SCM
make_chord_step (SCM step_scm, Rational alter)
{
	Pitch m (0, scm_to_int (step_scm) - 1, alter);

	// Notename/octave are normalized
	if (m.get_notename () == 6)
		m = m.transposed (Pitch (0, 0, FLAT_ALTERATION));

	return m.smobbed_copy ();
}


SCM
make_chord_elements (Input loc, SCM pitch, SCM dur, SCM modification_list)
{
	SCM res = Lily::construct_chord_elements (pitch, dur, modification_list);
	for (SCM s = res; scm_is_pair (s); s = scm_cdr (s))
	{
		unsmob<Music> (scm_car (s))->set_spot (loc);
	}
	return res;
}

// Return true if there are post events unaccounted for
bool
add_post_events (Music *m, SCM events)
{
	if (!scm_is_pair (events))
		return false;	// successfully added -- nothing

	while (m) {
		if (m->is_mus_type ("rhythmic-event")) {
			set_property
				(m, "articulations",
				 scm_append_x (scm_list_2
					       (get_property (m, "articulations"),
						events)));
			return false;
		}
		if (m->is_mus_type ("event-chord")) {
			set_property
				(m, "elements",
				 scm_append_x (scm_list_2
					       (get_property (m, "elements"),
						events)));
			return false;
		}
		if (m->is_mus_type ("sequential-music")) {
			SCM lp = scm_last_pair (get_property (m, "elements"));
			if (scm_is_pair (lp)) {
				m = unsmob<Music> (scm_car (lp));
				continue;
			}
			return true;
		}
		if (m->is_mus_type ("music-wrapper-music")
		    || m->is_mus_type ("time-scaled-music")) {
			m = unsmob<Music> (get_property (m, "element"));
			continue;
		}
		break;
	}
	return true;
}

// Returns either a list or a post-event
//
// If PRESERVE is true, unattachable post-events are not thrown away
// but rather added attached to empty chords.  If COMPRESS is true, a
// sequence consisting only of post-events may be returned as a single
// post-event.
SCM reverse_music_list (Lily_parser *parser, Input loc, SCM lst, bool preserve, bool compress)
{
	SCM res = SCM_EOL;	// Resulting reversed list
	SCM bad = SCM_EOL;	// Bad post events
	SCM post = SCM_EOL;	// current unattached events
	for (; scm_is_pair (lst); lst = scm_cdr (lst)) {
		SCM elt = scm_car (lst);
		Music *m = unsmob<Music> (elt);
		assert (m);
		if (m->is_mus_type ("post-event")) {
			post = post_event_cons (elt, post);
			continue;
		}
		if (add_post_events (m, post)) {
			bad = scm_cons (scm_car (post), bad);
			if (preserve) {
				Music *p = unsmob<Music> (scm_car (post));
				res = scm_cons (MAKE_SYNTAX (event_chord,
							     *p->origin (),
							     post),
						res);
			}
		}
		post = SCM_EOL;
		res = scm_cons (elt, res);
	}
	if (scm_is_pair (post)) {
		if (scm_is_null (res) && compress) { // pure postevent list
			if (scm_is_null (scm_cdr (post)))
				return scm_car (post);
			Music *m = MY_MAKE_MUSIC ("PostEvents", loc);
			set_property (m, "elements", post);
			return m->unprotect ();
		}
		bad = ly_append2 (post, bad);
		if (preserve) {
			Music *p = unsmob<Music> (scm_car (post));
			res = scm_cons (MAKE_SYNTAX (event_chord,
						     *p->origin (),
						     post),
					res);
		}
	}
	for (; scm_is_pair (bad); bad = scm_cdr (bad))
	{
		Music *what = unsmob<Music> (scm_car (bad));
		if (preserve)
			what->warning (_f ("Unattached %s", what->name ()));
		else
			what->warning (_f ("Dropping unattachable %s", what->name ()));
	}
	return res;
}

SCM post_event_cons (SCM post_event, SCM tail)
{
	Music *ev = unsmob<Music> (post_event);
	if (!ev)
		return tail;
	if (!ev->is_mus_type ("post-event-wrapper"))
		return scm_cons (post_event, tail);
	SCM elts = SCM_UNDEFINED;
	SCM props = SCM_EOL;
	SCM tweaks = SCM_UNDEFINED;
	for (SCM p = ev->get_property_alist (true);
	     scm_is_pair (p);
	     p = scm_cdr (p))
	{
		SCM pair = scm_car (p);
		SCM sym = scm_car (pair);
		if (scm_is_eq (sym, ly_symbol2scm ("origin")))
			continue;
		else if (scm_is_eq (sym, ly_symbol2scm ("elements"))
			 && SCM_UNBNDP (elts))
			elts = scm_cdr (pair);
		else if (scm_is_eq (sym, ly_symbol2scm ("tweaks"))
			 && SCM_UNBNDP (tweaks))
			tweaks = scm_cdr (pair);
		else
			props = scm_cons (pair, props);
	}
	if (!scm_is_pair (elts))
		return tail;
	elts = scm_reverse_x (elts, SCM_EOL);
	for (SCM p = elts; scm_is_pair (p); p = scm_cdr (p))
	{
		Music *ev = unsmob<Music> (scm_car (p));
		// tweaks are always collected in-order, newer tweaks
		// nearer to the front of the list
		if (scm_is_pair (tweaks))
			set_property (ev,
			              "tweaks",
			              Srfi_1::append_reverse (tweaks,
				                              get_property (ev, "tweaks")));
		// other properties are applied last to first so that
		// in case of duplicate properties, the actually
		// current one survives
		for (SCM q = props; scm_is_pair (q); q = scm_cdr (q))
			set_property (ev, scm_caar (q), scm_cdar (q));
	}
	return ly_append2 (elts, tail);
}

int
yylex (YYSTYPE *s, YYLTYPE *loc, Lily_parser *parser)
{
	Lily_lexer *lex = parser->lexer_;

	lex->lexval_ = s;
	lex->lexloc_ = loc;
	int tok = lex->pop_extra_token ();
	if (tok >= 0)
		return tok;
	lex->prepare_for_next_token ();
	return lex->yylex ();
}
